import { KernelGettings } from '../../kernel/core/config/gettings';
import { KernelSettings } from '../../kernel/core/config/settings';
import { KernelOptions } from '../../kernel/system/settings';
declare global {
    interface MLYSDK {
        config: {
            data: {
                mode: string;
                org_id: string;
                stream_id: string;
                stream_type: string;
                client_id: string;
                client_key: string;
                mux_env_key: string;
                platform: {
                    platforms: {
                        id: string;
                        provider_id: string;
                        platform_type: string;
                        name: string;
                        host: string;
                        enable: boolean;
                        score: number;
                    }[];
                };
                assets: Record<string, {
                    id: string;
                    tags: string[];
                }>;
            };
        };
    }
}
declare class DriverConfigurator {
    protected readonly _options?: import("type-fest/source/partial-deep").PartialObjectDeep<KernelSettings, {}> | undefined;
    protected constructor(_options?: import("type-fest/source/partial-deep").PartialObjectDeep<KernelSettings, {}> | undefined);
    config(): void;
    protected _configKernel(): void;
    static config(options?: DriverOptions): void;
}
type DriverOptions = KernelOptions;
type DriverGettings = KernelGettings;
type DriverSettings = KernelSettings;
export { DriverConfigurator, DriverOptions, DriverGettings, DriverSettings };
