type MessagePayload = {
    action: string;
    header: MessageHeader;
    content?: unknown;
    options?: unknown;
};
type MessageHeader = {
    correlation_id?: string;
    source_client_id?: string;
};
type RequestPayload = MessagePayload & {
    header: RequestHeader;
};
type RequestHeader = MessageHeader & {
    correlation_id: string;
};
type ResponsePayload = MessagePayload & {
    header: ResponseHeader;
};
type ResponseHeader = MessageHeader & {
    correlation_id: string;
    response_code: number;
    response_status: boolean;
    response_message: string;
};
type BypassFetchRequest = RequestPayload & {
    content: {
        uri: string;
    };
};
type BypassFetchResponse = ResponsePayload & {
    content: {
        uri: string;
        type: string;
        buffer: ArrayBuffer;
    };
};
export { MessagePayload, MessageHeader, RequestPayload, RequestHeader, ResponsePayload, ResponseHeader, BypassFetchRequest, BypassFetchResponse };
