import { Nullable } from '@mlytics/core-ts/core/type/basic';
import { Timeouter } from '@mlytics/core-ts/core/util/watch';
import { Resource } from '../../../../kernel/core/model/service/resource';
import type { Loader, LoaderCallbacks, LoaderConfiguration, LoaderContext, LoaderResponse, LoaderStats } from '../../../../module/lib/hls';
import { DriverExtensionMixin } from '../../../essential/module/mixin';
import { HLSLoaderProxy } from './proxy';
declare global {
    interface MLYSpecDriverExtensions {
        HLSLoader: typeof HLSLoader;
    }
}
declare class HLSLoader extends DriverExtensionMixin implements Loader<LoaderContext> {
    static readonly MIN_QUALITY_LEVEL = 0;
    static _isPublic: boolean;
    static _publicName: string;
    protected _proxy: HLSLoaderProxy;
    protected _stats: LoaderStats;
    protected _context: LoaderContext;
    protected _config: LoaderConfiguration;
    protected _callbacks: LoaderCallbacks<LoaderContext>;
    protected _resource?: Nullable<Resource>;
    protected _qualityLevel?: Nullable<number>;
    protected _timeouter: Timeouter;
    protected _isDestroyed: boolean;
    constructor();
    get stats(): LoaderStats;
    get context(): LoaderContext;
    load(context: LoaderContext, config: LoaderConfiguration, callbacks: LoaderCallbacks<LoaderContext>): Promise<void>;
    protected _load(): Promise<void>;
    protected _setupStates(): Promise<void>;
    protected _setQualityLevel(): Promise<void>;
    protected _applySystem(): Promise<void>;
    protected _applySource(): Promise<void>;
    protected _fetchContent(): Promise<void>;
    protected _fetchResource(): Promise<void>;
    protected _updateStats(): void;
    protected _replyResource(): void;
    protected _makeStats(): LoaderStats;
    protected _makeResponse(): LoaderResponse;
    protected _makeException(error: Error): Exception;
    abort(): Promise<void>;
    destroy(): Promise<void>;
    protected _abort(): Promise<void>;
}
type Exception = {
    code: number;
    text: string;
};
export { HLSLoader };
