import { Nullable } from '@mlytics/core-ts/core/type/basic';
import { DriverExtensionMixin } from '../../../../essential/module/mixin';
declare global {
    interface MLYSpecDriverExtensions {
        HLSSWClientOwner: typeof HLSSWClientOwner;
    }
}
declare class HLSSWClient extends DriverExtensionMixin {
    protected _isActive: boolean;
    protected _isProxiable: boolean;
    get isActive(): boolean;
    get isProxiable(): boolean;
    set isProxiable(value: boolean);
    start(): void;
    protected _start(): void;
    protected get _scriptPath(): Nullable<string>;
    protected get _scriptScope(): Nullable<string>;
    protected _setupWorker(): void;
    protected _bindEvents(): void;
    protected _onMessage(event: MessageEvent): Promise<void>;
    protected _onMessageError(event: MessageEvent): Promise<void>;
}
declare class HLSSWClientOwner extends DriverExtensionMixin {
    static _isPublic: boolean;
    static _publicName: string;
    protected static _client: Nullable<HLSSWClient>;
    static create(): HLSSWClient;
}
export { HLSSWClient, HLSSWClientOwner };
