/// <reference types="gtag.js" />
import { Nullable } from '@mlytics/core-ts/core/type/basic';
declare global {
    interface Window {
        gtag: typeof gtag;
    }
}
declare class GtagUtility {
    protected readonly _targetID: string;
    static readonly FETCH_DATA_TIMEOUT = 3;
    protected _data?: Nullable<GtagData>;
    protected constructor(_targetID: string);
    fetchData(): Promise<Nullable<GtagData>>;
    protected _fetchData(): Promise<void>;
    protected _fetchValue<Value extends GtagValue>(field: GtagField): Promise<Value>;
    protected _fetchClientID(): Promise<string>;
    protected _fetchSessionID(): Promise<string>;
    static fetchData(targetID: string): Promise<Nullable<GtagData>>;
}
type GtagData = {
    clientID: string;
    sessionID: string;
};
type GtagField = string | Gtag.FieldNames;
type GtagValue = Nullable<string | Gtag.CustomParams>;
export { GtagUtility, GtagData };
