import { Nullable, ObjectLike } from '@mlytics/core-ts/core/type/basic';
import { DriverExtensionMixin } from '../../../../../../essential/module/mixin';
import { MuxMonitorCustomData, MuxMonitorOptions } from '../../../addon/mux/monitor';
declare abstract class AbstractPlayerPlugin extends DriverExtensionMixin {
    static _setup(): void;
    static create(...args: unknown[]): SpecPlayerAdapter;
}
interface SpecPlayerAdapter {
    player: unknown;
    protocol: unknown;
}
declare abstract class AbstractPlayerAdapter extends DriverExtensionMixin implements SpecPlayerAdapter {
    protected _url: string;
    protected _element: HTMLMediaElement;
    protected _playerName: string;
    protected _playerOptions: unknown;
    protected _adapterOptions: PlayerAdapterOptions;
    protected _driverError?: Nullable<Error>;
    protected _customData: MuxMonitorCustomData;
    get element(): HTMLMediaElement;
    abstract get player(): unknown;
    abstract get protocol(): unknown;
    protected abstract _initialize(): void;
    protected abstract _mergeOptions(): void;
    protected abstract _buildPlayer(): void;
    protected get _shouldMonitor(): boolean;
    protected get _isMuxAllowed(): boolean;
    protected get _isMuxEnabled(): boolean;
    protected get _gtagTargetID(): Nullable<string>;
    protected _setupMonitor(): void;
    protected _embedMonitor(): void;
    protected _embedMux(): void;
    protected _bindMuxElement(): void;
    protected abstract _bindMuxProtocol(): void;
    protected _makeMuxMonitorData(): ObjectLike;
    protected _makeMuxMonitorOptions(): MuxMonitorOptions;
}
type PlayerAdapterOptions = {
    isLoaderAllowed: boolean;
    isMonitorAllowed: boolean;
};
export { AbstractPlayerPlugin, SpecPlayerAdapter, AbstractPlayerAdapter, PlayerAdapterOptions };
