import { Nullable } from '@mlytics/core-ts/core/type/basic';
import { Hls } from '../../../../../../../module/lib/hls';
import { HLSSWClient } from '../../../../../../integration/streaming/hls/swproxy/client';
import { AbstractPlayerAdapter, AbstractPlayerPlugin, PlayerAdapterOptions, SpecPlayerAdapter } from '../../base/player/plugin';
declare abstract class AbstractHlsPlayerPlugin extends AbstractPlayerPlugin {
    static create(...args: unknown[]): SpecHlsPlayerAdapter;
}
interface SpecHlsPlayerAdapter extends SpecPlayerAdapter {
    protocol: Nullable<Hls>;
}
declare abstract class AbstractHlsPlayerAdapter extends AbstractPlayerAdapter implements SpecHlsPlayerAdapter {
    protected _swclient?: Nullable<HLSSWClient>;
    protected _isHlsjsAvailable: boolean;
    get protocol(): Nullable<Hls>;
    protected abstract get _protocol(): Nullable<Hls>;
    protected _embedMonitor(): void;
    protected _bindMuxProtocol(): void;
}
type HlsPlayerAdapterOptions = PlayerAdapterOptions;
export { AbstractHlsPlayerPlugin, SpecHlsPlayerAdapter, AbstractHlsPlayerAdapter, HlsPlayerAdapterOptions };
