import { PartialDeep } from '@mlytics/core-ts/core/type/basic';
import { IDElement } from '../../../../base/model/plugin';
import { AbstractHlsPlayerPlugin, SpecHlsPlayerAdapter } from '../../../../base/streaming/hls/player/plugin';
import { Videojs7HlsAdapterOptions, Videojs7HlsPlayerOptions } from '../../../videojs7/streaming/hls/player/adapter';
import { Videojs8HlsAdapterOptions, Videojs8HlsPlayerOptions } from '../../../videojs8/streaming/hls/player/adapter';
declare global {
    interface MLYSpecDriverExtensions {
        VideojsHlsPlayerPlugin: typeof VideojsHlsPlayerPlugin;
    }
}
declare const VideojsHlsPlayerPlugin_base: typeof AbstractHlsPlayerPlugin & import("../../../base/module/mixin").SpecVideojsExtensionAbstractMixin;
declare class VideojsHlsPlayerPlugin extends VideojsHlsPlayerPlugin_base {
    static _isPublic: boolean;
    static _publicName: string;
    protected static _isVideojs7(): boolean;
    static _setup(): void;
    static create(id: IDElement, playerOptions: VideojsHlsPlayerOptions, adapterOptions?: PartialDeep<VideojsHlsAdapterOptions>): SpecHlsPlayerAdapter;
}
type VideojsHlsPlayerOptions = Videojs7HlsPlayerOptions | Videojs8HlsPlayerOptions;
type VideojsHlsAdapterOptions = Videojs7HlsAdapterOptions | Videojs8HlsAdapterOptions;
export { VideojsHlsPlayerPlugin };
