import Hls from 'hls.js';
import { Nullable, PartialDeep } from '@mlytics/core-ts/core/type/basic';
import { IDElement } from '../../../../../base/model/plugin';
import { AbstractHlsPlayerAdapter, HlsPlayerAdapterOptions } from '../../../../../base/streaming/hls/player/plugin';
import { Videojs7Options, Videojs7Player } from '../../../base/module/player';
import { VideojsHlsTech } from '../source/plugin';
declare const Videojs7HlsPlayerAdapter_base: typeof AbstractHlsPlayerAdapter & import("../../../../base/module/mixin").SpecVideojsExtensionAbstractMixin;
declare class Videojs7HlsPlayerAdapter extends Videojs7HlsPlayerAdapter_base {
    protected _id: IDElement;
    protected _options: Videojs7HlsPlayerAdapterOptions;
    protected _player: Videojs7HlsPlayer;
    protected _playerName: string;
    protected _playerOptions: Videojs7HlsPlayerOptions;
    protected _adapterOptions: Videojs7HlsAdapterOptions;
    constructor(options: Videojs7HlsPlayerAdapterOptions);
    get player(): Videojs7HlsPlayer;
    protected get _protocol(): Nullable<Hls>;
    protected _initialize(): void;
    protected _mergeOptions(): void;
    protected _mergePlayer(): void;
    protected _mergeAdapter(): void;
    protected _mergeHLSConfig(): void;
    protected _mergeLiveTracker(): void;
    protected _buildPlayer(): void;
    protected _setupHandler(): void;
    protected _setupSWProxy(): void;
}
type Videojs7HlsPlayer = Videojs7Player & {
    tech_: VideojsHlsTech;
};
type Videojs7HlsPlayerAdapterOptions = {
    id: IDElement;
    playerOptions: Videojs7HlsPlayerOptions;
    adapterOptions?: PartialDeep<Videojs7HlsAdapterOptions>;
};
type Videojs7HlsPlayerOptions = Videojs7Options;
type Videojs7HlsAdapterOptions = HlsPlayerAdapterOptions;
export { Videojs7HlsPlayerAdapter, Videojs7HlsPlayerOptions, Videojs7HlsAdapterOptions };
