import { QualityLevelList } from 'videojs-contrib-quality-levels';
import { ManifestParsedData } from '../../../../../../../../module/lib/hls';
import { AbstractQualityController, QualityControllerOptions } from '../../../../../base/streaming/hls/source/quality';
declare class Videojs7QualityController extends AbstractQualityController {
    protected _qualityLevels: QualityLevelList;
    protected _qualityCandidates: QualityCandidate[];
    constructor(options: Videojs7QualityControllerOptions);
    build(data: ManifestParsedData): void;
    protected _buildQualityLevels(data: ManifestParsedData): void;
    protected _collectQualityCandidate(candidate: QualityCandidate): void;
    protected _updateHlsQualityLevel(): void;
    destroy(): void;
}
type Videojs7QualityControllerOptions = QualityControllerOptions & {
    qualityLevels: QualityLevelList;
};
type QualityCandidate = {
    index: number;
    isEnabled: boolean;
};
export { Videojs7QualityController };
