import type videojs from 'video.js';
import type Player from 'video.js/dist/types/player';
import type Tech from 'video.js/dist/types/tech/tech';
import type { SourceObject } from 'video.js/dist/types/tech/tech';
import { ObjectLike, Voidable } from '@mlytics/core-ts/core/type/basic';
type Videojs8 = typeof videojs & {
    VERSION: string;
};
type Videojs8Player = Player;
type Videojs8Source = SourceObject;
type Videojs8Tech = Tech;
type Videojs8Options = {
    sources?: Voidable<SourceObject>;
    html5?: Voidable<ObjectLike>;
    liveTracker?: {
        liveTolerance?: Voidable<number>;
    };
};
type Videojs8Component = {
    el_: HTMLElement;
};
export { videojs, Videojs8, Videojs8Player, Videojs8Source, Videojs8Tech, Videojs8Options, Videojs8Component };
