import Hls from 'hls.js';
import { Nullable, PartialDeep } from '@mlytics/core-ts/core/type/basic';
import { IDElement } from '../../../../../base/model/plugin';
import { AbstractHlsPlayerAdapter, HlsPlayerAdapterOptions } from '../../../../../base/streaming/hls/player/plugin';
import { Videojs8Options, Videojs8Player } from '../../../base/module/player';
import { Videojs8HlsTech } from '../source/plugin';
declare const Videojs8HlsPlayerAdapter_base: typeof AbstractHlsPlayerAdapter & import("../../../../base/module/mixin").SpecVideojsExtensionAbstractMixin;
declare class Videojs8HlsPlayerAdapter extends Videojs8HlsPlayerAdapter_base {
    protected _id: IDElement;
    protected _options: Videojs8HlsPlayerAdapterOptions;
    protected _player: Videojs8HlsPlayer;
    protected _playerName: string;
    protected _playerOptions: Videojs8HlsPlayerOptions;
    protected _adapterOptions: Videojs8HlsAdapterOptions;
    constructor(options: Videojs8HlsPlayerAdapterOptions);
    get player(): Videojs8HlsPlayer;
    protected get _protocol(): Nullable<Hls>;
    protected _initialize(): void;
    protected _mergeOptions(): void;
    protected _mergePlayer(): void;
    protected _mergeAdapter(): void;
    protected _mergeHLSConfig(): void;
    protected _mergeLiveTracker(): void;
    protected _buildPlayer(): void;
    protected _setupHandler(): void;
    protected _setupSWProxy(): void;
}
type Videojs8HlsPlayer = Videojs8Player & {
    tech_: Videojs8HlsTech;
};
type Videojs8HlsPlayerAdapterOptions = {
    id: IDElement;
    playerOptions: Videojs8HlsPlayerOptions;
    adapterOptions?: PartialDeep<Videojs8HlsAdapterOptions>;
};
type Videojs8HlsPlayerOptions = Videojs8Options;
type Videojs8HlsAdapterOptions = HlsPlayerAdapterOptions;
export { Videojs8HlsPlayerAdapter, Videojs8HlsPlayerOptions, Videojs8HlsAdapterOptions };
