import { Nullable } from '@mlytics/core-ts/core/type/basic';
import { Payload, Requester, RequesterOptions } from '@mlytics/core-ts/utility/requester';
import { MeteringAPICreateCDNDownloadAggregationData, MeteringAPICreateP2PDownloadAggregationData } from '../model/server';
declare class API {
    protected static _host?: Nullable<HostRequester>;
    protected static _token?: Nullable<TokenRequester>;
    protected static _metering?: Nullable<MeteringRequester>;
    static get host(): HostRequester;
    static set host(value: Nullable<HostRequester>);
    static get token(): TokenRequester;
    static set token(value: Nullable<TokenRequester>);
    static get metering(): MeteringRequester;
    static set metering(value: Nullable<MeteringRequester>);
}
declare class HostRequester extends Requester {
    constructor(options?: RequesterOptions);
    readHosts(): Promise<Payload>;
}
declare class TokenRequester extends Requester {
    constructor(options?: RequesterOptions);
    readToken(options: TokenRequesterReadTokenOptions): Promise<Payload>;
    renewToken(options: TokenRequesterRenewTokenOptions): Promise<Payload>;
}
type TokenRequesterReadTokenOptions = {
    clientID: string;
    origin: Nullable<string>;
    nonce: number;
    signature: string;
};
type TokenRequesterRenewTokenOptions = {
    clientID: string;
    origin: Nullable<string>;
    nonce: number;
    signature: string;
    token: string;
};
declare class MeteringRequester extends Requester {
    constructor(options?: RequesterOptions);
    createCDNDownloadAggregation(options: MeteringRequesterCreateCDNDownloadAggregationOptions): Promise<void>;
    createP2PDownloadAggregation(options: MeteringRequesterCreateP2PDownloadAggregationOptions): Promise<void>;
}
type MeteringRequesterCreateCDNDownloadAggregationOptions = {
    data: MeteringAPICreateCDNDownloadAggregationData;
};
type MeteringRequesterCreateP2PDownloadAggregationOptions = {
    data: MeteringAPICreateP2PDownloadAggregationData;
};
export { API, HostRequester, TokenRequester, MeteringRequester };
