import { BufferLike } from '@mlytics/core-ts/core/type/basic';
import { AbstractFlow } from '@mlytics/core-ts/utility/flow';
declare class HostAPIReadHostsHandler extends AbstractFlow<void, HostAPIReadHostsOutcome> {
    process(): Promise<HostAPIReadHostsOutcome>;
    protected _intakeResult(): Promise<void>;
    protected _intakeOutcome(): Promise<void>;
    static process(): Promise<HostAPIReadHostsOutcome>;
}
type HostAPIReadHostsOutcome = {
    token: string;
    metering: string;
    tracker: string[];
};
declare class TokenAPIReadTokenHandler extends AbstractFlow<void, TokenAPIReadTokenOutcome> {
    process(): Promise<TokenAPIReadTokenOutcome>;
    protected _intakeNonce(): Promise<void>;
    protected _intakeSignature(): Promise<void>;
    protected _makeBase16Hash(value: BufferLike): string;
    protected _makeBase64URLHash(value: BufferLike): string;
    protected _intakeResult(): Promise<void>;
    protected _intakeOutcome(): Promise<void>;
    static process(): Promise<TokenAPIReadTokenOutcome>;
}
type TokenAPIReadTokenOutcome = {
    token: string;
    peerID: string;
};
declare class TokenAPIRenewTokenHandler extends TokenAPIReadTokenHandler {
    protected _intakeResult(): Promise<void>;
    static process(): Promise<TokenAPIRenewTokenOutcome>;
}
type TokenAPIRenewTokenOutcome = TokenAPIReadTokenOutcome;
declare class MeteringAPICreateCDNDownloadAggregationHandler extends AbstractFlow<MeteringAPICreateCDNDownloadAggregationContent> {
    process(): Promise<void>;
    protected _intakeData(): Promise<void>;
    protected _forwardData(): Promise<void>;
    static process(options: MeteringAPICreateCDNDownloadAggregationOptions): Promise<void>;
}
type MeteringAPICreateCDNDownloadAggregationContent = {
    reports: {
        time: number;
        platformID: string;
        platformType: string;
        successCount: number;
        failureCount: number;
        transferSize: number;
        bandwidth: number;
    }[];
};
type MeteringAPICreateCDNDownloadAggregationOptions = MeteringAPICreateCDNDownloadAggregationContent;
declare class MeteringAPICreateP2PDownloadAggregationHandler extends AbstractFlow<MeteringAPICreateP2PDownloadAggregationContent> {
    process(): Promise<void>;
    protected _intakeData(): Promise<void>;
    protected _forwardData(): Promise<void>;
    static process(options: MeteringAPICreateP2PDownloadAggregationOptions): Promise<void>;
}
type MeteringAPICreateP2PDownloadAggregationContent = {
    reports: {
        time: number;
        targetPeerID: string;
        targetPeerType: string;
        successCount: number;
        failureCount: number;
        transferSize: number;
    }[];
};
type MeteringAPICreateP2PDownloadAggregationOptions = MeteringAPICreateP2PDownloadAggregationContent;
export { HostAPIReadHostsHandler, HostAPIReadHostsOutcome, TokenAPIReadTokenHandler, TokenAPIReadTokenOutcome, TokenAPIRenewTokenHandler, TokenAPIRenewTokenOutcome, MeteringAPICreateCDNDownloadAggregationHandler, MeteringAPICreateCDNDownloadAggregationOptions, MeteringAPICreateP2PDownloadAggregationHandler, MeteringAPICreateP2PDownloadAggregationOptions };
