import Emittery from 'emittery';
import { Nullable } from '@mlytics/core-ts/core/type/basic';
import { TaskManager } from '@mlytics/core-ts/core/util/future';
declare class MetricsCollector extends Emittery {
    protected _taskManager: TaskManager;
    activate(): Promise<void>;
    deactivate(): Promise<void>;
    protected _bindEvents(): Promise<void>;
    protected _buildTasks(): Promise<void>;
    protected _buildHandleHTTPDownloadPulseTrafficTask(): Promise<void>;
    protected _buildHandleHTTPDownloadCumulativeTrafficTask(): Promise<void>;
    protected _buildHandleHTTPDownloadWMABandwidthTask(): Promise<void>;
    protected _buildHandleHTTPDownloadUsagePulseCountTask(): Promise<void>;
    protected _buildHandleHTTPDownloadUsageCumulativeCountTask(): Promise<void>;
    protected _buildHandleHTTPDownloadSuccessPulseCountTask(): Promise<void>;
    protected _buildHandleHTTPDownloadSuccessCumulativeCountTask(): Promise<void>;
    protected _buildHandleHTTPDownloadFailurePulseCountTask(): Promise<void>;
    protected _buildHandleHTTPDownloadFailureCumulativeCountTask(): Promise<void>;
    protected _buildHandleCDNDownloadLastMeanBandwidthTask(): Promise<void>;
    protected _buildHandleCDNDownloadLastMeanAvailabilityTask(): Promise<void>;
    protected _buildHandleCDNDownloadLastCurrentScoreTask(): Promise<void>;
    protected _buildHandleP2PDownloadPulseTrafficTask(): Promise<void>;
    protected _buildHandleP2PDownloadCumulativeTrafficTask(): Promise<void>;
    protected _buildHandleP2PDownloadWMABandwidthTask(): Promise<void>;
    protected _buildHandleP2PDownloadUsagePulseCountTask(): Promise<void>;
    protected _buildHandleP2PDownloadUsageCumulativeCountTask(): Promise<void>;
    protected _buildHandlePruneMetricsStatsTask(): Promise<void>;
}
declare class MetricsCollectorEvent {
    static readonly HTTP_DOWNLOAD_RECORD = "http_download_record";
    static readonly CDN_CONFIG_RECORDS = "cdn_config_records";
    static readonly CDN_DOWNLOAD_RECORD = "cdn_download_record";
    static readonly P2P_DOWNLOAD_RECORD = "p2p_download_record";
    static readonly TRACKER_STATE_RECORD = "tracker_state_record";
    static readonly NODE_STATE_RECORD = "node_state_record";
    static readonly SWARM_STATE_RECORD = "swarm_state_record";
    static readonly USER_STATE_RECORD = "user_state_record";
    static readonly PURGE_CDN_RECORDS = "purge_cdn_records";
}
declare class MetricsCollectorHolder {
    protected static _instance?: Nullable<MetricsCollector>;
    static get instance(): Nullable<MetricsCollector>;
    static set instance(value: Nullable<MetricsCollector>);
    static emit(eventName: string, eventData: unknown): Promise<void>;
}
export { MetricsCollector, MetricsCollectorEvent, MetricsCollectorHolder };
