import { Nullable, ObjectLike } from '@mlytics/core-ts/core/type/basic';
import { TimeSeriesData } from './metrics';
import { HTTPDownloadRecord, P2PDownloadRecord } from './record';
type HTTPDownloadRecordExport = HTTPDownloadRecord;
type HTTPDownloadPulseTrafficExport = {
    id?: Nullable<string>;
    name?: Nullable<string>;
    type: string;
    domain?: Nullable<string>;
    isEnabled?: Nullable<boolean>;
    dataset: TimeSeriesData<number>[];
};
type HTTPDownloadCumulativeTrafficExport = {
    id?: Nullable<string>;
    name?: Nullable<string>;
    type: string;
    domain?: Nullable<string>;
    isEnabled?: Nullable<boolean>;
    dataset: TimeSeriesData<number>[];
};
type HTTPDownloadWMABandwidthExport = {
    id?: Nullable<string>;
    name?: Nullable<string>;
    type: string;
    domain?: Nullable<string>;
    isEnabled?: Nullable<boolean>;
    dataset: TimeSeriesData<number>[];
};
type HTTPDownloadUsagePulseCountExport = {
    id?: Nullable<string>;
    name?: Nullable<string>;
    type: string;
    domain?: Nullable<string>;
    isEnabled?: Nullable<boolean>;
    dataset: TimeSeriesData<number>[];
};
type HTTPDownloadUsageCumulativeCountExport = {
    id?: Nullable<string>;
    name?: Nullable<string>;
    type: string;
    domain?: Nullable<string>;
    isEnabled?: Nullable<boolean>;
    dataset: TimeSeriesData<number>[];
};
type HTTPDownloadSuccessPulseCountExport = {
    id?: Nullable<string>;
    name?: Nullable<string>;
    type: string;
    domain?: Nullable<string>;
    isEnabled?: Nullable<boolean>;
    dataset: TimeSeriesData<number>[];
};
type HTTPDownloadSuccessCumulativeCountExport = {
    id?: Nullable<string>;
    name?: Nullable<string>;
    type: string;
    domain?: Nullable<string>;
    isEnabled?: Nullable<boolean>;
    dataset: TimeSeriesData<number>[];
};
type HTTPDownloadFailurePulseCountExport = {
    id?: Nullable<string>;
    name?: Nullable<string>;
    type: string;
    domain?: Nullable<string>;
    isEnabled?: Nullable<boolean>;
    dataset: TimeSeriesData<number>[];
};
type HTTPDownloadFailureCumulativeCountExport = {
    id?: Nullable<string>;
    name?: Nullable<string>;
    type: string;
    domain?: Nullable<string>;
    isEnabled?: Nullable<boolean>;
    dataset: TimeSeriesData<number>[];
};
type CDNDownloadLastMeanBandwidthExport = {
    id?: Nullable<string>;
    name?: Nullable<string>;
    type: string;
    domain?: Nullable<string>;
    isEnabled?: Nullable<boolean>;
    dataset: TimeSeriesData<number>[];
};
type CDNDownloadLastMeanAvailabilityExport = {
    id?: Nullable<string>;
    name?: Nullable<string>;
    type: string;
    domain?: Nullable<string>;
    isEnabled?: Nullable<boolean>;
    dataset: TimeSeriesData<number>[];
};
type CDNDownloadLastCurrentScoreExport = {
    id?: Nullable<string>;
    name?: Nullable<string>;
    type: string;
    domain?: Nullable<string>;
    isEnabled?: Nullable<boolean>;
    dataset: TimeSeriesData<number>[];
};
type P2PDownloadRecordExport = P2PDownloadRecord;
type P2PDownloadPulseTrafficExport = {
    swarmID: string;
    users: {
        peerID: string;
        dataset: TimeSeriesData<number>[];
    }[];
};
type P2PDownloadCumulativeTrafficExport = {
    swarmID: string;
    users: {
        peerID: string;
        dataset: TimeSeriesData<number>[];
    }[];
};
type P2PDownloadWMABandwidthExport = {
    swarmID: string;
    users: {
        peerID: string;
        dataset: TimeSeriesData<number>[];
    }[];
};
type P2PDownloadUsagePulseCountExport = {
    swarmID: string;
    users: {
        peerID: string;
        dataset: TimeSeriesData<number>[];
    }[];
};
type P2PDownloadUsageCumulativeCountExport = {
    swarmID: string;
    users: {
        peerID: string;
        dataset: TimeSeriesData<number>[];
    }[];
};
type P2SPSystemStateExport = {
    tracker: {
        peerID: Nullable<string>;
        isAvailable: boolean;
    };
    node: {
        peerID: Nullable<string>;
        isAvailable: boolean;
    };
    swarms: ObjectLike<{
        swarmID: string;
        swarmURI: string;
        isAvailable: boolean;
        users: ObjectLike<{
            peerID: string;
            isAvailable: boolean;
        }>;
    }>;
};
export { HTTPDownloadRecordExport, HTTPDownloadPulseTrafficExport, HTTPDownloadCumulativeTrafficExport, HTTPDownloadWMABandwidthExport, HTTPDownloadUsagePulseCountExport, HTTPDownloadUsageCumulativeCountExport, HTTPDownloadSuccessPulseCountExport, HTTPDownloadSuccessCumulativeCountExport, HTTPDownloadFailurePulseCountExport, HTTPDownloadFailureCumulativeCountExport, CDNDownloadLastMeanBandwidthExport, CDNDownloadLastMeanAvailabilityExport, CDNDownloadLastCurrentScoreExport, P2PDownloadRecordExport, P2PDownloadPulseTrafficExport, P2PDownloadCumulativeTrafficExport, P2PDownloadWMABandwidthExport, P2PDownloadUsagePulseCountExport, P2PDownloadUsageCumulativeCountExport, P2SPSystemStateExport };
