import { Nullable } from '@mlytics/core-ts/core/type/basic';
import { TimeSeriesDataLike } from '../../../model/service/metrics';
type CDNConfigRecord = {
    id: string;
    name: string;
    type: string;
    domain: string;
    isEnabled: boolean;
    meanBandwidth: number;
    meanAvailability: number;
    currentScore: number;
};
type CDNDownloadRecord = TimeSeriesDataLike & {
    id: string;
    name: string;
    kind: string;
    type: string;
    domain: string;
    meanBandwidth: number;
    meanAvailability: number;
    currentScore: number;
};
type HTTPDownloadRecord = TimeSeriesDataLike & {
    id?: Nullable<string>;
    name?: Nullable<string>;
    kind: string;
    type: string;
    domain: string;
    totalSize?: Nullable<number>;
    contentType?: Nullable<string>;
    contentSize: number;
    startTime: number;
    elapsedTime?: Nullable<number>;
    bandwidth?: Nullable<number>;
    isAborted: boolean;
    isSuccess: boolean;
    isOutlier: boolean;
    isComplete: boolean;
    swarmID?: Nullable<string>;
    swarmURI?: Nullable<string>;
    sourceURI: string;
    requestURI: string;
    responseCode?: Nullable<number>;
    errorMessage?: Nullable<string>;
};
type P2PDownloadRecord = TimeSeriesDataLike & {
    peerID: string;
    peerType: string;
    totalSize?: Nullable<number>;
    contentType?: Nullable<string>;
    contentSize: number;
    startTime: number;
    elapsedTime: number;
    bandwidth?: Nullable<number>;
    isOutlier: boolean;
    isComplete: boolean;
    swarmID?: Nullable<string>;
    swarmURI?: Nullable<string>;
    sourceURI: string;
    requestURI: string;
};
type TrackerStateRecord = {
    peerID: Nullable<string>;
    isAvailable: boolean;
};
type NodeStateRecord = {
    peerID: Nullable<string>;
    isAvailable: boolean;
};
type SwarmStateRecord = {
    swarmID: string;
    swarmURI: string;
    isAvailable: boolean;
};
type UserStateRecord = {
    peerID: string;
    swarmID: string;
    isAvailable: boolean;
};
export { CDNConfigRecord, CDNDownloadRecord, HTTPDownloadRecord, P2PDownloadRecord, TrackerStateRecord, NodeStateRecord, SwarmStateRecord, UserStateRecord };
