import { Nullable } from '@mlytics/core-ts/core/type/basic';
declare class BasePool<Value> {
    protected _pool: Map<string, Value>;
    get size(): number;
    get keys(): IterableIterator<string>;
    get values(): IterableIterator<Value>;
    isRegistered(key: string): boolean;
    retrieve(key: string): Nullable<Value>;
    register(key: string, value: Value): void;
    deregister(key: string): void;
    discharge(): void;
}
export { BasePool };
