/// <reference types="node" />
import { BufferLike, Nullable } from '@mlytics/core-ts/core/type/basic';
import { SpecConstraintTimer, Timer } from '@mlytics/core-ts/core/util/watch';
import { Buffer } from '@mlytics/core-ts/native/buffer';
declare class Resource {
    protected _id: string;
    protected _swarmID?: Nullable<string>;
    protected _swarmURI?: Nullable<string>;
    protected _sourceURI?: Nullable<string>;
    protected _uri: string;
    protected _type?: Nullable<string>;
    protected _total?: Nullable<number>;
    protected _ctime: Timer;
    protected _mtime: Timer;
    protected _ptime: Timer;
    protected _content: globalThis.Buffer;
    protected _priority: number;
    protected _startDelay: number;
    protected _isShareable: boolean;
    constructor(uri: string);
    get id(): string;
    get swarmID(): Nullable<string>;
    set swarmID(value: Nullable<string>);
    get swarmURI(): Nullable<string>;
    set swarmURI(value: Nullable<string>);
    get sourceURI(): Nullable<string>;
    set sourceURI(value: Nullable<string>);
    get uri(): string;
    get type(): Nullable<string>;
    set type(value: Nullable<string>);
    get total(): Nullable<number>;
    set total(value: Nullable<number>);
    get ctime(): Timer;
    get mtime(): SpecConstraintTimer;
    get ptime(): Timer;
    set ptime(value: Timer);
    get size(): number;
    get content(): Buffer;
    get priority(): number;
    set priority(value: number);
    get startDelay(): number;
    set startDelay(value: number);
    get isShareable(): boolean;
    set isShareable(value: boolean);
    get completion(): number;
    get isComplete(): boolean;
    concat(options: ResourceConcatOptions): void;
    nextRange(): ResourceRange;
    toJSON(): unknown;
    toString(): string;
    static makeID(uri: string): string;
}
type ResourceRange = {
    start: number;
    end: number;
};
type ResourceConcatOptions = {
    chunk: BufferLike;
    range: ResourceRange;
};
type ResourceStat = {
    id: string;
    completion: number;
};
export { Resource, ResourceRange, ResourceConcatOptions, ResourceStat };
