import { Nullable } from '@mlytics/core-ts/core/type/basic';
declare class CDN {
    protected _id: string;
    protected _name: string;
    protected _kind: string;
    protected _type: string;
    protected _domain: string;
    protected _isEnabled: boolean;
    protected _meanBandwidth: number;
    protected _meanAvailability: number;
    protected _overallScore: number;
    protected _currentScore: number;
    protected _businessScore: number;
    constructor(options: CDNOptions);
    get id(): string;
    get name(): Nullable<string>;
    get kind(): string;
    get type(): string;
    get domain(): string;
    get isEnabled(): boolean;
    get meanBandwidth(): number;
    set meanBandwidth(value: number);
    get meanAvailability(): number;
    set meanAvailability(value: number);
    get overallScore(): number;
    get currentScore(): number;
    set currentScore(value: number);
    get businessScore(): number;
}
type CDNOptions = {
    id: string;
    name: string;
    kind: string;
    type: string;
    domain: string;
    isEnabled: boolean;
    businessScore: number;
};
type CDNSource = Partial<CDN> & {
    kind: string;
    type: string;
    domain: string;
};
export { CDN, CDNSource };
