import { Nullable } from '@mlytics/core-ts/core/type/basic';
import { AbortController } from '@mlytics/core-ts/native/abctrl';
import { AbstractFlow } from '@mlytics/core-ts/utility/flow';
import { Payload } from '@mlytics/core-ts/utility/requester';
import { Resource } from '../../model/service/resource';
import { CDN, CDNSource } from './model/mcdn';
declare class MCDNDownloadRecorder extends AbstractFlow<MCDNDownloadRecorderContent> {
    protected _cdn: CDN;
    process(): Promise<void>;
    protected _intakeHTTPDownloadRecord(): Promise<void>;
    protected _forwardHTTPDownloadRecord(): Promise<void>;
    protected get _shouldUpdateCDNStats(): boolean;
    protected _intakeCDNStats(): Promise<void>;
    protected _updateCDNBandwidth(): Promise<void>;
    protected _updateCDNMeanBandwidth(): Promise<void>;
    protected _updateCDNMeanAvailability(): Promise<void>;
    protected _updateCDNCurrentScore(): Promise<void>;
    protected _forwardCDNDownloadRecord(): Promise<void>;
    static process(options: MCDNDownloadRecorderOptions): Promise<void>;
}
type MCDNDownloadRecorderContent = HTTPDownloadRecordBuilderOptions;
type MCDNDownloadRecorderOptions = MCDNDownloadRecorderContent;
type HTTPDownloadRecordBuilderOptions = {
    source: CDNSource;
    resource: Resource;
    payload?: Nullable<Payload>;
    error?: Nullable<Error>;
    aborter: AbortController;
    requestURI: string;
    startSize: number;
    startTime: number;
    measurement: PerformanceResourceTiming;
};
export { MCDNDownloadRecorder };
