import { Nullable } from '@mlytics/core-ts/core/type/basic';
import { LRUCache } from '@mlytics/core-ts/core/util/cache';
import { Resource } from '../../../model/service/resource';
declare class ResourceCache {
    protected _lruCache: LRUCache<Resource>;
    constructor(prefix: string);
    set(key: string, value: Resource, ttl: number): void;
    get(key: string): Nullable<Resource>;
    peek(key: string): Nullable<Resource>;
    has(key: string): boolean;
    delete(key: string): void;
    keys(): Generator<string>;
    values(): Generator<Resource>;
    prune(): void;
    clear(): void;
}
declare class ResourceTTLSuggester {
    static give(resource: Resource): number;
}
export { ResourceCache, ResourceTTLSuggester };
