import _m0 from "protobufjs/minimal";
import { ResourceRange, ResourceStat } from "../base/resource";
import { MessageHeader, RequestHeader, ResponseHeader } from "./base";
export interface PeerObtainResourceRequest {
    action: string;
    header: RequestHeader | undefined;
    content: PeerObtainResourceRequest_RequestContent | undefined;
}
export interface PeerObtainResourceRequest_RequestContent {
    id: string;
    uri: string;
    range: ResourceRange | undefined;
}
export interface PeerObtainResourceResponse {
    action: string;
    header: ResponseHeader | undefined;
    content: PeerObtainResourceResponse_ResponseContent | undefined;
}
export interface PeerObtainResourceResponse_ResponseContent {
    id: string;
    uri: string;
    type?: string | undefined;
    total?: number | undefined;
    range: ResourceRange | undefined;
    pieces: Uint8Array;
}
export interface PeerReportResourceStatMessage {
    action: string;
    header: MessageHeader | undefined;
    content: PeerReportResourceStatMessage_MessageContent | undefined;
}
export interface PeerReportResourceStatMessage_MessageContent {
    stat: ResourceStat | undefined;
}
export interface PeerReportResourceStatsMessage {
    action: string;
    header: MessageHeader | undefined;
    content: PeerReportResourceStatsMessage_MessageContent | undefined;
}
export interface PeerReportResourceStatsMessage_MessageContent {
    stats: ResourceStat[];
}
export interface PeerReportHealthMessage {
    action: string;
    header: MessageHeader | undefined;
}
export interface PeerNotifyExceptionMessage {
    action: string;
    header: ResponseHeader | undefined;
}
export declare const PeerObtainResourceRequest: {
    encode(message: PeerObtainResourceRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PeerObtainResourceRequest;
};
export declare const PeerObtainResourceRequest_RequestContent: {
    encode(message: PeerObtainResourceRequest_RequestContent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PeerObtainResourceRequest_RequestContent;
};
export declare const PeerObtainResourceResponse: {
    encode(message: PeerObtainResourceResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PeerObtainResourceResponse;
};
export declare const PeerObtainResourceResponse_ResponseContent: {
    encode(message: PeerObtainResourceResponse_ResponseContent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PeerObtainResourceResponse_ResponseContent;
};
export declare const PeerReportResourceStatMessage: {
    encode(message: PeerReportResourceStatMessage, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PeerReportResourceStatMessage;
};
export declare const PeerReportResourceStatMessage_MessageContent: {
    encode(message: PeerReportResourceStatMessage_MessageContent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PeerReportResourceStatMessage_MessageContent;
};
export declare const PeerReportResourceStatsMessage: {
    encode(message: PeerReportResourceStatsMessage, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PeerReportResourceStatsMessage;
};
export declare const PeerReportResourceStatsMessage_MessageContent: {
    encode(message: PeerReportResourceStatsMessage_MessageContent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PeerReportResourceStatsMessage_MessageContent;
};
export declare const PeerReportHealthMessage: {
    encode(message: PeerReportHealthMessage, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PeerReportHealthMessage;
};
export declare const PeerNotifyExceptionMessage: {
    encode(message: PeerNotifyExceptionMessage, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PeerNotifyExceptionMessage;
};
