import _m0 from "protobufjs/minimal";
import { WebRTCICE } from "../base/webrtc";
import { MessageHeader, RequestHeader, ResponseHeader } from "./base";
export interface TrackerEnableUserRequest {
    action: string;
    header: RequestHeader | undefined;
}
export interface TrackerEnableUserResponse {
    action: string;
    header: ResponseHeader | undefined;
}
export interface TrackerConnectNodeRequest {
    action: string;
    header: RequestHeader | undefined;
    content: TrackerConnectNodeRequest_RequestContent | undefined;
}
export interface TrackerConnectNodeRequest_RequestContent {
    sdp: string;
    type: string;
}
export interface TrackerConnectNodeResponse {
    action: string;
    header: ResponseHeader | undefined;
    content: TrackerConnectNodeResponse_ResponseContent | undefined;
}
export interface TrackerConnectNodeResponse_ResponseContent {
    peer_id: string;
    sdp: string;
    type: string;
}
export interface TrackerConnectUserRequest {
    action: string;
    header: RequestHeader | undefined;
    content: TrackerConnectUserRequest_RequestContent | undefined;
}
export interface TrackerConnectUserRequest_RequestContent {
    peer_id: string;
    swarm_id: string;
    sdp: string;
    type: string;
}
export interface TrackerConnectUserResponse {
    action: string;
    header: ResponseHeader | undefined;
    content: TrackerConnectUserResponse_ResponseContent | undefined;
}
export interface TrackerConnectUserResponse_ResponseContent {
    peer_id: string;
    swarm_id: string;
    sdp: string;
    type: string;
}
export interface TrackerJoinSwarmRequest {
    action: string;
    header: RequestHeader | undefined;
    content: TrackerJoinSwarmRequest_RequestContent | undefined;
}
export interface TrackerJoinSwarmRequest_RequestContent {
    swarm_id: string;
    swarm_score: number;
}
export interface TrackerJoinSwarmResponse {
    action: string;
    header: ResponseHeader | undefined;
}
export interface TrackerReportSwarmStatsMessage {
    action: string;
    header: MessageHeader | undefined;
    content: TrackerReportSwarmStatsMessage_MessageContent | undefined;
}
export interface TrackerReportSwarmStatsMessage_MessageContent {
    swarm_id: string;
    swarm_score: number;
}
export interface TrackerObtainSwarmUsersRequest {
    action: string;
    header: RequestHeader | undefined;
    content: TrackerObtainSwarmUsersRequest_RequestContent | undefined;
}
export interface TrackerObtainSwarmUsersRequest_RequestContent {
    swarm_id: string;
}
export interface TrackerObtainSwarmUsersResponse {
    action: string;
    header: ResponseHeader | undefined;
    content: TrackerObtainSwarmUsersResponse_ResponseContent | undefined;
}
export interface TrackerObtainSwarmUsersResponse_ResponseContent {
    swarm_users: Array<any>[];
}
export interface TrackerLeaveSwarmMessage {
    action: string;
    header: MessageHeader | undefined;
    content: TrackerLeaveSwarmMessage_MessageContent | undefined;
}
export interface TrackerLeaveSwarmMessage_MessageContent {
    swarm_id: string;
}
export interface TrackerReportHealthMessage {
    action: string;
    header: MessageHeader | undefined;
}
export interface TrackerNotifyExceptionMessage {
    action: string;
    header: ResponseHeader | undefined;
}
export interface TrackerConfirmReceiptMessage {
    action: string;
}
export interface TrackerDeliverExceptionMessage {
    action: string;
    header: RequestHeader | undefined;
    content: TrackerDeliverExceptionMessage_RequestContent | undefined;
}
export interface TrackerDeliverExceptionMessage_RequestContent {
    peer_id: string;
    code: number;
    status: boolean;
    message: string;
}
export interface TrackerDeliverIceCandidateMessage {
    action: string;
    header: RequestHeader | undefined;
    content: TrackerDeliverIceCandidateMessage_RequestContent | undefined;
}
export interface TrackerDeliverIceCandidateMessage_RequestContent {
    peer_id: string;
    swarm_id?: string | undefined;
    ice: WebRTCICE | undefined;
}
export declare const TrackerEnableUserRequest: {
    encode(message: TrackerEnableUserRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerEnableUserRequest;
};
export declare const TrackerEnableUserResponse: {
    encode(message: TrackerEnableUserResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerEnableUserResponse;
};
export declare const TrackerConnectNodeRequest: {
    encode(message: TrackerConnectNodeRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerConnectNodeRequest;
};
export declare const TrackerConnectNodeRequest_RequestContent: {
    encode(message: TrackerConnectNodeRequest_RequestContent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerConnectNodeRequest_RequestContent;
};
export declare const TrackerConnectNodeResponse: {
    encode(message: TrackerConnectNodeResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerConnectNodeResponse;
};
export declare const TrackerConnectNodeResponse_ResponseContent: {
    encode(message: TrackerConnectNodeResponse_ResponseContent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerConnectNodeResponse_ResponseContent;
};
export declare const TrackerConnectUserRequest: {
    encode(message: TrackerConnectUserRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerConnectUserRequest;
};
export declare const TrackerConnectUserRequest_RequestContent: {
    encode(message: TrackerConnectUserRequest_RequestContent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerConnectUserRequest_RequestContent;
};
export declare const TrackerConnectUserResponse: {
    encode(message: TrackerConnectUserResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerConnectUserResponse;
};
export declare const TrackerConnectUserResponse_ResponseContent: {
    encode(message: TrackerConnectUserResponse_ResponseContent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerConnectUserResponse_ResponseContent;
};
export declare const TrackerJoinSwarmRequest: {
    encode(message: TrackerJoinSwarmRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerJoinSwarmRequest;
};
export declare const TrackerJoinSwarmRequest_RequestContent: {
    encode(message: TrackerJoinSwarmRequest_RequestContent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerJoinSwarmRequest_RequestContent;
};
export declare const TrackerJoinSwarmResponse: {
    encode(message: TrackerJoinSwarmResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerJoinSwarmResponse;
};
export declare const TrackerReportSwarmStatsMessage: {
    encode(message: TrackerReportSwarmStatsMessage, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerReportSwarmStatsMessage;
};
export declare const TrackerReportSwarmStatsMessage_MessageContent: {
    encode(message: TrackerReportSwarmStatsMessage_MessageContent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerReportSwarmStatsMessage_MessageContent;
};
export declare const TrackerObtainSwarmUsersRequest: {
    encode(message: TrackerObtainSwarmUsersRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerObtainSwarmUsersRequest;
};
export declare const TrackerObtainSwarmUsersRequest_RequestContent: {
    encode(message: TrackerObtainSwarmUsersRequest_RequestContent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerObtainSwarmUsersRequest_RequestContent;
};
export declare const TrackerObtainSwarmUsersResponse: {
    encode(message: TrackerObtainSwarmUsersResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerObtainSwarmUsersResponse;
};
export declare const TrackerObtainSwarmUsersResponse_ResponseContent: {
    encode(message: TrackerObtainSwarmUsersResponse_ResponseContent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerObtainSwarmUsersResponse_ResponseContent;
};
export declare const TrackerLeaveSwarmMessage: {
    encode(message: TrackerLeaveSwarmMessage, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerLeaveSwarmMessage;
};
export declare const TrackerLeaveSwarmMessage_MessageContent: {
    encode(message: TrackerLeaveSwarmMessage_MessageContent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerLeaveSwarmMessage_MessageContent;
};
export declare const TrackerReportHealthMessage: {
    encode(message: TrackerReportHealthMessage, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerReportHealthMessage;
};
export declare const TrackerNotifyExceptionMessage: {
    encode(message: TrackerNotifyExceptionMessage, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerNotifyExceptionMessage;
};
export declare const TrackerConfirmReceiptMessage: {
    encode(message: TrackerConfirmReceiptMessage, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerConfirmReceiptMessage;
};
export declare const TrackerDeliverExceptionMessage: {
    encode(message: TrackerDeliverExceptionMessage, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerDeliverExceptionMessage;
};
export declare const TrackerDeliverExceptionMessage_RequestContent: {
    encode(message: TrackerDeliverExceptionMessage_RequestContent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerDeliverExceptionMessage_RequestContent;
};
export declare const TrackerDeliverIceCandidateMessage: {
    encode(message: TrackerDeliverIceCandidateMessage, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerDeliverIceCandidateMessage;
};
export declare const TrackerDeliverIceCandidateMessage_RequestContent: {
    encode(message: TrackerDeliverIceCandidateMessage_RequestContent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TrackerDeliverIceCandidateMessage_RequestContent;
};
