import { MessageCodeObject } from '@mlytics/core-ts/core/.const/code';
import { InternalError } from '@mlytics/core-ts/core/util/error';
declare abstract class AbstractErrorMessageCreator {
    protected readonly _id: string;
    protected readonly _cause: Error;
    static readonly DEFAULT_MESSAGE_CODE: MessageCodeObject;
    protected _code: MessageCodeObject;
    protected _error: InternalError;
    protected _buffer: Uint8Array;
    protected constructor(_id: string, _cause: Error);
    get id(): string;
    get cause(): Error;
    get code(): MessageCodeObject;
    get error(): InternalError;
    get buffer(): Uint8Array;
    protected abstract _initialize(): void;
    protected _setCode(): void;
    protected _setError(): void;
    protected abstract _setBuffer(): void;
}
declare class PeerErrorMessageCreator extends AbstractErrorMessageCreator {
    protected readonly _id: string;
    protected readonly _cause: Error;
    constructor(_id: string, _cause: Error);
    protected _initialize(): void;
    protected _setBuffer(): void;
}
declare class TrackerErrorMessageCreator extends AbstractErrorMessageCreator {
    protected readonly _id: string;
    protected readonly _cause: Error;
    protected readonly _peerID: string;
    constructor(_id: string, _cause: Error, _peerID: string);
    protected _initialize(): void;
    protected _setBuffer(): void;
}
export { PeerErrorMessageCreator, TrackerErrorMessageCreator };
