import { BufferLike, Nullable } from '@mlytics/core-ts/core/type/basic';
import { Condition, SpecConstraintChannelHub } from '@mlytics/core-ts/core/util/future';
import { BasePool } from '../../../../core/model/base/pool';
interface SpecBroker {
    info: AbstractBrokerInfo;
    condition: Condition;
    messageHub: SpecConstraintChannelHub;
    commitMessage(data: BufferLike): Promise<void>;
}
declare abstract class AbstractBrokerInfo {
    protected _peerID?: Nullable<string>;
    protected _peerType: string;
    abstract get id(): Nullable<string>;
    get peerID(): Nullable<string>;
    set peerID(value: Nullable<string>);
    get peerType(): string;
    set peerType(value: string);
}
declare class BrokerPool<Broker extends SpecBroker> extends BasePool<Broker> {
    available(brokerID: string): Promise<void>;
}
export { SpecBroker, AbstractBrokerInfo, BrokerPool };
