import Emittery from 'emittery';
import { TaskManager } from '@mlytics/core-ts/core/util/future';
interface SpecDaemon {
    activate(): Promise<void>;
    deactivate(): Promise<void>;
}
declare abstract class AbstractDaemon extends Emittery implements SpecDaemon {
    protected _taskManager: TaskManager;
    protected abstract _initialize(): void;
    activate(): Promise<void>;
    protected abstract _activate(): Promise<void>;
    deactivate(): Promise<void>;
    protected abstract _deactivate(): Promise<void>;
    protected abstract _storePool(): Promise<void>;
    protected abstract _clearPool(): Promise<void>;
    protected abstract _buildTasks(): Promise<void>;
    protected abstract _recordEnabled(): Promise<void>;
    protected abstract _recordDisabled(): Promise<void>;
}
export { SpecDaemon, AbstractDaemon };
