import { Nullable } from '@mlytics/core-ts/core/type/basic';
import { AbstractFlow, FlowOptions } from '@mlytics/core-ts/utility/flow';
import { SpecPeerBroker } from '../../../../peer/broker/broker';
import { SpecTrackerBroker } from '../../../../tracker/broker/broker';
declare abstract class AbstractProcessFlow<Content = unknown, Outcome = unknown> extends AbstractFlow<Content, Outcome> {
    protected _brokerID?: Nullable<string>;
    constructor(options?: ProcessFlowOptions<Content>);
    protected _obtainPeerBroker(): SpecPeerBroker;
    protected _obtainNodeBroker(): SpecPeerBroker;
    protected _obtainTrackerBroker(): SpecTrackerBroker;
}
type ProcessFlowOptions<Content> = FlowOptions<Content> & {
    brokerID?: Nullable<string>;
};
export { AbstractProcessFlow, ProcessFlowOptions };
