import Emittery from 'emittery';
import { Nullable } from '@mlytics/core-ts/core/type/basic';
import { DelayBackoff } from '@mlytics/core-ts/core/util/backoff';
import { TaskManager } from '@mlytics/core-ts/core/util/future';
import { AbstractDaemon } from '../daemon/daemon';
interface SpecLauncher {
    activate(): Promise<void>;
    deactivate(): Promise<void>;
    reactivate(): Promise<void>;
}
declare abstract class AbstractLauncher extends Emittery implements SpecLauncher {
    protected _daemon?: Nullable<AbstractDaemon>;
    protected _taskManager: TaskManager;
    protected _backoff: DelayBackoff;
    protected abstract _initialize(): void;
    activate(): Promise<void>;
    protected abstract _activate(): Promise<void>;
    deactivate(): Promise<void>;
    protected abstract _deactivate(): Promise<void>;
    reactivate(): Promise<void>;
    protected abstract _reactivate(): Promise<void>;
    protected _terminate(): Promise<void>;
    protected abstract _bindEvents(): Promise<void>;
    protected abstract _buildTasks(): Promise<void>;
}
export { SpecLauncher, AbstractLauncher };
