import { ResourceRange, ResourceStat } from '../../../../../../../core/model/service/resource';
import { ProtocolMessage } from '../../../../../../../protocol/client/utility/message/message';
import { AbstractProcessFlow } from '../../../../../base/daemon/process/flow/flow';
import { SpecPeerBroker } from '../../../../broker/broker';
declare class LaunchObtainResourceFlow extends AbstractProcessFlow<LaunchObtainResourceContent, LaunchObtainResourceOutcome> {
    protected _broker: SpecPeerBroker;
    process(): Promise<LaunchObtainResourceOutcome>;
    protected _intakeBroker(): Promise<void>;
    protected _intakeRequest(): Promise<void>;
    protected _forwardRequest(): Promise<void>;
    protected _intakeResponse(): Promise<void>;
    protected _intakeOutcome(): Promise<void>;
}
type LaunchObtainResourceContent = {
    id: string;
    uri: string;
    range: ResourceRange;
};
type LaunchObtainResourceOutcome = {
    type?: string;
    total?: number;
    range: ResourceRange;
    pieces: Uint8Array;
};
declare class HandleObtainResourceFlow extends AbstractProcessFlow<HandleObtainResourceContent> {
    protected _broker: SpecPeerBroker;
    process(): Promise<void>;
    protected _intakeBroker(): Promise<void>;
    protected _intakeRequest(): Promise<void>;
    protected _intakeResource(): Promise<void>;
    protected _intakeResponse(): Promise<void>;
    protected _forwardResponse(): Promise<void>;
}
type HandleObtainResourceContent = ProtocolMessage;
declare class LaunchReportResourceStatFlow extends AbstractProcessFlow<LaunchReportResourceStatContent> {
    protected _broker: SpecPeerBroker;
    process(): Promise<void>;
    protected _intakeBroker(): Promise<void>;
    protected _intakeMessage(): Promise<void>;
    protected _forwardMessage(): Promise<void>;
}
type LaunchReportResourceStatContent = ResourceStat;
declare class HandleReportResourceStatFlow extends AbstractProcessFlow<HandleReportResourceStatContent> {
    protected _broker: SpecPeerBroker;
    process(): Promise<void>;
    protected _intakeBroker(): Promise<void>;
    protected _intakeMessage(): Promise<void>;
    protected _intakeStat(): Promise<void>;
    protected _updateBrokerInfo(): Promise<void>;
}
type HandleReportResourceStatContent = ProtocolMessage;
declare class LaunchReportResourceStatsFlow extends AbstractProcessFlow<LaunchReportResourceStatsContent> {
    protected _broker: SpecPeerBroker;
    process(): Promise<void>;
    protected _intakeBroker(): Promise<void>;
    protected _intakeMessage(): Promise<void>;
    protected _forwardMessage(): Promise<void>;
}
type LaunchReportResourceStatsContent = ResourceStat[];
declare class HandleReportResourceStatsFlow extends AbstractProcessFlow<HandleReportResourceStatsContent> {
    protected _broker: SpecPeerBroker;
    process(): Promise<void>;
    protected _intakeBroker(): Promise<void>;
    protected _intakeMessage(): Promise<void>;
    protected _intakeStats(): Promise<void>;
    protected _updateBrokerInfo(): Promise<void>;
}
type HandleReportResourceStatsContent = ProtocolMessage;
export { LaunchObtainResourceFlow, LaunchObtainResourceContent, LaunchObtainResourceOutcome, HandleObtainResourceFlow, HandleObtainResourceContent, LaunchReportResourceStatFlow, LaunchReportResourceStatContent, HandleReportResourceStatFlow, HandleReportResourceStatContent, LaunchReportResourceStatsFlow, LaunchReportResourceStatsContent, HandleReportResourceStatsFlow, HandleReportResourceStatsContent };
