import { Resource } from '../../../../../../../core/model/service/resource';
import { AbstractProcessPipe } from '../../../../../base/daemon/process/flow/pipe';
import { SpecPeerBroker } from '../../../../broker/broker';
import * as flows from '../flow';
declare class LaunchObtainResourcePipe extends AbstractProcessPipe<LaunchObtainResourceContent> {
    protected _broker: SpecPeerBroker;
    protected _startSize: number;
    protected _startTime: number;
    protected _startPerfTime: number;
    process(): Promise<void>;
    protected _intakeBroker(): Promise<void>;
    protected _intakeResource(): Promise<void>;
    protected _intakeStates(): Promise<void>;
    protected _obtainResource(): Promise<void>;
    protected _updateResource(): Promise<void>;
    protected _recordDownload(): Promise<void>;
}
type LaunchObtainResourceContent = Resource;
declare class HandleObtainResourcePipe extends AbstractProcessPipe<HandleObtainResourceContent> {
    process(): Promise<void>;
    protected _obtainResource(): Promise<void>;
}
type HandleObtainResourceContent = flows.HandleObtainResourceContent;
declare class LaunchReportResourceStatPipe extends AbstractProcessPipe<LaunchReportResourceStatContent> {
    process(): Promise<void>;
    protected _reportResourceStat(): Promise<void>;
}
type LaunchReportResourceStatContent = flows.LaunchReportResourceStatContent;
declare class HandleReportResourceStatPipe extends AbstractProcessPipe<HandleReportResourceStatContent> {
    process(): Promise<void>;
    protected _reportResourceStat(): Promise<void>;
}
type HandleReportResourceStatContent = flows.HandleReportResourceStatContent;
declare class LaunchReportResourceStatsPipe extends AbstractProcessPipe<LaunchReportResourceStatsContent> {
    process(): Promise<void>;
    protected _reportResourceStats(): Promise<void>;
}
type LaunchReportResourceStatsContent = flows.LaunchReportResourceStatsContent;
declare class HandleReportResourceStatsPipe extends AbstractProcessPipe<HandleReportResourceStatsContent> {
    process(): Promise<void>;
    protected _reportResourceStats(): Promise<void>;
}
type HandleReportResourceStatsContent = flows.HandleReportResourceStatsContent;
export { LaunchObtainResourcePipe, LaunchObtainResourceContent, HandleObtainResourcePipe, HandleObtainResourceContent, LaunchReportResourceStatPipe, LaunchReportResourceStatContent, HandleReportResourceStatPipe, HandleReportResourceStatContent, LaunchReportResourceStatsPipe, LaunchReportResourceStatsContent, HandleReportResourceStatsPipe, HandleReportResourceStatsContent };
