import { AbstractProcessPipe } from '../../../../../base/daemon/process/flow/pipe';
import { SpecPeerBroker } from '../../../../broker/broker';
declare class LaunchConnectUserPipe extends AbstractProcessPipe<LaunchConnectUserContent> {
    protected _broker: SpecPeerBroker;
    process(): Promise<void>;
    protected _intakeBroker(): Promise<void>;
    protected _intakeOffer(): Promise<void>;
    protected _connectUser(): Promise<void>;
    protected _commitAnswer(): Promise<void>;
}
type LaunchConnectUserContent = {
    peerID: string;
    swarmID: string;
};
declare class HandleConnectUserPipe extends AbstractProcessPipe<HandleConnectUserContent> {
    protected _broker: SpecPeerBroker;
    process(): Promise<void>;
    protected _intakeBroker(): Promise<void>;
    protected _commitOffer(): Promise<void>;
    protected _intakeAnswer(): Promise<void>;
    protected _connectUser(): Promise<void>;
}
type HandleConnectUserContent = {
    peerID: string;
    swarmID: string;
    offer: RTCSessionDescriptionInit;
};
export { LaunchConnectUserPipe, LaunchConnectUserContent, HandleConnectUserPipe, HandleConnectUserContent };
