import { LRUCache } from '@mlytics/core-ts/core/util/cache';
import { BasePool } from '../../../../../core/model/base/pool';
import { AbstractProcessPipe, ProcessPipeOutcome } from '../../../base/daemon/process/flow/pipe';
import { PeerDaemonCommandOptions } from '../../daemon/base/daemon';
import { UserLauncher } from '../../launcher/user/launcher';
declare class UserManager extends BasePool<UserLauncher> {
    protected _unavailableBrokerIDs: LRUCache<{}, {}>;
    get hasReachedMaxConnections(): boolean;
    isInUnavailableBrokerIDs(brokerID: string): boolean;
    register(brokerID: string, launcher: UserLauncher): Promise<void>;
    protected _register(brokerID: string, launcher: UserLauncher): Promise<void>;
    deregister(brokerID: string): Promise<void>;
    protected _deregister(brokerID: string): Promise<void>;
    discharge(): Promise<void>;
    broadcast<Pipe extends AbstractProcessPipe>(command: PeerDaemonCommandOptions<Pipe>): Promise<ProcessPipeOutcome<Pipe>[]>;
}
export { UserManager };
