import { SpecQueue } from '@mlytics/core-ts/core/util/queue';
import { SpecConstraintTimer, Timer } from '@mlytics/core-ts/core/util/watch';
import { UserManager } from '../../peer/manager/user/manager';
declare class SwarmInfo {
    protected _swarmID: string;
    protected _swarmURI: string;
    protected _swarmUsers: SpecQueue<SwarmUser>;
    protected _segmentIDs: Set<string>;
    protected _userManager: UserManager;
    protected _timer: Timer;
    constructor(options: SwarmInfoOptions);
    get swarmID(): string;
    get swarmURI(): string;
    get segmentIDs(): Set<string>;
    set segmentIDs(value: Set<string>);
    get swarmUsers(): SpecQueue<SwarmUser>;
    set swarmUsers(values: SpecQueue<SwarmUser>);
    get userManager(): UserManager;
    get timer(): SpecConstraintTimer;
}
type SwarmInfoOptions = {
    swarmID: string;
    swarmURI: string;
    segmentIDs: Set<string>;
};
type SwarmUser = {
    peerID: string;
    swarmScore: number;
};
declare class SwarmScorer {
    static give(info: SwarmInfo): number;
    protected static _calculateByElapsedTime(info: SwarmInfo): number;
    protected static _calculateBySegmentsCompletion(info: SwarmInfo): number;
    protected static _calculateByUserConnections(info: SwarmInfo): number;
}
export { SwarmInfo, SwarmInfoOptions, SwarmUser, SwarmScorer };
