import { Nullable } from '@mlytics/core-ts/core/type/basic';
import { AbstractProcessPipe, ProcessPipeConstructor, ProcessPipeContent, ProcessPipeOptions, ProcessPipeOutcome } from './pipe';
declare abstract class AbstractProcessAgent {
    operate<Pipe extends AbstractProcessPipe>(options: ProcessAgentOperateOptions<Pipe>): Promise<ProcessPipeOutcome<Pipe>>;
    findPipeName(action: string): Nullable<string>;
    protected abstract get _pipeNames(): Map<string, string>;
    protected abstract get _pipeClasses(): Map<string, ProcessPipeConstructor>;
}
type ProcessAgentOperateOptions<Pipe> = {
    name: string;
    data?: ProcessPipeOptions<ProcessPipeContent<Pipe>>;
};
export { AbstractProcessAgent };
