import { SwarmInfo } from '../../../../base/swarm';
import { AbstractProcessFlow } from '../base/flow';
declare class LaunchConnectSwarmUserFlow extends AbstractProcessFlow<LaunchConnectSwarmUserContent> {
    process(): Promise<void>;
    protected _connectSwarmUser(): Promise<void>;
}
type LaunchConnectSwarmUserContent = {
    info: SwarmInfo;
    peerID: string;
    swarmID: string;
    offer?: RTCSessionDescriptionInit;
};
declare class LaunchReportResourceStatFlow extends AbstractProcessFlow<LaunchReportResourceStatContent> {
    process(): Promise<void>;
    protected _intakeResourceStat(): Promise<void>;
    protected _reportResourceStat(): Promise<void>;
}
type LaunchReportResourceStatContent = {
    info: SwarmInfo;
    resourceID: string;
};
declare class LaunchReportResourceStatsFlow extends AbstractProcessFlow<LaunchReportResourceStatsContent> {
    process(): Promise<void>;
    protected _intakeResourceStats(): Promise<void>;
    protected _reportResourceStats(): Promise<void>;
}
type LaunchReportResourceStatsContent = {
    info: SwarmInfo;
};
export { LaunchConnectSwarmUserFlow, LaunchConnectSwarmUserContent, LaunchReportResourceStatFlow, LaunchReportResourceStatContent, LaunchReportResourceStatsFlow, LaunchReportResourceStatsContent };
