import { Nullable } from '@mlytics/core-ts/core/type/basic';
import { BasePool } from '../../../../core/model/base/pool';
import { SwarmLauncher } from '../launcher/launcher';
declare class SwarmManager extends BasePool<SwarmLauncher> {
    register(swarmID: string, launcher: SwarmLauncher): Promise<void>;
    deregister(swarmID: string): Promise<void>;
    recharge(): Promise<void>;
    discharge(): Promise<void>;
}
declare class SwarmManagerHolder {
    protected static _instance?: Nullable<SwarmManager>;
    static get instance(): Nullable<SwarmManager>;
    static set instance(value: Nullable<SwarmManager>);
    static isRegistered(key: string): boolean;
    static register(key: string, value: SwarmLauncher): Promise<void>;
    static deregister(key: string): Promise<void>;
    static recharge(): Promise<void>;
}
export { SwarmManager, SwarmManagerHolder };
