import { Channel } from '@mlytics/core-ts/core/util/future';
import { ProtocolMessage } from '../../../../../protocol/client/utility/message/message';
import { AbstractDaemon, SpecDaemon } from '../../../base/daemon/daemon';
import { AbstractProcessAgent } from '../../../base/daemon/process/flow/agent';
import { SpecConstraintTrackerBroker, TrackerBroker } from '../../broker/broker';
interface SpecTrackerDaemon extends SpecDaemon {
    broker: SpecConstraintTrackerBroker;
}
declare abstract class AbstractTrackerDaemon extends AbstractDaemon implements SpecTrackerDaemon {
    protected _agent: AbstractProcessAgent;
    protected _broker: TrackerBroker;
    protected _feedbacks: Channel<TrackerDaemonFeedback>;
    get broker(): TrackerBroker;
    protected _makeURI(): string;
    feedback(): Promise<TrackerDaemonFeedback>;
    protected _buildWaitToStartTask(): Promise<void>;
    protected _execWaitToStartTaskSentinel(): Promise<boolean>;
    protected _buildListenStateEventTask(): Promise<void>;
    protected _execListenStateEventTaskCallee(): Promise<void>;
    protected _buildListenConnectingEventTask(): Promise<void>;
    protected _execListenConnectingEventTaskCallee(): Promise<void>;
    protected _buildListenConnectedEventTask(): Promise<void>;
    protected _execListenConnectedEventTaskCallee(): Promise<void>;
    protected _buildListenDisconnectedEventTask(): Promise<void>;
    protected _execListenDisconnectedEventTaskCallee(): Promise<void>;
    protected _buildListenTerminatedEventTask(): Promise<void>;
    protected _execListenTerminatedEventTaskCallee(): Promise<void>;
    protected _buildListenSubscribingEventTask(): Promise<void>;
    protected _execListenSubscribingEventTaskCallee(): Promise<void>;
    protected _buildListenSubscribedEventTask(): Promise<void>;
    protected _execListenSubscribedEventTaskCallee(): Promise<void>;
    protected _buildListenUnsubscribedEventTask(): Promise<void>;
    protected _execListenUnsubscribedEventTaskCallee(): Promise<void>;
    protected _buildListenJoinEventTask(): Promise<void>;
    protected _execListenJoinEventTaskCallee(): Promise<void>;
    protected _buildListenLeaveEventTask(): Promise<void>;
    protected _execListenLeaveEventTaskCallee(): Promise<void>;
    protected _buildListenServerDataEventTask(): Promise<void>;
    protected _execListenServerDataEventTaskCallee(): Promise<void>;
    protected _buildListenSpreadDataEventTask(): Promise<void>;
    protected _execListenSpreadDataEventTaskCallee(): Promise<void>;
    protected _buildListenMessageEventTask(): Promise<void>;
    protected _execListenMessageEventTaskCallee(): Promise<void>;
    protected _buildListenErrorEventTask(): Promise<void>;
    protected _execListenErrorEventTaskCallee(): Promise<void>;
    protected _buildDeliverMessageTask(): Promise<void>;
    protected _execDeliverMessageTaskCallee(): Promise<void>;
    protected _buildReceiveMessageTask(): Promise<void>;
    protected _execReceiveMessageTaskCallee(): Promise<void>;
    protected _buildProcessMessageTask(): Promise<void>;
    protected _execProcessMessageTaskCallee(): Promise<void>;
    protected abstract _buildEnablePeerTask(): Promise<void>;
    protected _buildReportHealthTask(): Promise<void>;
    protected _execReportHealthTaskCallee(): Promise<void>;
    protected _buildExitProcessTask(): Promise<void>;
    protected _execExitProcessTaskOnClose(): Promise<void>;
}
declare class TrackerDaemonEvent {
    static readonly FEEDBACK = "feedback";
    static readonly CONNECTED = "connected";
    static readonly DISCONNECTED = "disconnected";
}
declare class TrackerDaemonTaskName {
    static readonly WAIT_TO_START = "tracker daemon: wait to start";
    static readonly LISTEN_STATE_EVENT = "tracker daemon: listen state event";
    static readonly LISTEN_CONNECTING_EVENT = "tracker daemon: listen connecting event";
    static readonly LISTEN_CONNECTED_EVENT = "tracker daemon: listen connected event";
    static readonly LISTEN_DISCONNECTED_EVENT = "tracker daemon: listen disconnected event";
    static readonly LISTEN_TERMINATED_EVENT = "tracker daemon: listen terminated event";
    static readonly LISTEN_SUBSCRIBING_EVENT = "tracker daemon: listen subscribing event";
    static readonly LISTEN_SUBSCRIBED_EVENT = "tracker daemon: listen subscribed event";
    static readonly LISTEN_UNSUBSCRIBED_EVENT = "tracker daemon: listen unsubscribed event";
    static readonly LISTEN_JOIN_EVENT = "tracker daemon: listen join event";
    static readonly LISTEN_LEAVE_EVENT = "tracker daemon: listen leave event";
    static readonly LISTEN_SERVER_DATA_EVENT = "tracker daemon: listen server data event";
    static readonly LISTEN_SPREAD_DATA_EVENT = "tracker daemon: listen spread data event";
    static readonly LISTEN_MESSAGE_EVENT = "tracker daemon: listen message event";
    static readonly LISTEN_ERROR_EVENT = "tracker daemon: listen error event";
    static readonly DELIVER_MESSAGE = "tracker daemon: deliver message";
    static readonly RECEIVE_MESSAGE = "tracker daemon: receive message";
    static readonly PROCESS_MESSAGE = "tracker daemon: process message";
    static readonly ENABLE_PEER = "tracker daemon: enable peer";
    static readonly REPORT_HEALTH = "tracker daemon: report health";
    static readonly EXIT_PROCESS = "tracker daemon: exit process";
}
type TrackerDaemonFeedback = {
    content: ProtocolMessage;
};
export { SpecTrackerDaemon, AbstractTrackerDaemon, TrackerDaemonEvent, TrackerDaemonTaskName, TrackerDaemonFeedback };
