import { AbstractProcessFlow } from '../../../../../base/daemon/process/flow/flow';
import { SpecTrackerBroker } from '../../../../broker/broker';
declare class LaunchJoinSwarmFlow extends AbstractProcessFlow<LaunchJoinSwarmContent> {
    protected _broker: SpecTrackerBroker;
    process(): Promise<void>;
    protected _intakeBroker(): Promise<void>;
    protected _intakeRequest(): Promise<void>;
    protected _forwardRequest(): Promise<void>;
    protected _verifyResponse(): Promise<void>;
}
type LaunchJoinSwarmContent = {
    swarmID: string;
    swarmScore: number;
};
declare class LaunchReportSwarmStatsFlow extends AbstractProcessFlow<LaunchReportSwarmStatsContent> {
    protected _broker: SpecTrackerBroker;
    process(): Promise<void>;
    protected _intakeBroker(): Promise<void>;
    protected _intakeMessage(): Promise<void>;
    protected _forwardMessage(): Promise<void>;
}
type LaunchReportSwarmStatsContent = {
    swarmID: string;
    swarmScore: number;
};
declare class LaunchObtainSwarmUsersFlow extends AbstractProcessFlow<LaunchObtainSwarmUsersContent, LaunchObtainSwarmUsersOutcome> {
    protected _broker: SpecTrackerBroker;
    process(): Promise<LaunchObtainSwarmUsersOutcome>;
    protected _intakeBroker(): Promise<void>;
    protected _intakeRequest(): Promise<void>;
    protected _forwardRequest(): Promise<void>;
    protected _intakeResponse(): Promise<void>;
    protected _intakeOutcome(): Promise<void>;
}
type LaunchObtainSwarmUsersContent = {
    swarmID: string;
};
type LaunchObtainSwarmUsersOutcome = {
    swarmUsers: SwarmUser[];
};
type SwarmUser = {
    peerID: string;
    swarmScore: number;
};
declare class LaunchLeaveSwarmFlow extends AbstractProcessFlow<LaunchLeaveSwarmContent> {
    protected _broker: SpecTrackerBroker;
    process(): Promise<void>;
    protected _intakeBroker(): Promise<void>;
    protected _intakeMessage(): Promise<void>;
    protected _forwardMessage(): Promise<void>;
}
type LaunchLeaveSwarmContent = {
    swarmID: string;
};
export { LaunchJoinSwarmFlow, LaunchJoinSwarmContent, LaunchReportSwarmStatsFlow, LaunchReportSwarmStatsContent, LaunchObtainSwarmUsersFlow, LaunchObtainSwarmUsersContent, LaunchObtainSwarmUsersOutcome, LaunchLeaveSwarmFlow, LaunchLeaveSwarmContent };
