import { AbstractProcessFlow } from '../../../../../base/daemon/process/flow/flow';
import { SpecTrackerBroker } from '../../../../broker/broker';
declare class LaunchEnableUserFlow extends AbstractProcessFlow {
    protected _broker: SpecTrackerBroker;
    process(): Promise<void>;
    protected _intakeBroker(): Promise<void>;
    protected _intakeRequest(): Promise<void>;
    protected _forwardRequest(): Promise<void>;
    protected _verifyResponse(): Promise<void>;
}
declare class LaunchConnectUserFlow extends AbstractProcessFlow<LaunchConnectUserContent, LaunchConnectUserOutcome> {
    protected _broker: SpecTrackerBroker;
    process(): Promise<LaunchConnectUserOutcome>;
    protected _intakeBroker(): Promise<void>;
    protected _intakeRequest(): Promise<void>;
    protected _forwardRequest(): Promise<void>;
    protected _intakeResponse(): Promise<void>;
    protected _intakeOutcome(): Promise<void>;
}
type LaunchConnectUserContent = {
    peerID: string;
    swarmID: string;
    offer: RTCSessionDescriptionInit;
};
type LaunchConnectUserOutcome = {
    peerID: string;
    swarmID: string;
    sdp: string;
    type: RTCSdpType;
};
declare class HandleConnectUserFlow extends AbstractProcessFlow<HandleConnectUserContent> {
    protected _broker: SpecTrackerBroker;
    process(): Promise<void>;
    protected _intakeBroker(): Promise<void>;
    protected _intakeRequest(): Promise<void>;
    protected _forwardRequest(): Promise<void>;
}
type HandleConnectUserContent = {
    peerID: string;
    swarmID: string;
    answer: RTCSessionDescriptionInit;
};
export { LaunchEnableUserFlow, LaunchConnectUserFlow, LaunchConnectUserContent, LaunchConnectUserOutcome, HandleConnectUserFlow, HandleConnectUserContent };
