import { Nullable } from '@mlytics/core-ts/core/type/basic';
import { AbstractFeedbackPipe, FeedbackPipeConstructor, FeedbackPipeContent, FeedbackPipeOptions, FeedbackPipeOutcome } from './pipe';
declare abstract class AbstractFeedbackAgent {
    operate<Pipe extends AbstractFeedbackPipe>(options: FeedbackAgentOperateOptions<Pipe>): Promise<FeedbackPipeOutcome<Pipe>>;
    findPipeName(action: string): Nullable<string>;
    protected abstract get _pipeNames(): Map<string, string>;
    protected abstract get _pipeClasses(): Map<string, FeedbackPipeConstructor>;
}
type FeedbackAgentOperateOptions<Pipe> = {
    name: string;
    data?: FeedbackPipeOptions<FeedbackPipeContent<Pipe>>;
};
export { AbstractFeedbackAgent };
