import { Condition } from '@mlytics/core-ts/core/util/future';
import { AbstractComponent, AbstractComponentAgent } from './component';
declare abstract class AbstractSystemBooter {
    protected _condition: Condition<unknown>;
    protected _componentPool: Map<string, AbstractComponent>;
    protected _componentNames: string[];
    protected _componentAgent: AbstractComponentAgent;
    get pool(): Map<string, AbstractComponent>;
    set pool(value: Map<string, AbstractComponent>);
    get names(): Array<string>;
    set names(values: string[]);
    get isCrashed(): boolean;
    available(): Promise<void>;
    protected abstract _initialize(): void;
    activate(): Promise<void>;
    protected _activate(): Promise<void>;
    protected _initializeSystem(): Promise<void>;
    protected _buildComponentNames(): Promise<void>;
    protected _makeComponentNames(): string[];
    protected _sortComponentNames(names: string[]): void;
    protected _makeComponentWeights(names: string[]): Map<string, number>;
    protected _countComponentWeights(names: string[], weights: Map<string, number>): void;
    protected _buildComponentPool(): Promise<void>;
    deactivate(): Promise<void>;
    protected _deactivate(): Promise<void>;
    protected _clearComponents(): Promise<void>;
    protected _resetCondition(): void;
}
export { AbstractSystemBooter };
