import Emittery from 'emittery';
interface ComponentConstructor {
    new (): AbstractComponent;
}
declare abstract class AbstractComponent extends Emittery {
    protected _isActivated: boolean;
    get isActivated(): boolean;
    protected abstract _initialize(): void;
    activate(): Promise<void>;
    protected _activate(): Promise<void>;
    protected abstract _create(): Promise<void>;
    deactivate(): Promise<void>;
    protected _deactivate(): Promise<void>;
    protected abstract _destroy(): Promise<void>;
    reactivate(): Promise<void>;
    protected _reactivate(): Promise<void>;
    toString(): string;
}
declare abstract class AbstractComponentAgent {
    findMeta(name: string): ComponentMeta;
    findBundle(mode: string): string[][];
    protected abstract get _metas(): Map<string, ComponentMeta>;
    protected abstract get _modeBundles(): Map<string, string[][]>;
}
type ComponentMeta = {
    constructor: ComponentConstructor;
    dependencies: string[];
};
export { ComponentConstructor, AbstractComponent, AbstractComponentAgent, ComponentMeta };
