import { z } from 'zod';
import { PartialDeep } from '@mlytics/core-ts/core/type/basic';
import { KernelSettings } from '../core/config/settings';
declare class KernelConfigurator {
    protected readonly _options?: import("type-fest/source/partial-deep").PartialObjectDeep<KernelSettings, {}> | undefined;
    protected constructor(_options?: import("type-fest/source/partial-deep").PartialObjectDeep<KernelSettings, {}> | undefined);
    config(): void;
    protected _mergeOptions(): void;
    protected _updateLogger(): void;
    protected _updateLoggerLevel(): void;
    protected _updateClient(): void;
    protected _updateClientOrigin(): void;
    protected _updateClientSessionID(): void;
    protected _updateMonitor(): void;
    static config(options?: KernelOptions): void;
}
declare class KernelValidator {
    protected readonly _options?: import("type-fest/source/partial-deep").PartialObjectDeep<KernelSettings, {}> | undefined;
    protected _schema: z.ZodOptional<z.ZodObject<{
        logger: z.ZodOptional<z.ZodObject<{
            level: z.ZodOptional<z.ZodEnum<[string, ...string[]]>>;
        }, "strict", z.ZodTypeAny, {
            level?: string | undefined;
        }, {
            level?: string | undefined;
        }>>;
        server: z.ZodOptional<z.ZodObject<{
            host: z.ZodOptional<z.ZodObject<{
                fqdn: z.ZodOptional<z.ZodString>;
            }, "strict", z.ZodTypeAny, {
                fqdn?: string | undefined;
            }, {
                fqdn?: string | undefined;
            }>>;
        }, "strict", z.ZodTypeAny, {
            host?: {
                fqdn?: string | undefined;
            } | undefined;
        }, {
            host?: {
                fqdn?: string | undefined;
            } | undefined;
        }>>;
        system: z.ZodOptional<z.ZodObject<{
            isP2PAllowed: z.ZodOptional<z.ZodBoolean>;
        }, "strict", z.ZodTypeAny, {
            isP2PAllowed?: boolean | undefined;
        }, {
            isP2PAllowed?: boolean | undefined;
        }>>;
        stream: z.ZodOptional<z.ZodObject<{
            maxBufferSize: z.ZodOptional<z.ZodNumber>;
            minBufferTime: z.ZodOptional<z.ZodNumber>;
            maxBufferTime: z.ZodOptional<z.ZodNumber>;
        }, "strict", z.ZodTypeAny, {
            maxBufferSize?: number | undefined;
            minBufferTime?: number | undefined;
            maxBufferTime?: number | undefined;
        }, {
            maxBufferSize?: number | undefined;
            minBufferTime?: number | undefined;
            maxBufferTime?: number | undefined;
        }>>;
        swproxy: z.ZodOptional<z.ZodObject<{
            scriptPath: z.ZodOptional<z.ZodString>;
            scriptScope: z.ZodOptional<z.ZodString>;
        }, "strict", z.ZodTypeAny, {
            scriptPath?: string | undefined;
            scriptScope?: string | undefined;
        }, {
            scriptPath?: string | undefined;
            scriptScope?: string | undefined;
        }>>;
        monitor: z.ZodOptional<z.ZodObject<{
            gtagTargetID: z.ZodOptional<z.ZodString>;
            sampleRate: z.ZodOptional<z.ZodNumber>;
        }, "strict", z.ZodTypeAny, {
            gtagTargetID?: string | undefined;
            sampleRate?: number | undefined;
        }, {
            gtagTargetID?: string | undefined;
            sampleRate?: number | undefined;
        }>>;
        download: z.ZodOptional<z.ZodObject<{
            maxCacheItems: z.ZodOptional<z.ZodNumber>;
            maxP2PPossibility: z.ZodOptional<z.ZodNumber>;
            httpResponseTimeout: z.ZodOptional<z.ZodNumber>;
        }, "strict", z.ZodTypeAny, {
            maxCacheItems?: number | undefined;
            maxP2PPossibility?: number | undefined;
            httpResponseTimeout?: number | undefined;
        }, {
            maxCacheItems?: number | undefined;
            maxP2PPossibility?: number | undefined;
            httpResponseTimeout?: number | undefined;
        }>>;
    }, "strict", z.ZodTypeAny, {
        logger?: {
            level?: string | undefined;
        } | undefined;
        server?: {
            host?: {
                fqdn?: string | undefined;
            } | undefined;
        } | undefined;
        system?: {
            isP2PAllowed?: boolean | undefined;
        } | undefined;
        stream?: {
            maxBufferSize?: number | undefined;
            minBufferTime?: number | undefined;
            maxBufferTime?: number | undefined;
        } | undefined;
        swproxy?: {
            scriptPath?: string | undefined;
            scriptScope?: string | undefined;
        } | undefined;
        monitor?: {
            gtagTargetID?: string | undefined;
            sampleRate?: number | undefined;
        } | undefined;
        download?: {
            maxCacheItems?: number | undefined;
            maxP2PPossibility?: number | undefined;
            httpResponseTimeout?: number | undefined;
        } | undefined;
    }, {
        logger?: {
            level?: string | undefined;
        } | undefined;
        server?: {
            host?: {
                fqdn?: string | undefined;
            } | undefined;
        } | undefined;
        system?: {
            isP2PAllowed?: boolean | undefined;
        } | undefined;
        stream?: {
            maxBufferSize?: number | undefined;
            minBufferTime?: number | undefined;
            maxBufferTime?: number | undefined;
        } | undefined;
        swproxy?: {
            scriptPath?: string | undefined;
            scriptScope?: string | undefined;
        } | undefined;
        monitor?: {
            gtagTargetID?: string | undefined;
            sampleRate?: number | undefined;
        } | undefined;
        download?: {
            maxCacheItems?: number | undefined;
            maxP2PPossibility?: number | undefined;
            httpResponseTimeout?: number | undefined;
        } | undefined;
    }>>;
    protected constructor(_options?: import("type-fest/source/partial-deep").PartialObjectDeep<KernelSettings, {}> | undefined);
    verify(): void;
    protected _verify(): void;
    static verify(options?: KernelOptions): void;
}
type KernelOptions = PartialDeep<KernelSettings>;
export { KernelConfigurator, KernelValidator, KernelOptions };
