"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.HLSLoader=void 0;const error_1=require("@mlytics/core-ts/core/util/error"),logger_1=require("@mlytics/core-ts/core/util/logger"),watch_1=require("@mlytics/core-ts/core/util/watch"),perf_1=require("@mlytics/core-ts/native/perf"),code_1=require("../../../../kernel/core/const/base/code"),math_1=require("../../../../kernel/core/utility/math"),booter_1=require("../../../../kernel/system/booter"),mixin_1=require("../../../essential/module/mixin"),proxy_1=require("./proxy");class HLSLoader extends mixin_1.DriverExtensionMixin{constructor(){super(),this._timeouter=new watch_1.Timeouter,this._isDestroyed=!1,this._proxy=new proxy_1.HLSLoaderProxy,this._stats=this._makeStats()}get stats(){return this._stats}get context(){return this._context}async load(t,e,s){this._context=t,this._config=e,this._callbacks=s,await this._load().catch(async t=>{await logger_1.Logger.debug("HLS loader load failed.",void 0,{error:t}),this._isDestroyed||(t=this._makeException(t),this._callbacks.onError(t,this._context,void 0,this._stats))})}async _load(){await this._setupStates(),await this._applySystem(),await this._applySource()}async _setupStates(){await this._setQualityLevel()}async _setQualityLevel(){var t,e=this._context;this._qualityLevel=null!=(t=null==(t=e.frag)?void 0:t.level)?t:e.level}async _applySystem(){await booter_1.SystemBooterHolder.available()}async _applySource(){null==this._qualityLevel||this._qualityLevel===HLSLoader.MIN_QUALITY_LEVEL?await this._fetchContent():(await this._timeouter.setup(async()=>{await this._abort(),this._callbacks.onTimeout&&this._callbacks.onTimeout(this._stats,this._context,void 0)},this._config.timeout/1e3),await this._timeouter.apply(async()=>{await this._fetchContent()}))}async _fetchContent(){await this._fetchResource(),await this._updateStats(),await this._replyResource()}async _fetchResource(){switch(this._context.responseType){case ResponseType.TEXT:case ResponseType.ARRAY_BUFFER:this._resource=await this._proxy.fetch(this._context.url);break;default:throw new error_1.ValidationError(code_1.MessageCode.WSV050,void 0,{responseType:this._context.responseType})}}_updateStats(){var t=perf_1.performance.now(),e=this._resource,s=e.ptime.elapsedTimeMs,a=(this._stats.total=e.size,this._stats.loaded=e.size,this._stats.loading.start=t-s,this._stats.loading.first=t,this._stats.loading.end=t,this._context)["part"];a&&(e=Math.max(null!=(a=e.total)?a:10,10),a=Math.log10(s/16/(e/1e3)*10+1),e=math_1.MathFunction.convexHyperbolicTangentCurve(a,2),this._stats.loading.start=t-s*e)}_replyResource(){var t=this._makeResponse();this._callbacks.onProgress&&this._callbacks.onProgress(this._stats,this._context,this._resource.content,void 0),this._callbacks.onSuccess(t,this._stats,this._context,void 0)}_makeStats(){return{aborted:!1,loaded:0,retry:0,total:0,chunkCount:0,bwEstimate:0,loading:{start:0,end:0,first:0},parsing:{start:0,end:0},buffering:{start:0,end:0,first:0}}}_makeResponse(){var t=this._resource,e={url:this._context.url,data:t.content};return this._context.responseType===ResponseType.TEXT&&(e.data=(new TextDecoder).decode(t.content)),e}_makeException(t){return{code:500,text:t.message}}async abort(){await this._abort(),this._callbacks.onAbort&&this._callbacks.onAbort(this._stats,this._context,void 0)}async destroy(){await this._abort()}async _abort(){this._isDestroyed||(null==this._resource&&(this._stats.aborted=!0),this._timeouter.reset(),await this._proxy.abort(),this._isDestroyed=!0)}}(exports.HLSLoader=HLSLoader).MIN_QUALITY_LEVEL=0,HLSLoader._isPublic=!0,HLSLoader._publicName="HLSLoader";class ResponseType{}ResponseType.TEXT="text",ResponseType.ARRAY_BUFFER="arraybuffer";