"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.HLSLoaderProxy=exports.HLSProxy=void 0;const list_1=require("@mlytics/core-ts/core/tool/list"),time_1=require("@mlytics/core-ts/core/tool/time"),error_1=require("@mlytics/core-ts/core/util/error"),watch_1=require("@mlytics/core-ts/core/util/watch"),path_1=require("@mlytics/core-ts/native/path"),flow_1=require("@mlytics/core-ts/utility/flow"),gettings_1=require("../../../../kernel/core/config/gettings"),settings_1=require("../../../../kernel/core/config/settings"),code_1=require("../../../../kernel/core/const/base/code"),flow_2=require("../../../../kernel/core/const/base/flow"),pool_1=require("../../../../kernel/core/model/base/pool"),resource_1=require("../../../../kernel/core/model/service/resource"),math_1=require("../../../../kernel/core/utility/math"),parser_1=require("../../../../kernel/core/utility/parser"),swarm_1=require("../../../../kernel/service/client/swarm/base/swarm"),daemon_1=require("../../../../kernel/service/client/swarm/daemon/state/daemon"),launcher_1=require("../../../../kernel/service/client/swarm/launcher/launcher"),manager_1=require("../../../../kernel/service/client/swarm/manager/manager"),seeker_1=require("../../../../kernel/service/filer/seeker/seeker");class HLSProxy{static async clear(e){await hlsControllerManager.deregister(resource_1.Resource.makeID(e))}}exports.HLSProxy=HLSProxy;class HLSLoaderProxy{async fetch(e){return await this._setupResource(e),await this._setupController(),await this._fetchResource(),this._resource}async _setupResource(e){this._resource=await seeker_1.FileSeekerHolder.cache(new resource_1.Resource(e))}async _setupController(){await this._fetchController(),this._controller||await this._buildController()}async _fetchController(){for(const e of hlsControllerManager.values)if(e.info.isManaged(this._resource))return void(this._controller=e)}async _buildController(){this._controller=new HLSController({episode:new HLSArchive({id:this._resource.id,uri:this._resource.uri})}),await hlsControllerManager.register(this._resource.id,this._controller)}async _fetchResource(){await this._controller.fetch(this._resource)}async abort(){await this._abortResource()}async _abortResource(){await this._controller.abort(this._resource)}}exports.HLSLoaderProxy=HLSLoaderProxy;class HLSController{constructor(e){this._options=e,this._initialize()}get info(){return this._info}_initialize(){this._info=new HLSControllerInfo(this._options)}async fetch(e){await this._injectInfo(e),this._shouldBufferPlay(e)&&await this._bufferPlay(e),await this._fetchResource(e),this._shouldUpdateInfo(e)&&await this._updateInfo(e),this._shouldManageSwarm&&await this._manageSwarm()}async _injectInfo(e){await InjectInfoHandler.process({info:this._info,resource:e})}_shouldBufferPlay(e){return this._info.isSegment(e)}async _bufferPlay(e){await BufferPlayHandler.process({info:this._info,resource:e})}_shouldUpdateInfo(e){return this._info.isPlaylist(e)}async _updateInfo(e){await UpdateInfoHandler.process({info:this._info,resource:e})}get _shouldManageSwarm(){return gettings_1.kernelGettings.isSystemP2PMode&&[...this._info.details.values()].some(e=>null!=e.playManifest)}async _manageSwarm(){await ManageSwarmHandler.process({info:this._info})}async _fetchResource(e){await seeker_1.FileSeekerHolder.fetch(e)}async abort(e){await this._abortResource(e)}async _abortResource(e){await seeker_1.FileSeekerHolder.abort(e)}async close(){await this._deleteSource()}async _deleteSource(){await DeleteSwarmHandler.process({info:this._info})}}class HLSControllerInfo{constructor(e){this._details=new Map,this._episode=e.episode}get episode(){return this._episode}get details(){return this._details}isManaged(e){return this.isSwarmed(e)||this.isEpisode(e)}isPlaylist(e){return this.isManifest(e)||this.isEpisode(e)}isSwarmed(t){return[...this._details.values()].some(e=>e.isSwarmed(t))}isEpisode(e){return this._episode.id===e.id}isManifest(t){return[...this._details.values()].some(e=>e.isManifest(t))}isSegment(t){return[...this._details.values()].some(e=>e.isSegment(t))}findDetail(e){return this._details.get(e)}}class HLSControllerInfoDetail{constructor(){this._manifests=new Map,this._playSegments=new Map,this._playStableTime=new watch_1.Timer}get manifests(){return this._manifests}set manifests(e){this._manifests=e}get lastManifest(){return this._lastManifest}set lastManifest(e){this._lastManifest=e}get lastSegment(){return this._lastSegment}set lastSegment(e){this._lastSegment=e}get playManifest(){return this._playManifest}set playManifest(e){this._playManifest=e}get playSegment(){return this._playSegment}set playSegment(e){this._playSegment=e}get playSegments(){return this._playSegments}set playSegments(e){this._playSegments=e}get playStableTime(){return this._playStableTime}isSwarmed(e){return this.isManifest(e)||this.isSegment(e)}isManifest(e){return this._manifests.has(e.id)}isSegment(t){return[...this._manifests.values()].some(e=>e.isSegment(t))}}class HLSControllerInfoDetailName{}HLSControllerInfoDetailName.VIDEO="video",HLSControllerInfoDetailName.AUDIO="audio",HLSControllerInfoDetailName.SUBTITLE="subtitle",HLSControllerInfoDetailName.UNKNOWN="unknown";class HLSArchive{constructor(e){this._id=e.id,this._uri=e.uri}get id(){return this._id}set id(e){this._id=e}get uri(){return this._uri}set uri(e){this._uri=e}}class HLSManifest extends HLSArchive{constructor(e){super(e),this._segments=new Map,this._segments=e.segments}get segments(){return this._segments}set segments(e){this._segments=e}isSegment(e){return this._segments.has(e.id)}}class HLSSegment extends HLSArchive{constructor(e){super(e),this._duration=e.duration,this._hasParts=e.hasParts}get duration(){return this._duration}set duration(e){this._duration=e}get hasParts(){return this._hasParts}set hasParts(e){this._hasParts=e}}class HLSMeasure extends HLSSegment{constructor(e){super(e),this._priority=e.priority,this._cumulativeDuration=e.cumulativeDuration}get priority(){return this._priority}set priority(e){this._priority=e}get cumulativeDuration(){return this._cumulativeDuration}set cumulativeDuration(e){this._cumulativeDuration=e}}class HLSControllerManager extends pool_1.BasePool{async register(e,t){await super.register(e,t)}async deregister(e){var t=this.retrieve(e);await(null==t?void 0:t.close()),await super.deregister(e)}}const hlsControllerManager=new HLSControllerManager;class InjectInfoHandler extends flow_1.AbstractFlow{constructor(e){super(e),this._info=e.content.info,this._resource=e.content.resource}async process(){await this._injectSource(),await this._injectSwarm()}_injectSource(){this._resource.sourceURI=this._info.episode.uri}_injectSwarm(){for(const e of[...this._info.details.values()].flatMap(e=>[...e.manifests.values()]))if(e.isSegment(this._resource)){this._resource.swarmID=e.id,this._resource.swarmURI=e.uri,this._resource.isShareable=!0;break}}static async process(e){await new InjectInfoHandler({content:e}).process()}}class BufferPlayHandler extends flow_1.AbstractFlow{constructor(e){super(e),this._info=e.content.info,this._resource=e.content.resource}async process(){await this._intakeDetail(),await this._updatePlayStates(),await this._delayBufferPlay(),await this._intakeSegments(),await this._intakeMeasures(),await this._intakePlaySegments(),await this._abortPlaySegments(),await this._updatePlaySegments()}_intakeDetail(){var e=[...this._info.details.values()].find(e=>e.isSegment(this._resource));this._expose(flow_2.FlowKey.DETAIL,e)}_updatePlayStates(){var e=this._require(flow_2.FlowKey.DETAIL);e.lastManifest=e.playManifest,e.lastSegment=e.playSegment,e.playManifest=e.manifests.get(this._resource.swarmID),e.playSegment=this._resource,e.lastManifest&&e.lastManifest===e.playManifest&&e.lastSegment&&e.lastSegment.isComplete?e.playStableTime.stamp():e.playStableTime.reset()}async _delayBufferPlay(){var e=this._require(flow_2.FlowKey.DETAIL),t=e.playSegment;if(null!=e.lastSegment&&(await time_1.TimeTool.sleepRandomly(.1*(1-this._playStability)),e.playSegment!==t))throw new error_1.InternalError(code_1.MessageCode.ESV051,void 0,{resource:this._resource})}get _playStability(){var e=this._require(flow_2.FlowKey.DETAIL),e=Math.min(e.playStableTime.elapsedTimeS,BufferPlayHandler.MIN_STABLE_TIME);return Math.pow(e/BufferPlayHandler.MIN_STABLE_TIME,2)}_intakeSegments(){var e=this._require(flow_2.FlowKey.DETAIL);let t=new Array;var s=[...e.playManifest.segments.values()].filter(e=>!e.hasParts);for(let e=0;e<s.length;e++)if(s[e].uri===this._resource.uri){t=s.slice(e,e+settings_1.kernelSettings.stream.maxBufferSize);break}this._expose(flow_2.FlowKey.SEGMENTS,t)}_intakeMeasures(){var t=this._require(flow_2.FlowKey.SEGMENTS),s=new Array;let r=0;var a=Math.max(settings_1.kernelSettings.stream.maxBufferTime*Math.max(this._playStability,.1),settings_1.kernelSettings.stream.minBufferTime);for(let e=0;e<t.length;e++){var{id:i,uri:n,duration:o,hasParts:l}=t[e];if(s.push(new HLSMeasure({id:i,uri:n,duration:o,hasParts:l,priority:e,cumulativeDuration:r})),(r+=o)>a)break}this._expose(flow_2.FlowKey.MEASURES,s)}async _intakePlaySegments(){var t=this._require(flow_2.FlowKey.MEASURES),s=new Map;for(const r of t){let e=new resource_1.Resource(r.uri);e.priority=r.priority,e.startDelay=r.cumulativeDuration*math_1.MathFunction.upwardSigmoidCurve(r.priority,t.length),e=await seeker_1.FileSeekerHolder.prefetch(e),await s.set(e.id,e),await InjectInfoHandler.process({info:this._info,resource:e})}await this._expose(flow_2.FlowKey.SEGMENTS,s)}async _abortPlaySegments(){var e=this._require(flow_2.FlowKey.DETAIL).playSegments,t=this._require(flow_2.FlowKey.SEGMENTS);for(const s of e.values())t.has(s.id)||await seeker_1.FileSeekerHolder.abort(s)}_updatePlaySegments(){var e=this._require(flow_2.FlowKey.DETAIL),t=this._require(flow_2.FlowKey.SEGMENTS);e.playSegments=t}static async process(e){await new BufferPlayHandler({content:e}).process()}}BufferPlayHandler.MIN_STABLE_TIME=10;class UpdateInfoHandler extends flow_1.AbstractFlow{constructor(e){super(e),this._info=e.content.info,this._resource=e.content.resource}async process(){await this._intakePlaylist(),this._isEpisodePlaylist?(await this._updateVideo(),await this._updateAudio()):this._isManifestPlaylist&&(await this._ensureDetail(),await this._updateManifest(),await this._updateSegments())}_intakePlaylist(){var e=parser_1.M3U8Tool.parse(this._resource.content);this._expose(flow_2.FlowKey.PLAYLIST,e)}get _isEpisodePlaylist(){var e=this._require(flow_2.FlowKey.PLAYLIST);return null!=e.playlists&&0<e.playlists.length}_updateVideo(){var e=this._require(flow_2.FlowKey.PLAYLIST),e=this._createDetail(e.playlists);this._info.details.set(HLSControllerInfoDetailName.VIDEO,e)}_updateAudio(){var e,t=this._require(flow_2.FlowKey.PLAYLIST);null!=(null==(e=t.mediaGroups)?void 0:e.AUDIO)&&(e=this._createDetail(list_1.ListTool.flatObject(t.mediaGroups.AUDIO,2)),this._info.details.set(HLSControllerInfoDetailName.AUDIO,e))}_createDetail(e){var t=new HLSControllerInfoDetail,s=new Map;for(const a of e){var r=path_1.path.dirname(this._info.episode.uri),r=new resource_1.Resource(new URL(a.uri,r+"/").href),r=new HLSManifest({id:r.id,uri:r.uri,segments:new Map});s.set(r.id,r)}return t.manifests=s,t}get _isManifestPlaylist(){return 0<this._require(flow_2.FlowKey.PLAYLIST).segments.length}_ensureDetail(){let e=[...this._info.details.values()].find(e=>e.isManifest(this._resource));e||(e=this._createDetail([{uri:this._resource.uri}]),this._info.details.set(HLSControllerInfoDetailName.UNKNOWN,e)),this._expose(flow_2.FlowKey.DETAIL,e)}_updateManifest(){var e=this._require(flow_2.FlowKey.DETAIL),t=null!=(t=e.manifests.get(this._resource.id))?t:new HLSManifest({id:this._resource.id,uri:this._resource.uri,segments:new Map});e.manifests.set(t.id,t)}_updateSegments(){var e=this._require(flow_2.FlowKey.PLAYLIST),t=this._require(flow_2.FlowKey.DETAIL).manifests.get(this._resource.id);const s=path_1.path.dirname(t.uri),r=new Map;e.segments.forEach(e=>{var t=null!=e.parts;t&&e.parts.forEach(e=>{this._injectHLSSegment(r,s,e,!1)}),this._injectHLSSegment(r,s,e,t)}),e.preloadSegment&&null!=(e=e.preloadSegment.parts)&&e.forEach(e=>{this._injectHLSSegment(r,s,e,!1)}),t.segments=r}_injectHLSSegment(e,t,s,r){t=new resource_1.Resource(new URL(s.uri,t+"/").href),t=new HLSSegment({id:t.id,uri:t.uri,duration:s.duration,hasParts:r});e.set(t.id,t)}static async process(e){await new UpdateInfoHandler({content:e}).process()}}class ManageSwarmHandler extends flow_1.AbstractFlow{constructor(e){super(e),this._info=e.content.info}async process(){await this._iterateDetails(async()=>{await this._intakeSegmentIDs(),this._shouldCreateSwarmLauncher&&await this._createSwarmLauncher(),await this._updateSwarmDaemonInfo()})}async _iterateDetails(e){for(const t of[...this._info.details.values()].filter(e=>null!=e.playManifest))await this._expose(flow_2.FlowKey.DETAIL,t),await e(),await this._remove(flow_2.FlowKey.DETAIL)}_intakeSegmentIDs(){var e=[...this._require(flow_2.FlowKey.DETAIL).playManifest.segments.values()].map(e=>e.id);this._expose(flow_2.FlowKey.SEGMENT_IDS,new Set(e))}get _shouldCreateSwarmLauncher(){var e=this._require(flow_2.FlowKey.DETAIL);return!manager_1.SwarmManagerHolder.isRegistered(e.playManifest.id)}async _createSwarmLauncher(){var e=this._require(flow_2.FlowKey.DETAIL),t=this._require(flow_2.FlowKey.SEGMENT_IDS);await manager_1.SwarmManagerHolder.register(e.playManifest.id,new launcher_1.SwarmLauncher({info:new swarm_1.SwarmInfo({swarmID:e.playManifest.id,swarmURI:e.playManifest.uri,segmentIDs:t})}))}_updateSwarmDaemonInfo(){var e=this._require(flow_2.FlowKey.DETAIL),e=daemon_1.swarmDaemonPool.retrieve(e.playManifest.id),t=this._require(flow_2.FlowKey.SEGMENT_IDS);e&&(e.info.segmentIDs=t)}static async process(e){await new ManageSwarmHandler({content:e}).process()}}class DeleteSwarmHandler extends flow_1.AbstractFlow{constructor(e){super(e),this._info=e.content.info}async process(){await this._intakeDetails(),await this._abortPlaySegments(),await this._deleteSwarmLauncher(),await this._deleteSwarmLaunchers()}_intakeDetails(){var e=[...this._info.details.values()];this._expose(flow_2.FlowKey.DETAILS,e)}async _abortPlaySegments(){var e=this._require(flow_2.FlowKey.DETAILS).flatMap(e=>[...e.playSegments.values()]);await Promise.all(e.map(e=>seeker_1.FileSeekerHolder.abort(e)))}async _deleteSwarmLauncher(){var e=this._require(flow_2.FlowKey.DETAILS).filter(e=>null!=e.playManifest).map(e=>e.playManifest.id);await Promise.all(e.map(e=>manager_1.SwarmManagerHolder.deregister(e)))}async _deleteSwarmLaunchers(){var e=this._require(flow_2.FlowKey.DETAILS).flatMap(e=>[...e.manifests.keys()]);await Promise.all(e.map(e=>manager_1.SwarmManagerHolder.deregister(e)))}static async process(e){await new DeleteSwarmHandler({content:e}).process()}}