"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.HLSSWURLPatterns=exports.HLSSWServerOwner=exports.HLSSWServer=void 0;const http_1=require("@mlytics/core-ts/core/.const/http"),error_1=require("@mlytics/core-ts/core/util/error"),future_1=require("@mlytics/core-ts/core/util/future"),logger_1=require("@mlytics/core-ts/core/util/logger"),watch_1=require("@mlytics/core-ts/core/util/watch"),flow_1=require("@mlytics/core-ts/utility/flow"),code_1=require("../../../../../kernel/core/const/base/code"),mcdn_1=require("../../../../../kernel/core/const/service/mcdn"),constant_1=require("../../base/swproxy/model/constant");class HLSSWServer{constructor(){this._isActive=!1}get isActive(){return this._isActive}start(){this._isActive||(this._start(),this._isActive=!0)}_start(){this._bindEvents()}_bindEvents(){self.addEventListener("install",e=>{this._onInstall(e)}),self.addEventListener("activate",e=>{this._onActivate(e)}),self.addEventListener("fetch",e=>{this._onFetch(e)})}_onInstall(e){e.waitUntil((async()=>{console.info("[MLYSDK]","SWServer:","Install swproxy."),await self.skipWaiting()})())}_onActivate(e){e.waitUntil((async()=>{console.info("[MLYSDK]","SWServer:","Activate swproxy."),await self.clients.claim()})())}_onFetch(e){var t=new HLSSWURLBypasser(e);t.shouldFetch&&e.respondWith(t.fetch())}}exports.HLSSWServer=HLSSWServer;class HLSSWURLBypasser{constructor(e){this._flowID=flow_1.FlowID.make(),this._channel=new MessageChannel,this._condition=new future_1.Condition,this._timeouter=new watch_1.Timeouter,this._url=new URL(e.request.url),this._event=e,this._request=e.request,this._clientID=e.clientId}get shouldFetch(){return this._isGetMethod&&!this._isBypassedURL&&this._isIdentifiedURL}get _isGetMethod(){return this._request.method===http_1.HTTPMethod.GET}get _isBypassedURL(){return null!=this._url.searchParams.get(mcdn_1.QueryStringKey.VIA_MLYSDK)}get _isIdentifiedURL(){return new HLSSWURLResolver(this._url).indentify()}async fetch(){try{await this._recordEvent(),await this._intakeClient(),await this._setupTimeout(),await this._bindEvents(),await this._forwardMessage(),await this._intakeMessage(),await this._intakeResponse()}catch(e){throw await this._recordError(e),e}finally{await this._clearTimeout()}return this._response}async _recordEvent(){var[e,t,s]=[this._url,this._flowID,this._clientID];logger_1.Logger.info("SWServer bypass fetch.",{url:e,flowID:t,clientID:s})}async _intakeClient(){var e=await self.clients.get(this._clientID);if(null==e)throw new error_1.InternalError(code_1.MessageCode.WSV010);this._client=e}async _setupTimeout(){this._timeouter.setup(async()=>{this._condition.deny(new error_1.InternalError(code_1.MessageCode.ESV011))},HLSSWURLBypasser.BYPASS_FETCH_TIMEOUT)}async _bindEvents(){this._channel.port1.onmessage=async e=>{await this._onMessage(e)},this._channel.port1.onmessageerror=async e=>{await this._onMessageError(e)}}async _onMessage(e){this._condition.pass(e.data)}async _onMessageError(e){this._condition.deny(new error_1.InternalError(code_1.MessageCode.ESV012))}async _forwardMessage(){this._client.postMessage({action:constant_1.SWProxyActionName.REQUEST_BYPASS_FETCH,header:{correlation_id:this._flowID,source_client_id:this._clientID},content:{uri:this._request.url}},[this._channel.port2])}async _intakeMessage(){var e=await this._condition.done();if(e.action===constant_1.SWProxyActionName.MESSAGE_NOTIFY_EXCEPTION)throw new error_1.InternalError(code_1.MessageCode.ESV000,void 0,{payload:e});if(e.action!==constant_1.SWProxyActionName.RESPOND_BYPASS_FETCH)throw new error_1.InternalError(code_1.MessageCode.WSV001,void 0,{payload:e});this._payload=e}async _intakeResponse(){var e=this._payload.content;this._response=new Response(e.buffer,{status:200,statusText:"OK",headers:{[http_1.HTTPHeader.CONTENT_TYPE]:e.type}})}async _recordError(e){var[t,s,r]=[this._url,this._flowID,this._clientID];logger_1.Logger.warn("SWServer bypass failed.",{url:t,flowID:s,clientID:r},{error:e})}async _clearTimeout(){this._timeouter.reset()}}HLSSWURLBypasser.BYPASS_FETCH_TIMEOUT=600;class HLSSWURLResolver{constructor(e){this._url=e}indentify(){e:for(const s of Object.values(HLSSWURLPatterns)){var t=this._url.pathname.match(s.regex);if(null!=t&&t.length-1===s.matches.length){for(let e=0;e<s.matches.length;e++)if(!s.matches[e].has(t[e+1].toLowerCase()))continue e;return!0}}return!1}}const HLSSWURLPatterns={suffix:{regex:/^.+?(\.[0-9a-z]+(?:\.enc)?)$/i,matches:[new Set([".m3u8",".ts",".ts.enc",".key",".mp4",".m4s"])]},azureSuffix:{regex:/^.+?([a-z]+)\([^/]*format=([0-9a-z-]+)[^/]*\)$/i,matches:[new Set(["manifest","fragments"]),new Set(["m3u8-cmaf","m3u8-aapl","m3u8-aapl-v3"])]}};exports.HLSSWURLPatterns=HLSSWURLPatterns;class HLSSWServerOwner{static create(){return null==this._server&&(this._server=new HLSSWServer,this._server.start()),this._server}}(exports.HLSSWServerOwner=HLSSWServerOwner).create();