"use strict";var __importDefault=this&&this.__importDefault||function(t){return t&&t.__esModule?t:{default:t}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.MetricsCollectorHolder=exports.MetricsCollectorEvent=exports.MetricsCollector=void 0;const emittery_1=__importDefault(require("emittery")),future_1=require("@mlytics/core-ts/core/util/future"),flow_1=require("@mlytics/core-ts/utility/flow"),flow_2=require("../../const/base/flow"),data_1=require("../../utility/data"),math_1=require("../../utility/math"),exporter_1=require("./exporter"),constant_1=require("./model/constant"),stats_1=require("./state/stats");class MetricsCollector extends emittery_1.default{constructor(){super(...arguments),this._taskManager=new future_1.TaskManager}async activate(){await this._taskManager.activate(),await this._bindEvents(),await this._buildTasks()}async deactivate(){await this._taskManager.deactivate(),await this.clearListeners()}async _bindEvents(){await this.on(MetricsCollectorEvent.HTTP_DOWNLOAD_RECORD,async t=>{await HTTPDownloadRecordHandler.process(t)}),await this.on(MetricsCollectorEvent.CDN_CONFIG_RECORDS,async t=>{await CDNConfigRecordsHandler.process(t)}),await this.on(MetricsCollectorEvent.CDN_DOWNLOAD_RECORD,async t=>{await CDNDownloadRecordHandler.process(t)}),await this.on(MetricsCollectorEvent.P2P_DOWNLOAD_RECORD,async t=>{await P2PDownloadRecordHandler.process(t)}),await this.on(MetricsCollectorEvent.TRACKER_STATE_RECORD,async t=>{await TrackerStateRecordHandler.process(t)}),await this.on(MetricsCollectorEvent.NODE_STATE_RECORD,async t=>{await NodeStateRecordHandler.process(t)}),await this.on(MetricsCollectorEvent.SWARM_STATE_RECORD,async t=>{await SwarmStateRecordHandler.process(t)}),await this.on(MetricsCollectorEvent.USER_STATE_RECORD,async t=>{await UserStateRecordHandler.process(t)}),await this.on(MetricsCollectorEvent.PURGE_CDN_RECORDS,async t=>{await PurgeCDNRecordsHandler.process(t)})}async _buildTasks(){await this._buildHandleHTTPDownloadPulseTrafficTask(),await this._buildHandleHTTPDownloadCumulativeTrafficTask(),await this._buildHandleHTTPDownloadWMABandwidthTask(),await this._buildHandleHTTPDownloadUsagePulseCountTask(),await this._buildHandleHTTPDownloadUsageCumulativeCountTask(),await this._buildHandleHTTPDownloadSuccessPulseCountTask(),await this._buildHandleHTTPDownloadSuccessCumulativeCountTask(),await this._buildHandleHTTPDownloadFailurePulseCountTask(),await this._buildHandleHTTPDownloadFailureCumulativeCountTask(),await this._buildHandleCDNDownloadLastMeanBandwidthTask(),await this._buildHandleCDNDownloadLastMeanAvailabilityTask(),await this._buildHandleCDNDownloadLastCurrentScoreTask(),await this._buildHandleP2PDownloadPulseTrafficTask(),await this._buildHandleP2PDownloadCumulativeTrafficTask(),await this._buildHandleP2PDownloadWMABandwidthTask(),await this._buildHandleP2PDownloadUsagePulseCountTask(),await this._buildHandleP2PDownloadUsageCumulativeCountTask(),await this._buildHandlePruneMetricsStatsTask()}async _buildHandleHTTPDownloadPulseTrafficTask(){await this._taskManager.createCyclicTask(new HTTPDownloadPulseTrafficDuty({name:MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_PULSE_TRAFFIC,content:{cursors:new Map},sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleHTTPDownloadCumulativeTrafficTask(){await this._taskManager.createCyclicTask(new HTTPDownloadCumulativeTrafficDuty({name:MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_CUMULATIVE_TRAFFIC,content:{cursors:new Map},sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleHTTPDownloadWMABandwidthTask(){await this._taskManager.createCyclicTask(new HTTPDownloadWMABandwidthDuty({name:MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_WMA_BANDWIDTH,sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleHTTPDownloadUsagePulseCountTask(){await this._taskManager.createCyclicTask(new HTTPDownloadUsagePulseCountDuty({name:MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_USAGE_PULSE_COUNT,content:{cursors:new Map},sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleHTTPDownloadUsageCumulativeCountTask(){await this._taskManager.createCyclicTask(new HTTPDownloadUsageCumulativeCountDuty({name:MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_USAGE_CUMULATIVE_COUNT,content:{cursors:new Map},sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleHTTPDownloadSuccessPulseCountTask(){await this._taskManager.createCyclicTask(new HTTPDownloadSuccessPulseCountDuty({name:MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_SUCCESS_PULSE_COUNT,content:{cursors:new Map},sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleHTTPDownloadSuccessCumulativeCountTask(){await this._taskManager.createCyclicTask(new HTTPDownloadSuccessCumulativeCountDuty({name:MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_SUCCESS_CUMULATIVE_COUNT,content:{cursors:new Map},sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleHTTPDownloadFailurePulseCountTask(){await this._taskManager.createCyclicTask(new HTTPDownloadFailurePulseCountDuty({name:MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_FAILURE_PULSE_COUNT,content:{cursors:new Map},sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleHTTPDownloadFailureCumulativeCountTask(){await this._taskManager.createCyclicTask(new HTTPDownloadFailureCumulativeCountDuty({name:MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_FAILURE_CUMULATIVE_COUNT,content:{cursors:new Map},sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleCDNDownloadLastMeanBandwidthTask(){await this._taskManager.createCyclicTask(new CDNDownloadLastMeanBandwidthDuty({name:MetricsCollectorTaskName.HANDLE_CDN_DOWNLOAD_LAST_MEAN_BANDWIDTH,content:{cursors:new Map},sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleCDNDownloadLastMeanAvailabilityTask(){await this._taskManager.createCyclicTask(new CDNDownloadLastMeanAvailabilityDuty({name:MetricsCollectorTaskName.HANDLE_CDN_DOWNLOAD_LAST_MEAN_AVAILABILITY,content:{cursors:new Map},sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleCDNDownloadLastCurrentScoreTask(){await this._taskManager.createCyclicTask(new CDNDownloadLastCurrentScoreDuty({name:MetricsCollectorTaskName.HANDLE_CDN_DOWNLOAD_LAST_CURRENT_SCORE,content:{cursors:new Map},sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleP2PDownloadPulseTrafficTask(){await this._taskManager.createCyclicTask(new P2PDownloadPulseTrafficDuty({name:MetricsCollectorTaskName.HANDLE_P2P_DOWNLOAD_PULSE_TRAFFIC,content:{cursors:new Map},sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleP2PDownloadCumulativeTrafficTask(){await this._taskManager.createCyclicTask(new P2PDownloadCumulativeTrafficDuty({name:MetricsCollectorTaskName.HANDLE_P2P_DOWNLOAD_CUMULATIVE_TRAFFIC,content:{cursors:new Map},sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleP2PDownloadWMABandwidthTask(){await this._taskManager.createCyclicTask(new P2PDownloadWMABandwidthDuty({name:MetricsCollectorTaskName.HANDLE_P2P_DOWNLOAD_WMA_BANDWIDTH,sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleP2PDownloadUsagePulseCountTask(){await this._taskManager.createCyclicTask(new P2PDownloadUsagePulseCountDuty({name:MetricsCollectorTaskName.HANDLE_P2P_DOWNLOAD_USAGE_PULSE_COUNT,content:{cursors:new Map},sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleP2PDownloadUsageCumulativeCountTask(){await this._taskManager.createCyclicTask(new P2PDownloadUsageCumulativeCountDuty({name:MetricsCollectorTaskName.HANDLE_P2P_DOWNLOAD_USAGE_CUMULATIVE_COUNT,content:{cursors:new Map},sleepFirst:!0,sleepSeconds:3,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandlePruneMetricsStatsTask(){await this._taskManager.createCyclicTask(new PruneMetricsStatsDuty({name:MetricsCollectorTaskName.HANDLE_PRUNE_METRICS_STATS,sleepFirst:!0,sleepSeconds:10,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}}exports.MetricsCollector=MetricsCollector;class MetricsCollectorEvent{}(exports.MetricsCollectorEvent=MetricsCollectorEvent).HTTP_DOWNLOAD_RECORD="http_download_record",MetricsCollectorEvent.CDN_CONFIG_RECORDS="cdn_config_records",MetricsCollectorEvent.CDN_DOWNLOAD_RECORD="cdn_download_record",MetricsCollectorEvent.P2P_DOWNLOAD_RECORD="p2p_download_record",MetricsCollectorEvent.TRACKER_STATE_RECORD="tracker_state_record",MetricsCollectorEvent.NODE_STATE_RECORD="node_state_record",MetricsCollectorEvent.SWARM_STATE_RECORD="swarm_state_record",MetricsCollectorEvent.USER_STATE_RECORD="user_state_record",MetricsCollectorEvent.PURGE_CDN_RECORDS="purge_cdn_records";class MetricsCollectorTaskName{}MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_PULSE_TRAFFIC="metrics collector: handle http download pulse traffic",MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_CUMULATIVE_TRAFFIC="metrics collector: handle http download cumulative traffic",MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_WMA_BANDWIDTH="metrics collector: handle http download wma bandwidth",MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_USAGE_PULSE_COUNT="metrics collector: handle http download usage pulse count",MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_USAGE_CUMULATIVE_COUNT="metrics collector: handle http download usage cumulative count",MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_SUCCESS_PULSE_COUNT="metrics collector: handle http download success pulse count",MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_SUCCESS_CUMULATIVE_COUNT="metrics collector: handle http download success cumulative count",MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_FAILURE_PULSE_COUNT="metrics collector: handle http download failure pulse count",MetricsCollectorTaskName.HANDLE_HTTP_DOWNLOAD_FAILURE_CUMULATIVE_COUNT="metrics collector: handle http download failure cumulative count",MetricsCollectorTaskName.HANDLE_CDN_DOWNLOAD_LAST_MEAN_BANDWIDTH="metrics collector: handle cdn download last mean bandwidth",MetricsCollectorTaskName.HANDLE_CDN_DOWNLOAD_LAST_MEAN_AVAILABILITY="metrics collector: handle cdn download last mean availability",MetricsCollectorTaskName.HANDLE_CDN_DOWNLOAD_LAST_CURRENT_SCORE="metrics collector: handle cdn download last current score",MetricsCollectorTaskName.HANDLE_P2P_DOWNLOAD_PULSE_TRAFFIC="metrics collector: handle p2p download pulse traffic",MetricsCollectorTaskName.HANDLE_P2P_DOWNLOAD_CUMULATIVE_TRAFFIC="metrics collector: handle p2p download cumulative traffic",MetricsCollectorTaskName.HANDLE_P2P_DOWNLOAD_WMA_BANDWIDTH="metrics collector: handle p2p download wma bandwidth",MetricsCollectorTaskName.HANDLE_P2P_DOWNLOAD_USAGE_PULSE_COUNT="metrics collector: handle p2p download usage pulse count",MetricsCollectorTaskName.HANDLE_P2P_DOWNLOAD_USAGE_CUMULATIVE_COUNT="metrics collector: handle p2p download usage cumulative count",MetricsCollectorTaskName.HANDLE_PRUNE_METRICS_STATS="metrics collector: handle prune metrics stats";class HTTPDownloadPulseTrafficDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await HTTPDownloadPulseTrafficHandler.process(this._options.content)}}class HTTPDownloadCumulativeTrafficDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await HTTPDownloadCumulativeTrafficHandler.process(this._options.content)}}class HTTPDownloadWMABandwidthDuty extends future_1.CyclicDuty{async callee(){await HTTPDownloadWMABandwidthHandler.process()}}class HTTPDownloadUsagePulseCountDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await HTTPDownloadUsagePulseCountHandler.process(this._options.content)}}class HTTPDownloadUsageCumulativeCountDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await HTTPDownloadUsageCumulativeCountHandler.process(this._options.content)}}class HTTPDownloadSuccessPulseCountDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await HTTPDownloadSuccessPulseCountHandler.process(this._options.content)}}class HTTPDownloadSuccessCumulativeCountDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await HTTPDownloadSuccessCumulativeCountHandler.process(this._options.content)}}class HTTPDownloadFailurePulseCountDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await HTTPDownloadFailurePulseCountHandler.process(this._options.content)}}class HTTPDownloadFailureCumulativeCountDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await HTTPDownloadFailureCumulativeCountHandler.process(this._options.content)}}class CDNDownloadLastMeanBandwidthDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await CDNDownloadLastMeanBandwidthHandler.process(this._options.content)}}class CDNDownloadLastMeanAvailabilityDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await CDNDownloadLastMeanAvailabilityHandler.process(this._options.content)}}class CDNDownloadLastCurrentScoreDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await CDNDownloadLastCurrentScoreHandler.process(this._options.content)}}class P2PDownloadPulseTrafficDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await P2PDownloadPulseTrafficHandler.process(this._options.content)}}class P2PDownloadCumulativeTrafficDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await P2PDownloadCumulativeTrafficHandler.process(this._options.content)}}class P2PDownloadWMABandwidthDuty extends future_1.CyclicDuty{async callee(){await P2PDownloadWMABandwidthHandler.process()}}class P2PDownloadUsagePulseCountDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await P2PDownloadUsagePulseCountHandler.process(this._options.content)}}class P2PDownloadUsageCumulativeCountDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await P2PDownloadUsageCumulativeCountHandler.process(this._options.content)}}class PruneMetricsStatsDuty extends future_1.CyclicDuty{async callee(){await PruneMetricsStatsHandler.process()}}class HTTPDownloadRecordHandler extends flow_1.AbstractFlow{async process(){await this._intakeMetrics(),await this._updateMetrics(),await this._exportMetrics()}async _intakeMetrics(){var t=this._content;let e;e=t.id?stats_1.MetricsStatsHolder.cdns[t.id]:stats_1.MetricsStatsHolder.origin,await this._expose(flow_2.FlowKey.METRICS,e)}async _updateMetrics(){var t=this._content,e=this._require(flow_2.FlowKey.METRICS);await e.download.count.usage.dataset.push({ctime:t.ctime,value:1}),t.isSuccess?await e.download.count.success.dataset.push({ctime:t.ctime,value:1}):await e.download.count.failure.dataset.push({ctime:t.ctime,value:1}),await e.download.outcome.dataset.push({ctime:t.ctime,value:t.isSuccess?1:0}),await e.download.traffic.dataset.push({ctime:t.ctime,value:t.contentSize}),t.bandwidth&&await e.download.bandwidth.dataset.push({ctime:t.ctime,value:t.bandwidth}),await stats_1.MetricsStatsHolder.source.http.download.records.push(t)}async _exportMetrics(){var t=this._content;await exporter_1.ExportHTTPDownloadRecordHandler.process(t)}static async process(t){await new HTTPDownloadRecordHandler({content:t}).process()}}class HTTPDownloadPulseTrafficHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._ensureCursor(),await this._intakeIndex(),await this._intakeData(),await this._updateMetrics()}),await this._exportMetrics()}async _iterateMetrics(t){for(const e of[...Object.values(stats_1.MetricsStatsHolder.cdns),stats_1.MetricsStatsHolder.origin])await this._expose(flow_2.FlowKey.METRICS,e),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.INDEX,flow_2.FlowKey.DATA)}async _ensureCursor(){var t=this._require(flow_2.FlowKey.METRICS);this._content.cursors.get(t.id)||this._content.cursors.set(t.id,{data:void 0})}async _intakeIndex(){var t=this._require(flow_2.FlowKey.METRICS),e=this._content.cursors.get(t.id),a=t.download.traffic.dataset;let s=a.length;for(let t=a.length-1;0<=t&&a[t]!==e.data;t--)s=t;await this._expose(flow_2.FlowKey.INDEX,s)}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.INDEX),a=t.download.traffic.dataset;let s=0;for(let t=e;t<a.length;t++)s+=a[t].value;t={ctime:Date.now(),value:s};await this._expose(flow_2.FlowKey.DATA,t)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.DATA),a=t.download.traffic.dataset;await t.download.traffic.pulse.dataset.push(e),await this._content.cursors.set(t.id,{data:a[a.length-1]})}async _exportMetrics(){await exporter_1.ExportHTTPDownloadPulseTrafficHandler.process()}static async process(t){await new HTTPDownloadPulseTrafficHandler({content:t}).process()}}class HTTPDownloadCumulativeTrafficHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._ensureCursor(),await this._intakeIndex(),await this._intakeData(),await this._updateMetrics()}),await this._exportMetrics()}async _iterateMetrics(t){for(const e of[...Object.values(stats_1.MetricsStatsHolder.cdns),stats_1.MetricsStatsHolder.origin])await this._expose(flow_2.FlowKey.METRICS,e),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.INDEX,flow_2.FlowKey.DATA)}async _ensureCursor(){var t=this._require(flow_2.FlowKey.METRICS);this._content.cursors.get(t.id)||this._content.cursors.set(t.id,{data:void 0,value:0})}async _intakeIndex(){var t=this._require(flow_2.FlowKey.METRICS),e=this._content.cursors.get(t.id),a=t.download.traffic.dataset;let s=a.length;for(let t=a.length-1;0<=t&&a[t]!==e.data;t--)s=t;await this._expose(flow_2.FlowKey.INDEX,s)}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.INDEX),a=this._content.cursors.get(t.id),s=t.download.traffic.dataset;let o=a.value;for(let t=e;t<s.length;t++)o+=s[t].value;t={ctime:Date.now(),value:o};await this._expose(flow_2.FlowKey.DATA,t)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.DATA),a=t.download.traffic.dataset;await t.download.traffic.cumulation.dataset.push(e),await this._content.cursors.set(t.id,{data:a[a.length-1],value:e.value})}async _exportMetrics(){await exporter_1.ExportHTTPDownloadCumulativeTrafficHandler.process()}static async process(t){await new HTTPDownloadCumulativeTrafficHandler({content:t}).process()}}class HTTPDownloadWMABandwidthHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._intakeData(),await this._updateMetrics()}),await this._exportMetrics()}async _iterateMetrics(t){for(const e of[...Object.values(stats_1.MetricsStatsHolder.cdns),stats_1.MetricsStatsHolder.origin])await this._expose(flow_2.FlowKey.METRICS,e),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.DATA)}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=Date.now();const a=e-1e3*constant_1.MetricsConstant.DURATION_OF_WMA_DATA;t=t.download.bandwidth.dataset.filter(t=>t.ctime>=a),await t.push({ctime:e,value:0}),t=math_1.MathCalculator.weightedAverage(t.map(t=>({offset:t.ctime-a,value:t.value}))),e={ctime:e,value:t};await this._expose(flow_2.FlowKey.DATA,e)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.DATA);await t.download.bandwidth.wma.dataset.push(e)}async _exportMetrics(){await exporter_1.ExportHTTPDownloadWMABandwidthHandler.process()}static async process(){await(new HTTPDownloadWMABandwidthHandler).process()}}class HTTPDownloadUsagePulseCountHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._ensureCursor(),await this._intakeIndex(),await this._intakeData(),await this._updateMetrics()}),await this._exportMetrics()}async _iterateMetrics(t){for(const e of[...Object.values(stats_1.MetricsStatsHolder.cdns),stats_1.MetricsStatsHolder.origin])await this._expose(flow_2.FlowKey.METRICS,e),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.INDEX,flow_2.FlowKey.DATA)}async _ensureCursor(){var t=this._require(flow_2.FlowKey.METRICS);this._content.cursors.get(t.id)||this._content.cursors.set(t.id,{data:void 0})}async _intakeIndex(){var t=this._require(flow_2.FlowKey.METRICS),e=this._content.cursors.get(t.id),a=t.download.count.usage.dataset;let s=a.length;for(let t=a.length-1;0<=t&&a[t]!==e.data;t--)s=t;await this._expose(flow_2.FlowKey.INDEX,s)}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.INDEX),a=t.download.count.usage.dataset;let s=0;for(let t=e;t<a.length;t++)s+=a[t].value;t={ctime:Date.now(),value:s};await this._expose(flow_2.FlowKey.DATA,t)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.DATA),a=t.download.count.usage.dataset;await t.download.count.usage.pulse.dataset.push(e),await this._content.cursors.set(t.id,{data:a[a.length-1]})}async _exportMetrics(){await exporter_1.ExportHTTPDownloadUsagePulseCountHandler.process()}static async process(t){await new HTTPDownloadUsagePulseCountHandler({content:t}).process()}}class HTTPDownloadUsageCumulativeCountHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._ensureCursor(),await this._intakeIndex(),await this._intakeData(),await this._updateMetrics()}),await this._exportMetrics()}async _iterateMetrics(t){for(const e of[...Object.values(stats_1.MetricsStatsHolder.cdns),stats_1.MetricsStatsHolder.origin])await this._expose(flow_2.FlowKey.METRICS,e),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.INDEX,flow_2.FlowKey.DATA)}async _ensureCursor(){var t=this._require(flow_2.FlowKey.METRICS);this._content.cursors.get(t.id)||this._content.cursors.set(t.id,{data:void 0,value:0})}async _intakeIndex(){var t=this._require(flow_2.FlowKey.METRICS),e=this._content.cursors.get(t.id),a=t.download.count.usage.dataset;let s=a.length;for(let t=a.length-1;0<=t&&a[t]!==e.data;t--)s=t;await this._expose(flow_2.FlowKey.INDEX,s)}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.INDEX),a=this._content.cursors.get(t.id),s=t.download.count.usage.dataset;let o=a.value;for(let t=e;t<s.length;t++)o+=s[t].value;t={ctime:Date.now(),value:o};await this._expose(flow_2.FlowKey.DATA,t)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.DATA),a=t.download.count.usage.dataset;await t.download.count.usage.cumulation.dataset.push(e),await this._content.cursors.set(t.id,{data:a[a.length-1],value:e.value})}async _exportMetrics(){await exporter_1.ExportHTTPDownloadUsageCumulativeCountHandler.process()}static async process(t){await new HTTPDownloadUsageCumulativeCountHandler({content:t}).process()}}class HTTPDownloadSuccessPulseCountHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._ensureCursor(),await this._intakeIndex(),await this._intakeData(),await this._updateMetrics()}),await this._exportMetrics()}async _iterateMetrics(t){for(const e of[...Object.values(stats_1.MetricsStatsHolder.cdns),stats_1.MetricsStatsHolder.origin])await this._expose(flow_2.FlowKey.METRICS,e),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.INDEX,flow_2.FlowKey.DATA)}async _ensureCursor(){var t=this._require(flow_2.FlowKey.METRICS);this._content.cursors.get(t.id)||this._content.cursors.set(t.id,{data:void 0})}async _intakeIndex(){var t=this._require(flow_2.FlowKey.METRICS),e=this._content.cursors.get(t.id),a=t.download.count.success.dataset;let s=a.length;for(let t=a.length-1;0<=t&&a[t]!==e.data;t--)s=t;await this._expose(flow_2.FlowKey.INDEX,s)}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.INDEX),a=t.download.count.success.dataset;let s=0;for(let t=e;t<a.length;t++)s+=a[t].value;t={ctime:Date.now(),value:s};await this._expose(flow_2.FlowKey.DATA,t)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.DATA),a=t.download.count.success.dataset;await t.download.count.success.pulse.dataset.push(e),await this._content.cursors.set(t.id,{data:a[a.length-1]})}async _exportMetrics(){await exporter_1.ExportHTTPDownloadSuccessPulseCountHandler.process()}static async process(t){await new HTTPDownloadSuccessPulseCountHandler({content:t}).process()}}class HTTPDownloadSuccessCumulativeCountHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._ensureCursor(),await this._intakeIndex(),await this._intakeData(),await this._updateMetrics()}),await this._exportMetrics()}async _iterateMetrics(t){for(const e of[...Object.values(stats_1.MetricsStatsHolder.cdns),stats_1.MetricsStatsHolder.origin])await this._expose(flow_2.FlowKey.METRICS,e),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.INDEX,flow_2.FlowKey.DATA)}async _ensureCursor(){var t=this._require(flow_2.FlowKey.METRICS);this._content.cursors.get(t.id)||this._content.cursors.set(t.id,{data:void 0,value:0})}async _intakeIndex(){var t=this._require(flow_2.FlowKey.METRICS),e=this._content.cursors.get(t.id),a=t.download.count.success.dataset;let s=a.length;for(let t=a.length-1;0<=t&&a[t]!==e.data;t--)s=t;await this._expose(flow_2.FlowKey.INDEX,s)}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.INDEX),a=this._content.cursors.get(t.id),s=t.download.count.success.dataset;let o=a.value;for(let t=e;t<s.length;t++)o+=s[t].value;t={ctime:Date.now(),value:o};await this._expose(flow_2.FlowKey.DATA,t)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.DATA),a=t.download.count.success.dataset;await t.download.count.success.cumulation.dataset.push(e),await this._content.cursors.set(t.id,{data:a[a.length-1],value:e.value})}async _exportMetrics(){await exporter_1.ExportHTTPDownloadSuccessCumulativeCountHandler.process()}static async process(t){await new HTTPDownloadSuccessCumulativeCountHandler({content:t}).process()}}class HTTPDownloadFailurePulseCountHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._ensureCursor(),await this._intakeIndex(),await this._intakeData(),await this._updateMetrics()}),await this._exportMetrics()}async _iterateMetrics(t){for(const e of[...Object.values(stats_1.MetricsStatsHolder.cdns),stats_1.MetricsStatsHolder.origin])await this._expose(flow_2.FlowKey.METRICS,e),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.INDEX,flow_2.FlowKey.DATA)}async _ensureCursor(){var t=this._require(flow_2.FlowKey.METRICS);this._content.cursors.get(t.id)||this._content.cursors.set(t.id,{data:void 0})}async _intakeIndex(){var t=this._require(flow_2.FlowKey.METRICS),e=this._content.cursors.get(t.id),a=t.download.count.failure.dataset;let s=a.length;for(let t=a.length-1;0<=t&&a[t]!==e.data;t--)s=t;await this._expose(flow_2.FlowKey.INDEX,s)}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.INDEX),a=t.download.count.failure.dataset;let s=0;for(let t=e;t<a.length;t++)s+=a[t].value;t={ctime:Date.now(),value:s};await this._expose(flow_2.FlowKey.DATA,t)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.DATA),a=t.download.count.failure.dataset;await t.download.count.failure.pulse.dataset.push(e),await this._content.cursors.set(t.id,{data:a[a.length-1]})}async _exportMetrics(){await exporter_1.ExportHTTPDownloadFailurePulseCountHandler.process()}static async process(t){await new HTTPDownloadFailurePulseCountHandler({content:t}).process()}}class HTTPDownloadFailureCumulativeCountHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._ensureCursor(),await this._intakeIndex(),await this._intakeData(),await this._updateMetrics()}),await this._exportMetrics()}async _iterateMetrics(t){for(const e of[...Object.values(stats_1.MetricsStatsHolder.cdns),stats_1.MetricsStatsHolder.origin])await this._expose(flow_2.FlowKey.METRICS,e),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.INDEX,flow_2.FlowKey.DATA)}async _ensureCursor(){var t=this._require(flow_2.FlowKey.METRICS);this._content.cursors.get(t.id)||this._content.cursors.set(t.id,{data:void 0,value:0})}async _intakeIndex(){var t=this._require(flow_2.FlowKey.METRICS),e=this._content.cursors.get(t.id),a=t.download.count.failure.dataset;let s=a.length;for(let t=a.length-1;0<=t&&a[t]!==e.data;t--)s=t;await this._expose(flow_2.FlowKey.INDEX,s)}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.INDEX),a=this._content.cursors.get(t.id),s=t.download.count.failure.dataset;let o=a.value;for(let t=e;t<s.length;t++)o+=s[t].value;t={ctime:Date.now(),value:o};await this._expose(flow_2.FlowKey.DATA,t)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.DATA),a=t.download.count.failure.dataset;await t.download.count.failure.cumulation.dataset.push(e),await this._content.cursors.set(t.id,{data:a[a.length-1],value:e.value})}async _exportMetrics(){await exporter_1.ExportHTTPDownloadFailureCumulativeCountHandler.process()}static async process(t){await new HTTPDownloadFailureCumulativeCountHandler({content:t}).process()}}class CDNConfigRecordsHandler extends flow_1.AbstractFlow{async process(){await this._iterateRecords(async()=>{await this._updateMetrics()})}async _iterateRecords(t){for(const e of this._content)await this._expose(flow_2.FlowKey.RECORD,e),await t(),await this._remove(flow_2.FlowKey.RECORD)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.RECORD);await stats_1.MetricsStatsHolder.setupCDN(t)}static async process(t){await new CDNConfigRecordsHandler({content:t}).process()}}class CDNDownloadRecordHandler extends flow_1.AbstractFlow{async process(){await this._updateMetrics()}async _updateMetrics(){var t=this._content,e=stats_1.MetricsStatsHolder.cdns[t.id];await e.download.meanBandwidth.dataset.push({ctime:t.ctime,value:t.meanBandwidth}),await e.download.meanAvailability.dataset.push({ctime:t.ctime,value:t.meanAvailability}),await e.download.currentScore.dataset.push({ctime:t.ctime,value:t.currentScore})}static async process(t){await new CDNDownloadRecordHandler({content:t}).process()}}class CDNDownloadLastMeanBandwidthHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._ensureCursor(),await this._intakeData(),await this._updateMetrics()}),await this._exportMetrics()}async _iterateMetrics(t){for(const e of Object.values(stats_1.MetricsStatsHolder.cdns))await this._expose(flow_2.FlowKey.METRICS,e),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.INDEX,flow_2.FlowKey.DATA)}async _ensureCursor(){var t=this._require(flow_2.FlowKey.METRICS);this._content.cursors.get(t.id)||this._content.cursors.set(t.id,{data:void 0,value:0})}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=this._content.cursors.get(t.id),t=t.download.meanBandwidth.dataset,t={ctime:Date.now(),value:null!=(t=null==(t=t[t.length-1])?void 0:t.value)?t:e.value};await this._expose(flow_2.FlowKey.DATA,t)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.DATA),a=t.download.meanBandwidth.dataset;await t.download.meanBandwidth.last.dataset.push(e),await this._content.cursors.set(t.id,{data:a[a.length-1],value:e.value})}async _exportMetrics(){await exporter_1.ExportCDNDownloadLastMeanBandwidthHandler.process()}static async process(t){await new CDNDownloadLastMeanBandwidthHandler({content:t}).process()}}class CDNDownloadLastMeanAvailabilityHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._ensureCursor(),await this._intakeData(),await this._updateMetrics()}),await this._exportMetrics()}async _iterateMetrics(t){for(const e of Object.values(stats_1.MetricsStatsHolder.cdns))await this._expose(flow_2.FlowKey.METRICS,e),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.INDEX,flow_2.FlowKey.DATA)}async _ensureCursor(){var t=this._require(flow_2.FlowKey.METRICS);this._content.cursors.get(t.id)||this._content.cursors.set(t.id,{data:void 0,value:1})}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=this._content.cursors.get(t.id),t=t.download.meanAvailability.dataset,t={ctime:Date.now(),value:null!=(t=null==(t=t[t.length-1])?void 0:t.value)?t:e.value};await this._expose(flow_2.FlowKey.DATA,t)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.DATA),a=t.download.meanAvailability.dataset;await t.download.meanAvailability.last.dataset.push(e),await this._content.cursors.set(t.id,{data:a[a.length-1],value:e.value})}async _exportMetrics(){await exporter_1.ExportCDNDownloadLastMeanAvailabilityHandler.process()}static async process(t){await new CDNDownloadLastMeanAvailabilityHandler({content:t}).process()}}class CDNDownloadLastCurrentScoreHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._ensureCursor(),await this._intakeData(),await this._updateMetrics()}),await this._exportMetrics()}async _iterateMetrics(t){for(const e of Object.values(stats_1.MetricsStatsHolder.cdns))await this._expose(flow_2.FlowKey.METRICS,e),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.INDEX,flow_2.FlowKey.DATA)}async _ensureCursor(){var t=this._require(flow_2.FlowKey.METRICS);this._content.cursors.get(t.id)||this._content.cursors.set(t.id,{data:void 0,value:1})}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=this._content.cursors.get(t.id),t=t.download.currentScore.dataset,t={ctime:Date.now(),value:null!=(t=null==(t=t[t.length-1])?void 0:t.value)?t:e.value};await this._expose(flow_2.FlowKey.DATA,t)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.DATA),a=t.download.currentScore.dataset;await t.download.currentScore.last.dataset.push(e),await this._content.cursors.set(t.id,{data:a[a.length-1],value:e.value})}async _exportMetrics(){await exporter_1.ExportCDNDownloadLastCurrentScoreHandler.process()}static async process(t){await new CDNDownloadLastCurrentScoreHandler({content:t}).process()}}class P2PDownloadRecordHandler extends flow_1.AbstractFlow{async process(){await this._updateMetrics(),await this._exportMetrics()}async _updateMetrics(){var t=this._content,e=stats_1.MetricsStatsHolder.swarms[t.swarmID].users[t.peerID];await e.download.count.usage.dataset.push({ctime:t.ctime,value:1}),await e.download.traffic.dataset.push({ctime:t.ctime,value:t.contentSize}),t.bandwidth&&await e.download.bandwidth.dataset.push({ctime:t.ctime,value:t.bandwidth}),await stats_1.MetricsStatsHolder.source.p2p.download.records.push(t)}async _exportMetrics(){var t=this._content;await exporter_1.ExportP2PDownloadRecordHandler.process(t)}static async process(t){await new P2PDownloadRecordHandler({content:t}).process()}}class P2PDownloadPulseTrafficHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._ensureCursor(),await this._intakeIndex(),await this._intakeData(),await this._updateMetrics()}),await this._cleanCursors(),await this._exportMetrics()}async _iterateMetrics(t){for(const e of Object.values(stats_1.MetricsStatsHolder.swarms))for(const a of Object.values(e.users))await this._expose(flow_2.FlowKey.ID,e.swarmID+"::"+a.peerID),await this._expose(flow_2.FlowKey.METRICS,a),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.ID,flow_2.FlowKey.INDEX,flow_2.FlowKey.DATA)}async _ensureCursor(){var t=this._require(flow_2.FlowKey.ID);this._content.cursors.get(t)||this._content.cursors.set(t,{data:void 0})}async _intakeIndex(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.ID),a=this._content.cursors.get(e),s=t.download.traffic.dataset;let o=s.length;for(let t=s.length-1;0<=t&&s[t]!==a.data;t--)o=t;await this._expose(flow_2.FlowKey.INDEX,o)}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.INDEX),a=t.download.traffic.dataset;let s=0;for(let t=e;t<a.length;t++)s+=a[t].value;t={ctime:Date.now(),value:s};await this._expose(flow_2.FlowKey.DATA,t)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.ID),a=this._require(flow_2.FlowKey.DATA),s=t.download.traffic.dataset;await t.download.traffic.pulse.dataset.push(a),await this._content.cursors.set(e,{data:s[s.length-1]})}async _cleanCursors(){for(const a of this._content.cursors.keys()){var[t,e]=a.split("::");null==(null==(t=stats_1.MetricsStatsHolder.swarms[t])?void 0:t.users[e])&&this._content.cursors.delete(a)}}async _exportMetrics(){await exporter_1.ExportP2PDownloadPulseTrafficHandler.process()}static async process(t){await new P2PDownloadPulseTrafficHandler({content:t}).process()}}class P2PDownloadCumulativeTrafficHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._ensureCursor(),await this._intakeIndex(),await this._intakeData(),await this._updateMetrics()}),await this._cleanCursors(),await this._exportMetrics()}async _iterateMetrics(t){for(const e of Object.values(stats_1.MetricsStatsHolder.swarms))for(const a of Object.values(e.users))await this._expose(flow_2.FlowKey.ID,e.swarmID+"::"+a.peerID),await this._expose(flow_2.FlowKey.METRICS,a),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.ID,flow_2.FlowKey.INDEX,flow_2.FlowKey.DATA)}async _ensureCursor(){var t=this._require(flow_2.FlowKey.ID);this._content.cursors.get(t)||this._content.cursors.set(t,{data:void 0,value:0})}async _intakeIndex(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.ID),a=this._content.cursors.get(e),s=t.download.traffic.dataset;let o=s.length;for(let t=s.length-1;0<=t&&s[t]!==a.data;t--)o=t;await this._expose(flow_2.FlowKey.INDEX,o)}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.ID),a=this._require(flow_2.FlowKey.INDEX),e=this._content.cursors.get(e),s=t.download.traffic.dataset;let o=e.value;for(let t=a;t<s.length;t++)o+=s[t].value;t={ctime:Date.now(),value:o};await this._expose(flow_2.FlowKey.DATA,t)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.ID),a=this._require(flow_2.FlowKey.DATA),s=t.download.traffic.dataset;await t.download.traffic.cumulation.dataset.push(a),await this._content.cursors.set(e,{data:s[s.length-1],value:a.value})}async _cleanCursors(){for(const a of this._content.cursors.keys()){var[t,e]=a.split("::");null==(null==(t=stats_1.MetricsStatsHolder.swarms[t])?void 0:t.users[e])&&this._content.cursors.delete(a)}}async _exportMetrics(){await exporter_1.ExportP2PDownloadCumulativeTrafficHandler.process()}static async process(t){await new P2PDownloadCumulativeTrafficHandler({content:t}).process()}}class P2PDownloadWMABandwidthHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._intakeData(),await this._updateMetrics()}),await this._exportMetrics()}async _iterateMetrics(t){for(const e of Object.values(stats_1.MetricsStatsHolder.swarms))for(const a of Object.values(e.users))await this._expose(flow_2.FlowKey.METRICS,a),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.DATA)}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=Date.now();const a=e-1e3*constant_1.MetricsConstant.DURATION_OF_WMA_DATA;t=t.download.bandwidth.dataset.filter(t=>t.ctime>=a),await t.push({ctime:e,value:0}),t=math_1.MathCalculator.weightedAverage(t.map(t=>({offset:t.ctime-a,value:t.value}))),e={ctime:e,value:t};await this._expose(flow_2.FlowKey.DATA,e)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.DATA);await t.download.bandwidth.wma.dataset.push(e)}async _exportMetrics(){await exporter_1.ExportP2PDownloadWMABandwidthHandler.process()}static async process(){await(new P2PDownloadWMABandwidthHandler).process()}}class P2PDownloadUsagePulseCountHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._ensureCursor(),await this._intakeIndex(),await this._intakeData(),await this._updateMetrics()}),await this._cleanCursors(),await this._exportMetrics()}async _iterateMetrics(t){for(const e of Object.values(stats_1.MetricsStatsHolder.swarms))for(const a of Object.values(e.users))await this._expose(flow_2.FlowKey.ID,e.swarmID+"::"+a.peerID),await this._expose(flow_2.FlowKey.METRICS,a),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.ID,flow_2.FlowKey.INDEX,flow_2.FlowKey.DATA)}async _ensureCursor(){var t=this._require(flow_2.FlowKey.ID);this._content.cursors.get(t)||this._content.cursors.set(t,{data:void 0})}async _intakeIndex(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.ID),a=this._content.cursors.get(e),s=t.download.count.usage.dataset;let o=s.length;for(let t=s.length-1;0<=t&&s[t]!==a.data;t--)o=t;await this._expose(flow_2.FlowKey.INDEX,o)}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.INDEX),a=t.download.count.usage.dataset;let s=0;for(let t=e;t<a.length;t++)s+=a[t].value;t={ctime:Date.now(),value:s};await this._expose(flow_2.FlowKey.DATA,t)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.ID),a=this._require(flow_2.FlowKey.DATA),s=t.download.count.usage.dataset;await t.download.count.usage.pulse.dataset.push(a),await this._content.cursors.set(e,{data:s[s.length-1]})}async _cleanCursors(){for(const a of this._content.cursors.keys()){var[t,e]=a.split("::");null==(null==(t=stats_1.MetricsStatsHolder.swarms[t])?void 0:t.users[e])&&this._content.cursors.delete(a)}}async _exportMetrics(){await exporter_1.ExportP2PDownloadUsagePulseCountHandler.process()}static async process(t){await new P2PDownloadUsagePulseCountHandler({content:t}).process()}}class P2PDownloadUsageCumulativeCountHandler extends flow_1.AbstractFlow{async process(){await this._iterateMetrics(async()=>{await this._ensureCursor(),await this._intakeIndex(),await this._intakeData(),await this._updateMetrics()}),await this._cleanCursors(),await this._exportMetrics()}async _iterateMetrics(t){for(const e of Object.values(stats_1.MetricsStatsHolder.swarms))for(const a of Object.values(e.users))await this._expose(flow_2.FlowKey.ID,e.swarmID+"::"+a.peerID),await this._expose(flow_2.FlowKey.METRICS,a),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.ID,flow_2.FlowKey.INDEX,flow_2.FlowKey.DATA)}async _ensureCursor(){var t=this._require(flow_2.FlowKey.ID);this._content.cursors.get(t)||this._content.cursors.set(t,{data:void 0,value:0})}async _intakeIndex(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.ID),a=this._content.cursors.get(e),s=t.download.count.usage.dataset;let o=s.length;for(let t=s.length-1;0<=t&&s[t]!==a.data;t--)o=t;await this._expose(flow_2.FlowKey.INDEX,o)}async _intakeData(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.ID),a=this._require(flow_2.FlowKey.INDEX),e=this._content.cursors.get(e),s=t.download.count.usage.dataset;let o=e.value;for(let t=a;t<s.length;t++)o+=s[t].value;t={ctime:Date.now(),value:o};await this._expose(flow_2.FlowKey.DATA,t)}async _updateMetrics(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.ID),a=this._require(flow_2.FlowKey.DATA),s=t.download.count.usage.dataset;await t.download.count.usage.cumulation.dataset.push(a),await this._content.cursors.set(e,{data:s[s.length-1],value:a.value})}async _cleanCursors(){for(const a of this._content.cursors.keys()){var[t,e]=a.split("::");null==(null==(t=stats_1.MetricsStatsHolder.swarms[t])?void 0:t.users[e])&&this._content.cursors.delete(a)}}async _exportMetrics(){await exporter_1.ExportP2PDownloadUsageCumulativeCountHandler.process()}static async process(t){await new P2PDownloadUsageCumulativeCountHandler({content:t}).process()}}class TrackerStateRecordHandler extends flow_1.AbstractFlow{async process(){await this._updateMetrics(),await this._exportMetrics()}async _updateMetrics(){var t=this._content,e=stats_1.MetricsStatsHolder.tracker;e.peerID=t.peerID,e.isAvailable=t.isAvailable}async _exportMetrics(){await exporter_1.ExportP2SPSystemStateHandler.process()}static async process(t){await new TrackerStateRecordHandler({content:t}).process()}}class NodeStateRecordHandler extends flow_1.AbstractFlow{async process(){await this._updateMetrics(),await this._exportMetrics()}async _updateMetrics(){var t=this._content,e=stats_1.MetricsStatsHolder.node;e.peerID=t.peerID,e.isAvailable=t.isAvailable}async _exportMetrics(){await exporter_1.ExportP2SPSystemStateHandler.process()}static async process(t){await new NodeStateRecordHandler({content:t}).process()}}class SwarmStateRecordHandler extends flow_1.AbstractFlow{async process(){await this._updateMetrics(),await this._exportMetrics()}async _updateMetrics(){var t=this._content,e=stats_1.MetricsStatsHolder.swarms[t.swarmID];e?e.isAvailable=t.isAvailable:stats_1.MetricsStatsHolder.setupSwarm(t)}async _exportMetrics(){await exporter_1.ExportP2SPSystemStateHandler.process()}static async process(t){await new SwarmStateRecordHandler({content:t}).process()}}class UserStateRecordHandler extends flow_1.AbstractFlow{async process(){await this._updateMetrics(),await this._exportMetrics()}async _updateMetrics(){var t=this._content,e=stats_1.MetricsStatsHolder.swarms[t.swarmID];e&&(t.isAvailable?e.users[t.peerID]||stats_1.MetricsStatsHolder.setupUser(t):delete e.users[t.peerID])}async _exportMetrics(){await exporter_1.ExportP2SPSystemStateHandler.process()}static async process(t){await new UserStateRecordHandler({content:t}).process()}}class PurgeCDNRecordsHandler extends flow_1.AbstractFlow{async process(){await this._resetStats()}async _resetStats(){await stats_1.MetricsStatsHolder.resetMCDN()}static async process(t){await new PurgeCDNRecordsHandler({content:t}).process()}}class PruneMetricsStatsHandler extends flow_1.AbstractFlow{constructor(){super(...arguments),this._pruneTime=Date.now()-1e3*constant_1.MetricsConstant.DURATION_OF_RETAINED_DATA}async process(){await this._updateCDNs(),await this._updateOrigin(),await this._updateSwarms(),await this._updateSource()}async _updateCDNs(){for(const t of[...Object.values(stats_1.MetricsStatsHolder.cdns)])await this._pruneCDN(t),await this._pruneDomain(t)}async _updateOrigin(){var t=stats_1.MetricsStatsHolder.origin;await this._pruneDomain(t)}async _updateSwarms(){for(const t of Object.values(stats_1.MetricsStatsHolder.swarms))for(const e of Object.values(t.users))await this._pruneUser(e)}async _updateSource(){var t=stats_1.MetricsStatsHolder.source;await this._pruneSource(t)}async _pruneCDN(t){await this._pruneDataset(t.download.meanBandwidth),await this._pruneDataset(t.download.meanBandwidth.last),await this._pruneDataset(t.download.meanAvailability),await this._pruneDataset(t.download.meanAvailability.last),await this._pruneDataset(t.download.currentScore),await this._pruneDataset(t.download.currentScore.last)}async _pruneDomain(t){await this._pruneDataset(t.download.traffic),await this._pruneDataset(t.download.traffic.pulse),await this._pruneDataset(t.download.traffic.cumulation),await this._pruneDataset(t.download.bandwidth),await this._pruneDataset(t.download.bandwidth.wma),await this._pruneDataset(t.download.count.usage),await this._pruneDataset(t.download.count.usage.pulse),await this._pruneDataset(t.download.count.usage.cumulation),await this._pruneDataset(t.download.count.success),await this._pruneDataset(t.download.count.success.pulse),await this._pruneDataset(t.download.count.success.cumulation),await this._pruneDataset(t.download.count.failure),await this._pruneDataset(t.download.count.failure.pulse),await this._pruneDataset(t.download.count.failure.cumulation)}async _pruneUser(t){await this._pruneDataset(t.download.traffic),await this._pruneDataset(t.download.traffic.pulse),await this._pruneDataset(t.download.traffic.cumulation),await this._pruneDataset(t.download.bandwidth),await this._pruneDataset(t.download.bandwidth.wma),await this._pruneDataset(t.download.count.usage),await this._pruneDataset(t.download.count.usage.pulse),await this._pruneDataset(t.download.count.usage.cumulation)}async _pruneSource(t){await this._pruneRecords(t.http.download),await this._pruneRecords(t.p2p.download)}async _pruneRecords(t){t.records=data_1.DataTool.prune(t.records,this._pruneTime)}async _pruneDataset(t){t.dataset=data_1.DataTool.prune(t.dataset,this._pruneTime)}static async process(){await(new PruneMetricsStatsHandler).process()}}class MetricsCollectorHolder{static get instance(){return this._instance}static set instance(t){this._instance=t}static async emit(t,e){await this._instance.emit(t,e)}}exports.MetricsCollectorHolder=MetricsCollectorHolder;