"use strict";var __createBinding=this&&this.__createBinding||(Object.create?function(t,e,a,r){void 0===r&&(r=a);var s=Object.getOwnPropertyDescriptor(e,a);s&&("get"in s?e.__esModule:!s.writable&&!s.configurable)||(s={enumerable:!0,get:function(){return e[a]}}),Object.defineProperty(t,r,s)}:function(t,e,a,r){t[r=void 0===r?a:r]=e[a]}),__setModuleDefault=this&&this.__setModuleDefault||(Object.create?function(t,e){Object.defineProperty(t,"default",{enumerable:!0,value:e})}:function(t,e){t.default=e}),__importStar=this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var a in t)"default"!==a&&Object.prototype.hasOwnProperty.call(t,a)&&__createBinding(e,t,a);return __setModuleDefault(e,t),e};Object.defineProperty(exports,"__esModule",{value:!0}),exports.ReportSubmitterHolder=exports.ReportSubmitter=void 0;const future_1=require("@mlytics/core-ts/core/util/future"),logger_1=require("@mlytics/core-ts/core/util/logger"),flow_1=require("@mlytics/core-ts/utility/flow"),apis=__importStar(require("../../api")),flow_2=require("../../const/base/flow"),math_1=require("../../utility/math"),stats_1=require("../metrics/state/stats"),constant_1=require("./model/constant");class ReportSubmitter{constructor(){this._taskManager=new future_1.TaskManager}async activate(){await this._taskManager.activate(),await this._buildTasks()}async deactivate(){await this._taskManager.deactivate()}async _buildTasks(){await this._buildHandleHTTPDownloadAggregationTask(),await this._buildHandleP2PDownloadAggregationTask(),await this._buildHandleHTTPDownloadAggregationReportTask(),await this._buildHandleP2PDownloadAggregationReportTask()}async _buildHandleHTTPDownloadAggregationTask(){await this._taskManager.createCyclicTask(new HTTPDownloadAggregationDuty({name:ReportSubmitterTaskName.HANDLE_HTTP_DOWNLOAD_AGGREGATION,content:{cursors:new Map},sleepFirst:!0,sleepSeconds:60,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleP2PDownloadAggregationTask(){await this._taskManager.createCyclicTask(new P2PDownloadAggregationDuty({name:ReportSubmitterTaskName.HANDLE_P2P_DOWNLOAD_AGGREGATION,content:{cursor:{data:void 0}},sleepFirst:!0,sleepSeconds:60,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleHTTPDownloadAggregationReportTask(){await this._taskManager.createCyclicTask(new HTTPDownloadAggregationReportDuty({name:ReportSubmitterTaskName.HANDLE_HTTP_DOWNLOAD_AGGREGATION_REPORT,content:{cursor:{data:void 0}},loopPretasks:[this._taskManager.cueCyclicTask(ReportSubmitterTaskName.HANDLE_HTTP_DOWNLOAD_AGGREGATION)],sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1}))}async _buildHandleP2PDownloadAggregationReportTask(){await this._taskManager.createCyclicTask(new P2PDownloadAggregationReportDuty({name:ReportSubmitterTaskName.HANDLE_P2P_DOWNLOAD_AGGREGATION_REPORT,content:{cursor:{data:void 0}},loopPretasks:[this._taskManager.cueCyclicTask(ReportSubmitterTaskName.HANDLE_P2P_DOWNLOAD_AGGREGATION)],sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1}))}}exports.ReportSubmitter=ReportSubmitter;class ReportSubmitterTaskName{}ReportSubmitterTaskName.HANDLE_HTTP_DOWNLOAD_AGGREGATION="report submitter: handle http download aggregation",ReportSubmitterTaskName.HANDLE_P2P_DOWNLOAD_AGGREGATION="report submitter: handle p2p download aggregation",ReportSubmitterTaskName.HANDLE_HTTP_DOWNLOAD_AGGREGATION_REPORT="report submitter: handle http download aggregation report",ReportSubmitterTaskName.HANDLE_P2P_DOWNLOAD_AGGREGATION_REPORT="report submitter: handle p2p download aggregation report";class HTTPDownloadAggregationDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await HTTPDownloadAggregationHandler.process(this._options.content)}}class P2PDownloadAggregationDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await P2PDownloadAggregationHandler.process(this._options.content)}}class HTTPDownloadAggregationReportDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await this._report()}async onCancel(){await this._report()}async _report(){await HTTPDownloadAggregationReportHandler.process(this._options.content)}}class P2PDownloadAggregationReportDuty extends future_1.CyclicDuty{constructor(t){super(t),this._options=t}async callee(){await this._report()}async onCancel(){await this._report()}async _report(){await P2PDownloadAggregationReportHandler.process(this._options.content)}}class HTTPDownloadAggregationHandler extends flow_1.AbstractFlow{constructor(){super(...arguments),this._ctime=Date.now()}async process(){await this._iterateMetrics(async()=>{await this._ensureCursor(),await this._intakeIndex(),await this._intakeResult(),await this._updateUsage(),await this._updateSuccess(),await this._updateFailure(),await this._updateTraffic(),await this._updateBandwidth(),await this._updateReports(),await this._updateCursor()})}async _iterateMetrics(t){for(const e of[...Object.values(stats_1.MetricsStatsHolder.cdns),stats_1.MetricsStatsHolder.origin])await this._expose(flow_2.FlowKey.METRICS,e),await t(),await this._remove(flow_2.FlowKey.METRICS,flow_2.FlowKey.INDEX,flow_2.FlowKey.RESULT)}async _ensureCursor(){var t=this._require(flow_2.FlowKey.METRICS);this._content.cursors.get(t.id)||this._content.cursors.set(t.id,{data:{usage:void 0,success:void 0,failure:void 0,traffic:void 0}})}async _intakeIndex(){var t=this._require(flow_2.FlowKey.METRICS),e=this._content.cursors.get(t.id),t={usage:this._selectIndex(t.download.count.usage.dataset,e.data.usage),success:this._selectIndex(t.download.count.success.dataset,e.data.success),failure:this._selectIndex(t.download.count.failure.dataset,e.data.failure),traffic:this._selectIndex(t.download.traffic.dataset,e.data.traffic)};await this._expose(flow_2.FlowKey.INDEX,t)}_selectIndex(e,a){let r=e.length;for(let t=e.length-1;0<=t&&e[t]!==a;t--)r=t;return r}async _intakeResult(){await this._expose(flow_2.FlowKey.RESULT,{usage:0,success:0,failure:0,traffic:0,bandwidth:0})}async _updateUsage(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.INDEX).usage,a=this._require(flow_2.FlowKey.RESULT),r=t.download.count.usage.dataset;for(let t=e;t<r.length;t++)a.usage+=r[t].value}async _updateSuccess(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.INDEX).success,a=this._require(flow_2.FlowKey.RESULT),r=t.download.count.success.dataset;for(let t=e;t<r.length;t++)a.success+=r[t].value}async _updateFailure(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.INDEX).failure,a=this._require(flow_2.FlowKey.RESULT),r=t.download.count.failure.dataset;for(let t=e;t<r.length;t++)a.failure+=r[t].value}async _updateTraffic(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.INDEX).traffic,a=this._require(flow_2.FlowKey.RESULT),r=t.download.traffic.dataset;for(let t=e;t<r.length;t++)a.traffic+=r[t].value}async _updateBandwidth(){var t=this._require(flow_2.FlowKey.METRICS),e=this._require(flow_2.FlowKey.RESULT),a=Date.now();const r=a-1e3*constant_1.ReportConstant.DURATION_OF_WMA_DATA;t=t.download.bandwidth.dataset.filter(t=>t.ctime>=r),await t.push({ctime:a,value:0}),a=math_1.MathCalculator.weightedAverage(t.map(t=>({offset:t.ctime-r,value:t.value})));e.bandwidth=Math.round(1e3*a)/1e3}async _updateReports(){var t,e,a=this._require(flow_2.FlowKey.RESULT);0<a.usage&&(e=this._require(flow_2.FlowKey.METRICS),await stats_1.MetricsStatsHolder.report.http.download.aggregation.reports.push({ctime:this._ctime,platformID:null!=(t=e.id)?t:constant_1.ReportConstant.FALLBACK_PLATFORM_ID,platformType:e.type,successCount:a.success,failureCount:a.failure,transferSize:a.traffic,bandwidth:a.bandwidth}))}async _updateCursor(){var t=this._require(flow_2.FlowKey.METRICS),e=t.download.count.usage.dataset,a=t.download.count.success.dataset,r=t.download.count.failure.dataset,s=t.download.traffic.dataset;await this._content.cursors.set(t.id,{data:{usage:e[e.length-1],success:a[a.length-1],failure:r[r.length-1],traffic:s[s.length-1]}})}static async process(t){await new HTTPDownloadAggregationHandler({content:t}).process()}}class P2PDownloadAggregationHandler extends flow_1.AbstractFlow{constructor(){super(...arguments),this._ctime=Date.now(),this._reports=new Map}async process(){await this._intakeIndex(),await this._iterateRecords(async()=>{await this._ensureReport(),await this._updateReport()}),await this._updateReports()}async _intakeIndex(){var e=stats_1.MetricsStatsHolder.source.p2p.download.records;let a=e.length;for(let t=e.length-1;0<=t&&e[t]!==this._content.cursor.data;t--)a=t;await this._expose(flow_2.FlowKey.INDEX,a)}async _iterateRecords(e){var a=stats_1.MetricsStatsHolder.source.p2p.download.records;for(let t=this._require(flow_2.FlowKey.INDEX);t<a.length;t++)await this._expose(flow_2.FlowKey.RECORD,a[t]),await e(),await this._remove(flow_2.FlowKey.RECORD)}async _ensureReport(){var t=this._require(flow_2.FlowKey.RECORD);this._reports.has(t.peerID)||this._reports.set(t.peerID,{ctime:this._ctime,targetPeerID:t.peerID,targetPeerType:t.peerType,successCount:0,failureCount:0,transferSize:0})}async _updateReport(){var t=this._require(flow_2.FlowKey.RECORD),e=this._reports.get(t.peerID),t=t.contentSize;e.successCount+=0<t?1:0,e.failureCount+=0<t?0:1,e.transferSize+=t}async _updateReports(){var t=stats_1.MetricsStatsHolder.source.p2p.download.records;await stats_1.MetricsStatsHolder.report.p2p.download.aggregation.reports.push(...this._reports.values()),this._content.cursor.data=t[t.length-1]}static async process(t){await new P2PDownloadAggregationHandler({content:t}).process()}}class HTTPDownloadAggregationReportHandler extends flow_1.AbstractFlow{constructor(){super(...arguments),this._reports=new Array}async process(){for(await this._intakeIndex(),await this._injectReports();this._shouldSubmit;)await this._submitReports()}async _intakeIndex(){var e=stats_1.MetricsStatsHolder.report.http.download.aggregation.reports;let a=e.length;for(let t=e.length-1;0<=t&&e[t]!==this._content.cursor.data;t--)a=t;await this._expose(flow_2.FlowKey.INDEX,a)}async _injectReports(){var t=stats_1.MetricsStatsHolder.report.http.download.aggregation.reports,e=this._require(flow_2.FlowKey.INDEX);this._reports.push(...t.slice(e)),this._content.cursor.data=t[t.length-1]}get _shouldSubmit(){return 0<this._reports.length}async _submitReports(){const e=this._reports.slice(0,constant_1.ReportConstant.HTTP_DOWNLOAD_REPORT_BATCH_SIZE);await apis.MeteringAPICreateCDNDownloadAggregationHandler.process({reports:e.map(t=>({time:t.ctime,platformID:t.platformID,platformType:t.platformType,successCount:t.successCount,failureCount:t.failureCount,transferSize:t.transferSize,bandwidth:t.bandwidth}))}).catch(async t=>{await logger_1.Logger.debug("Submit reports failed.",{reports:e},{error:t})}).finally(async()=>{this._reports=this._reports.slice(constant_1.ReportConstant.HTTP_DOWNLOAD_REPORT_BATCH_SIZE)})}static async process(t){await new HTTPDownloadAggregationReportHandler({content:t}).process()}}class P2PDownloadAggregationReportHandler extends flow_1.AbstractFlow{constructor(){super(...arguments),this._reports=new Array}async process(){for(await this._intakeIndex(),await this._injectReports();this._shouldSubmit;)await this._submitReports()}async _intakeIndex(){var e=stats_1.MetricsStatsHolder.report.p2p.download.aggregation.reports;let a=e.length;for(let t=e.length-1;0<=t&&e[t]!==this._content.cursor.data;t--)a=t;await this._expose(flow_2.FlowKey.INDEX,a)}async _injectReports(){var t=stats_1.MetricsStatsHolder.report.p2p.download.aggregation.reports,e=this._require(flow_2.FlowKey.INDEX);this._reports.push(...t.slice(e)),this._content.cursor.data=t[t.length-1]}get _shouldSubmit(){return 0<this._reports.length}async _submitReports(){const e=this._reports.slice(0,constant_1.ReportConstant.P2P_DOWNLOAD_REPORT_BATCH_SIZE);await apis.MeteringAPICreateP2PDownloadAggregationHandler.process({reports:e.map(t=>({time:t.ctime,targetPeerID:t.targetPeerID,targetPeerType:t.targetPeerType,successCount:t.successCount,failureCount:t.failureCount,transferSize:t.transferSize}))}).catch(async t=>{await logger_1.Logger.debug("Submit reports failed.",{reports:e},{error:t})}).finally(async()=>{this._reports=this._reports.slice(constant_1.ReportConstant.P2P_DOWNLOAD_REPORT_BATCH_SIZE)})}static async process(t){await new P2PDownloadAggregationReportHandler({content:t}).process()}}class ReportSubmitterHolder{static get instance(){return this._instance}static set instance(t){this._instance=t}}exports.ReportSubmitterHolder=ReportSubmitterHolder;