"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.MCDNDownloadRecorder=void 0;const flow_1=require("@mlytics/core-ts/utility/flow"),flow_2=require("../../const/base/flow"),mcdn_1=require("../../const/service/mcdn"),collector_1=require("../../infra/metrics/collector"),constant_1=require("../../infra/metrics/model/constant"),stats_1=require("../../infra/metrics/state/stats"),math_1=require("../../utility/math"),constant_2=require("./model/constant"),stats_2=require("./state/stats");class MCDNDownloadRecorder extends flow_1.AbstractFlow{async process(){await this._intakeHTTPDownloadRecord(),await this._forwardHTTPDownloadRecord(),this._shouldUpdateCDNStats&&(await this._intakeCDNStats(),await this._updateCDNBandwidth(),await this._updateCDNMeanBandwidth(),await this._updateCDNMeanAvailability(),await this._updateCDNCurrentScore(),await this._forwardCDNDownloadRecord())}async _intakeHTTPDownloadRecord(){var t=new HTTPDownloadRecordBuilder(this._content).build();await this._expose(flow_2.FlowKey.RECORD,t)}async _forwardHTTPDownloadRecord(){var t=this._require(flow_2.FlowKey.RECORD);await collector_1.MetricsCollectorHolder.emit(collector_1.MetricsCollectorEvent.HTTP_DOWNLOAD_RECORD,t)}get _shouldUpdateCDNStats(){return this._require(flow_2.FlowKey.RECORD).kind===mcdn_1.DomainKind.CDN}async _intakeCDNStats(){var t=this._require(flow_2.FlowKey.RECORD);this._cdn=stats_2.MCDNStatsHolder.cdns.get(t.id)}async _updateCDNBandwidth(){var t=this._require(flow_2.FlowKey.RECORD);t.bandwidth&&(stats_2.MCDNStatsHolder.networkBandwidth=Math.max(constant_2.MCDNConstant.QUALIFIED_DOWNLOAD_BANDWIDTH,(stats_2.MCDNStatsHolder.networkBandwidth+t.bandwidth)/2))}async _updateCDNMeanBandwidth(){this._require(flow_2.FlowKey.RECORD).bandwidth&&await MeanBandwidthCalculator.process({cdn:this._cdn})}async _updateCDNMeanAvailability(){await MeanAvailabilityCalculator.process({cdn:this._cdn})}async _updateCDNCurrentScore(){await CurrentScoreCalculator.process({cdn:this._cdn})}async _forwardCDNDownloadRecord(){await collector_1.MetricsCollectorHolder.emit(collector_1.MetricsCollectorEvent.CDN_DOWNLOAD_RECORD,{id:this._cdn.id,name:this._cdn.name,kind:this._cdn.kind,type:this._cdn.type,domain:this._cdn.domain,ctime:Date.now(),meanBandwidth:this._cdn.meanBandwidth,meanAvailability:this._cdn.meanAvailability,currentScore:this._cdn.currentScore})}static async process(t){await new MCDNDownloadRecorder({content:t}).process()}}exports.MCDNDownloadRecorder=MCDNDownloadRecorder;class HTTPDownloadRecordBuilder{constructor(t){this._options=t,this._initialize()}build(){return this._content}_initialize(){this._setContent(),this._setContentSize(),this._setElapsedTime(),this._setIsOutlier(),this._setBandwidth()}_setContent(){var t,e=this._options;this._content={id:e.source.id,name:e.source.name,kind:e.source.kind,type:e.source.type,domain:e.source.domain,ctime:Date.now(),totalSize:e.resource.total,contentType:e.resource.type,startTime:e.startTime,isAborted:e.aborter.signal.aborted,isSuccess:null==e.error,isComplete:e.resource.isComplete,swarmID:e.resource.swarmID,swarmURI:e.resource.swarmURI,sourceURI:e.resource.sourceURI,requestURI:e.requestURI,responseCode:null==(t=e.payload)?void 0:t.status,errorMessage:null==(t=e.error)?void 0:t.message}}_setContentSize(){var t=this._options;this._content.contentSize=t.resource.size-t.startSize}_setElapsedTime(){var t,e=this._options.measurement;this._content.isSuccess&&(t=e.responseEnd,e=0!==e.requestStart?e.requestStart:e.startTime,this._content.elapsedTime=t-e)}_setIsOutlier(){this._content.isOutlier=this._content.contentSize<constant_2.MCDNConstant.MIN_SIZE_FOR_BANDWIDTH_MEASUREMENT}_setBandwidth(){this._content.isSuccess&&!this._content.isOutlier&&(this._content.bandwidth=this._content.contentSize/(this._content.elapsedTime/1e3))}}class MeanBandwidthCalculator extends flow_1.AbstractFlow{constructor(t){super(t),this._cdn=t.content.cdn}async process(){await this._intakeResult(),await this._updateCDN()}async _intakeResult(){var t=stats_1.MetricsStatsHolder.cdns[this._cdn.id].download.bandwidth.dataset;let e=Date.now()-1e3*constant_1.MetricsConstant.DURATION_OF_RETAINED_DATA;0<t.length&&(e=Math.min(t[0].ctime,e));t=math_1.MathCalculator.weightedAverage(t.map(t=>({offset:t.ctime-e,value:t.value})));await this._expose(flow_2.FlowKey.RESULT,t)}async _updateCDN(){var t=this._require(flow_2.FlowKey.RESULT);this._cdn.meanBandwidth=t}static async process(t){await new MeanBandwidthCalculator({content:t}).process()}}class MeanAvailabilityCalculator extends flow_1.AbstractFlow{constructor(t){super(t),this._cdn=t.content.cdn}async process(){await this._intakeResult(),await this._updateCDN()}async _intakeResult(){var t=stats_1.MetricsStatsHolder.cdns[this._cdn.id].download.outcome.dataset;let e=Date.now()-1e3*constant_1.MetricsConstant.DURATION_OF_RETAINED_DATA;0<t.length&&(e=Math.min(t[0].ctime,e));t=math_1.MathCalculator.weightedAverage(t.map(t=>({offset:t.ctime-e,value:t.value})));await this._expose(flow_2.FlowKey.RESULT,t)}async _updateCDN(){var t=this._require(flow_2.FlowKey.RESULT);this._cdn.meanAvailability=t}static async process(t){await new MeanAvailabilityCalculator({content:t}).process()}}class CurrentScoreCalculator extends flow_1.AbstractFlow{constructor(t){super(t),this._cdn=t.content.cdn,this._scoreParts={}}async process(){await this._scoreBandwidth(),await this._scoreAvailability(),await this._updateCDN()}async _scoreBandwidth(){let t=1;0<stats_1.MetricsStatsHolder.cdns[this._cdn.id].download.bandwidth.dataset.length&&(t=Math.min(this._cdn.meanBandwidth/stats_2.MCDNStatsHolder.networkBandwidth,1)),this._scoreParts.bandwidth=t}async _scoreAvailability(){var t=Math.pow(this._cdn.meanAvailability,constant_2.MCDNConstant.PENALTY_POWER_OF_AVAILABILITY);this._scoreParts.availability=t}async _updateCDN(){var t=this._cdn.currentScore,e=this._scoreParts.bandwidth*this._scoreParts.availability;this._cdn.currentScore=(t+e)/2}static async process(t){await new CurrentScoreCalculator({content:t}).process()}}