"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.MCDNSelector=void 0;const random_1=require("@mlytics/core-ts/core/tool/random"),queue_1=require("@mlytics/core-ts/core/util/queue"),flow_1=require("@mlytics/core-ts/utility/flow"),flow_2=require("../../const/base/flow"),mcdn_1=require("../../const/service/mcdn"),resource_1=require("../../const/service/resource"),constant_1=require("./model/constant"),stats_1=require("./state/stats");class MCDNSelector extends flow_1.AbstractFlow{async process(){return await this._intakeResult(),await this._injectOrigin(),await this._intakeOutcome(),this._outcome}async _intakeResult(){let e;e=this._isUrgentResource?await CDNsBasedOnHighScoreGroupHandler.process():await CDNsBasedOnOverallScoresHandler.process(),await this._expose(flow_2.FlowKey.RESULT,e)}get _isUrgentResource(){return this._content.resource.priority<resource_1.ResourceConstant.URGENT_THRESHOLD_PRIORITY}async _injectOrigin(){var e=this._require(flow_2.FlowKey.RESULT),t=this._content.resource,s=new URL(t.uri).host;for(const r of e)if(r.domain===s)return;await e.push({kind:mcdn_1.DomainKind.ORIGIN,type:mcdn_1.DomainType.FALLBACK,domain:s})}async _intakeOutcome(){this._outcome=this._require(flow_2.FlowKey.RESULT)}static async process(e){return new MCDNSelector({content:e}).process()}}exports.MCDNSelector=MCDNSelector;class CDNsBasedOnHighScoreGroupHandler extends flow_1.AbstractFlow{async process(){return await this._intakeThreshold(),await this._intakeCDNs(),await this._intakeResult(),await this._injectOthers(),await this._intakeOutcome(),this._outcome}async _intakeThreshold(){let t=0;await[...stats_1.MCDNStatsHolder.cdns.values()].forEach(e=>{e.currentScore>=t&&(t=e.currentScore)});var e=t-constant_1.MCDNConstant.MAX_ACCEPTABLE_SCORE_DIFFERENCE;await this._expose(flow_2.FlowKey.THRESHOLD,e)}async _intakeCDNs(){var e=[...stats_1.MCDNStatsHolder.cdns.values()],t=this._require(flow_2.FlowKey.THRESHOLD);this._primeCDNs=new Array,this._otherCDNs=new Array;for(const s of e)s.isEnabled&&(s.currentScore>=t?this._primeCDNs:this._otherCDNs).push(s)}async _intakeResult(){var e=await RandomlySelectCDNsHandler.process({cdns:[...this._primeCDNs],cdnScoreGetter:e=>e.overallScore});await this._expose(flow_2.FlowKey.RESULT,e)}async _injectOthers(){var e=await this._require(flow_2.FlowKey.RESULT),t=await RandomlySelectCDNsHandler.process({cdns:[...this._otherCDNs],cdnScoreGetter:e=>e.overallScore});await e.push(...t)}async _intakeOutcome(){this._outcome=this._require(flow_2.FlowKey.RESULT)}static async process(){return(new CDNsBasedOnHighScoreGroupHandler).process()}}class CDNsBasedOnOverallScoresHandler extends flow_1.AbstractFlow{async process(){return await this._intakeCDNs(),await this._intakeResult(),await this._intakeOutcome(),this._outcome}async _intakeCDNs(){this._cdns=[...stats_1.MCDNStatsHolder.cdns.values()].filter(e=>e.isEnabled)}async _intakeResult(){var e=await RandomlySelectCDNsHandler.process({cdns:[...this._cdns],cdnScoreGetter:e=>e.overallScore});await this._expose(flow_2.FlowKey.RESULT,e)}async _intakeOutcome(){this._outcome=this._require(flow_2.FlowKey.RESULT)}static async process(){return(new CDNsBasedOnOverallScoresHandler).process()}}class RandomlySelectCDNsHandler extends flow_1.AbstractFlow{constructor(e){super(e),this._cdns=random_1.RandomTool.shuffle(e.content.cdns),this._cdnScoreGetter=e.content.cdnScoreGetter}async process(){return await this._intakeCDNs(),await this._intakeResult(),await this._repeatRandomSelection(async()=>{await this._intakeThresholdScore(),await this._injectSelectedCDN()}),await this._injectRemainedCDNs(),await this._intakeOutcome(),this._outcome}async _intakeCDNs(){this._primeCDNs=queue_1.Deque.make(),this._otherCDNs=queue_1.Deque.make();for(const e of this._cdns)(0<this._cdnScoreGetter(e)?this._primeCDNs:this._otherCDNs).push(e)}async _intakeResult(){var e=new Array;await this._expose(flow_2.FlowKey.RESULT,e)}async _repeatRandomSelection(e){for(;0<this._primeCDNs.size;)await e(),await this._remove(flow_2.FlowKey.THRESHOLD)}async _intakeThresholdScore(){let e=0;for(const s of this._primeCDNs)e+=this._cdnScoreGetter(s);var t=e*Math.random();await this._expose(flow_2.FlowKey.THRESHOLD,t)}async _injectSelectedCDN(){var e=this._require(flow_2.FlowKey.RESULT);let t=this._require(flow_2.FlowKey.THRESHOLD);for(const s of this._primeCDNs.iterator())if((t-=this._cdnScoreGetter(s.value))<0){e.push(s.value),s.drop();break}}async _injectRemainedCDNs(){await this._require(flow_2.FlowKey.RESULT).push(...this._otherCDNs)}async _intakeOutcome(){this._outcome=this._require(flow_2.FlowKey.RESULT)}static async process(e){return new RandomlySelectCDNsHandler({content:e}).process()}}