"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.MCDNDownloaderProxy=exports.AbstractHttpDownloaderProxy=exports.AbstractDownloaderProxy=exports.AbstractDownloaderAgent=exports.BaseDownloaderProxyName=void 0;const http_1=require("@mlytics/core-ts/core/.const/http"),error_1=require("@mlytics/core-ts/core/util/error"),logger_1=require("@mlytics/core-ts/core/util/logger"),queue_1=require("@mlytics/core-ts/core/util/queue"),abctrl_1=require("@mlytics/core-ts/native/abctrl"),perf_1=require("@mlytics/core-ts/native/perf"),requester_1=require("@mlytics/core-ts/utility/requester"),settings_1=require("../../../config/settings"),code_1=require("../../../const/base/code"),mcdn_1=require("../../../const/service/mcdn"),recorder_1=require("../../../servant/mcdn/recorder"),selector_1=require("../../../servant/mcdn/selector"),loader_1=require("./base/loader");class BaseDownloaderProxyName{}(exports.BaseDownloaderProxyName=BaseDownloaderProxyName).HTTP="http";class AbstractDownloaderAgent{makeProxyClasses(){var e=this._proxyNames,r=new Array;for(const s of e){var t=this._proxyClasses.get(s);t&&r.push(t)}return r}}exports.AbstractDownloaderAgent=AbstractDownloaderAgent;class AbstractDownloaderProxy extends loader_1.AbstractDownloader{async fetch(){await this._setup(),await super.fetch()}async _beforeFetch(){this._resource.ptime.reset()}async _afterFetch(){this._isComplete&&this._resource.ptime.stamp()}}class AbstractHttpDownloaderProxy extends(exports.AbstractDownloaderProxy=AbstractDownloaderProxy){constructor(e){super(e),this._resource=e,this._aborter=new abctrl_1.AbortController,this._requestURI=this._resource.uri}async _fetching(){switch(await this._buildAborter(),await this._buildPayload(),this._responseStatus){case 200:await this._handleEntireContent();break;case 206:await this._handlePartialContent();break;default:await this._handleInvalidContent()}}get _responseStatus(){return this._payload.status}async _buildAborter(){this._aborter=new abctrl_1.AbortController}async _buildPayload(){this._payload=await requester_1.Requester.get(this._requestURI,{headers:{[http_1.HTTPHeader.RANGE]:`bytes=${this._resource.size}-`},aborter:this._aborter,timeout:settings_1.kernelSettings.download.httpResponseTimeout}).catch(async e=>{throw new error_1.InternalError(code_1.MessageCode.ESC010,e)})}async _handleEntireContent(){await this._concatResourceChunk(!1),await this._updateResourceType(),await this._updateResourceTotal()}async _handlePartialContent(){await this._concatResourceChunk(!0),await this._updateResourceType(),await this._updateResourceTotal()}async _handleInvalidContent(){throw new error_1.InternalError(code_1.MessageCode.ESC011,void 0,{payload:this._payload})}async _concatResourceChunk(e){let r=0;e&&(r=this._resource.size);for await(const t of this._payload.response.body)this._resource.concat({chunk:t,range:{start:r,end:r+t.length}}),r+=t.length}async _updateResourceType(){this._resource.type=this._payload.response.headers.get(http_1.HTTPHeader.CONTENT_TYPE).split(";")[0].toLowerCase()}async _updateResourceTotal(){this._resource.total=this._resource.size}async _abort(){await this._aborter.abort()}}class MCDNDownloaderProxy extends(exports.AbstractHttpDownloaderProxy=AbstractHttpDownloaderProxy){constructor(e){super(e),this._resource=e}async _setup(){await this._resetStates(),await this._checkStates(),await this._ensureSources(),await this._fetchSource(),await this._buildRequestURI()}async _resetStates(){this._error=null,this._startSize=this._resource.size,this._startTime=Date.now()}async _checkStates(){if(this._resource.isShareable&&this._isWithinStartDelay)throw new error_1.InternalError(code_1.MessageCode.ESC012)}get _isWithinStartDelay(){var e=this._resource.startDelay;return!this._resource.ctime.stamp().hasElapsedTimeS(e)}async _ensureSources(){var e;this._sources&&0!==this._sources.size||(e=await selector_1.MCDNSelector.process({resource:this._resource}),this._sources=queue_1.Queue.from(e))}async _fetchSource(){this._source=this._sources.pull()}async _buildRequestURI(){var e=new URL(this._resource.uri);e.host=this._source.domain,e.searchParams.set(mcdn_1.QueryStringKey.VIA_MLYSDK,"1"),this._requestURI=e.href}async _fetching(){await super._fetching().catch(async e=>{var r=this._resource;if(await logger_1.Logger.debug("MCDN downloader proxy fetch failed.",{resource:r},{error:e}),this._error=e,!this._shouldRetry)throw e}).finally(async()=>{await this._buildMeasurement(),await this._recordDownload(),await this._clearPerformance()})}get _shouldRetry(){return!this._resource.isComplete&&0<this._sources.size}async _buildMeasurement(){var e=perf_1.performance.getEntriesByName(this._requestURI).pop();this._measurement=e}async _recordDownload(){await recorder_1.MCDNDownloadRecorder.process({source:this._source,resource:this._resource,payload:this._payload,error:this._error,aborter:this._aborter,requestURI:this._requestURI,startSize:this._startSize,startTime:this._startTime,measurement:this._measurement})}async _clearPerformance(){await perf_1.performance.clearResourceTimings()}}exports.MCDNDownloaderProxy=MCDNDownloaderProxy;