"use strict";var __importDefault=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.PeerEvent=exports.PeerBrokerID=exports.PeerBrokerInfo=exports.PeerBroker=void 0;const emittery_1=__importDefault(require("emittery")),future_1=require("@mlytics/core-ts/core/util/future"),buffer_1=require("@mlytics/core-ts/native/buffer"),webrtc_1=require("@mlytics/core-ts/native/webrtc"),settings_1=require("../../../../core/config/settings"),broker_1=require("../../base/broker/broker");class PeerBroker{constructor(){this._condition=new future_1.Condition,this._eventHub=new future_1.ChannelHub,this._messageHub=new future_1.ChannelHub,this._deliverChannel=new future_1.Channel,this._receiveChannel=new future_1.Channel,this._info=new PeerBrokerInfo}get info(){return this._info}get condition(){return this._condition}get eventHub(){return this._eventHub}get messageHub(){return this._messageHub}get deliverChannel(){return this._deliverChannel}get receiveChannel(){return this._receiveChannel}get isActivated(){return!this._client.state.isDestroyed}get isConnected(){return this._client.state.isConnected}get isSendable(){return 0===this._client.bufferedAmount}get isAvailable(){return this._client.state.isConnected&&this._condition.isDone}async activate(){this._client=new PeerClient(settings_1.kernelSettings.webrtc.options),await this._bindEvents(),await this._openEventHub()}async deactivate(){await this._client.close(),await this._client.clearListeners(),await this._eventHub.close(),await this._messageHub.close(),await this._deliverChannel.close(),await this._receiveChannel.close()}async sendMessage(e){await this._client.send(e)}async commitMessage(e){await this._deliverChannel.deliver(e)}async createOffer(){return this._client.createOffer()}async createAnswer(){return this._client.createAnswer()}async commitOffer(e){await this._client.commitOffer(e)}async commitAnswer(e){await this._client.commitAnswer(e)}async addIceCandidate(e){await this._client.addIceCandidate(e)}async _bindEvents(){this._client.on(PeerEvent.ICE_NEGOTIATION,async()=>{await this._eventHub.deliver(PeerEvent.ICE_NEGOTIATION,void 0)}),this._client.on(PeerEvent.ICE_CANDIDATE,async e=>{await this._eventHub.deliver(PeerEvent.ICE_CANDIDATE,e.candidate)}),this._client.on(PeerEvent.ICE_SIGNALING,async e=>{await this._eventHub.deliver(PeerEvent.ICE_SIGNALING,e)}),this._client.on(PeerEvent.ICE_GATHERING,async e=>{await this._eventHub.deliver(PeerEvent.ICE_GATHERING,e)}),this._client.on(PeerEvent.ICE_CONNECTION,async e=>{await this._eventHub.deliver(PeerEvent.ICE_CONNECTION,e)}),this._client.on(PeerEvent.DATACHANNEL_OPEN,async()=>{await this._eventHub.deliver(PeerEvent.DATACHANNEL_OPEN,void 0)}),this._client.on(PeerEvent.DATACHANNEL_DATA,async e=>{await this._eventHub.deliver(PeerEvent.DATACHANNEL_DATA,e.data)}),this._client.on(PeerEvent.DATACHANNEL_ERROR,async()=>{await this._eventHub.deliver(PeerEvent.DATACHANNEL_ERROR,void 0)}),this._client.on(PeerEvent.DATACHANNEL_CLOSE,async()=>{await this._eventHub.deliver(PeerEvent.DATACHANNEL_CLOSE,void 0)}),this._client.on(PeerEvent.CONNECTION_CLOSED,async()=>{await this._eventHub.deliver(PeerEvent.CONNECTION_CLOSED,void 0)})}async _openEventHub(){await this._eventHub.connect(PeerEvent.ICE_NEGOTIATION),await this._eventHub.connect(PeerEvent.ICE_CANDIDATE),await this._eventHub.connect(PeerEvent.ICE_SIGNALING),await this._eventHub.connect(PeerEvent.ICE_GATHERING),await this._eventHub.connect(PeerEvent.ICE_CONNECTION),await this._eventHub.connect(PeerEvent.DATACHANNEL_OPEN),await this._eventHub.connect(PeerEvent.DATACHANNEL_DATA),await this._eventHub.connect(PeerEvent.DATACHANNEL_ERROR),await this._eventHub.connect(PeerEvent.DATACHANNEL_CLOSE),await this._eventHub.connect(PeerEvent.CONNECTION_CLOSED)}}exports.PeerBroker=PeerBroker;class PeerBrokerInfo extends broker_1.AbstractBrokerInfo{constructor(){super(...arguments),this._resourceStats=new Map}get id(){return this._peerID?PeerBrokerID.make(this._peerID,this._swarmID):null}get swarmID(){return this._swarmID}set swarmID(e){this._swarmID=e}get resourceStats(){return this._resourceStats}set resourceStats(e){this._resourceStats=e}}exports.PeerBrokerInfo=PeerBrokerInfo;class PeerBrokerID{static make(e,t){e=[e];return t&&e.unshift(t),e.join("::")}}exports.PeerBrokerID=PeerBrokerID;class PeerClient extends emittery_1.default{constructor(e){super(),this._options=e,this._state=new PeerState,this._connection=new webrtc_1.RTCPeerConnection(e),this._bindConnection()}get state(){return this._state}get bufferedAmount(){return this._dataChannel.bufferedAmount}async send(e){await this._dataChannel.send(buffer_1.Buffer.from(e))}async close(){var e;await this._connection.close(),await(null==(e=this._dataChannel)?void 0:e.close())}async createOffer(){await this._buildDataChannel();var e=await this._connection.createOffer();return await this._connection.setLocalDescription(e),e}async createAnswer(){var e=await this._connection.createAnswer();return await this._connection.setLocalDescription(e),e}async commitOffer(e){await this._connection.setRemoteDescription(e)}async commitAnswer(e){await this._connection.setRemoteDescription(e)}async addIceCandidate(e){await this._connection.addIceCandidate(e)}_bindConnection(){this._connection.onnegotiationneeded=async()=>{await this._onNegotiationNeeded()},this._connection.onicecandidate=async e=>{await this._onIceCandidate(e)},this._connection.onsignalingstatechange=async()=>{await this._onSignalingStateChange()},this._connection.onicegatheringstatechange=async()=>{await this._onIceGatheringStateChange()},this._connection.oniceconnectionstatechange=async()=>{await this._onIceConnectionStateChange()},this._connection.ondatachannel=async e=>{await this._onDataChannel(e)}}_bindDataChannel(){this._dataChannel.onopen=async()=>{await this._onDataChannelOpen()},this._dataChannel.onmessage=async e=>{await this._onDataChannelData(e)},this._dataChannel.onerror=async()=>{await this._onDataChannelError()},this._dataChannel.onclose=async()=>{await this._onDataChannelClose()}}async _buildDataChannel(){this._dataChannel=await this._connection.createDataChannel(PeerClient.DEFAULT_DATACHANNEL_NAME),await this._bindDataChannel()}async _onNegotiationNeeded(){await this.emit(PeerEvent.ICE_NEGOTIATION)}async _onIceCandidate(e){e.candidate&&await this.emit(PeerEvent.ICE_CANDIDATE,e)}async _onSignalingStateChange(){var e=this._connection.signalingState;await this.emit(PeerEvent.ICE_SIGNALING,e)}async _onIceGatheringStateChange(){var e=this._connection.iceGatheringState;await this.emit(PeerEvent.ICE_GATHERING,e)}async _onIceConnectionStateChange(){var e=this._connection.iceConnectionState;switch(await this.emit(PeerEvent.ICE_CONNECTION,e),e){case ICEConnectionState.DISCONNECTED:case ICEConnectionState.FAILED:await this.emit(PeerEvent.CONNECTION_CLOSED);break;case ICEConnectionState.CLOSED:await this._state.toDestroyed()}}async _onDataChannel(e){this._dataChannel=e.channel,await this._bindDataChannel()}async _onDataChannelOpen(){await this._state.toConnected(),await this.emit(PeerEvent.DATACHANNEL_OPEN)}async _onDataChannelData(e){await this.emit(PeerEvent.DATACHANNEL_DATA,e)}async _onDataChannelError(){await this.emit(PeerEvent.DATACHANNEL_ERROR)}async _onDataChannelClose(){await this.emit(PeerEvent.DATACHANNEL_CLOSE)}}PeerClient.DEFAULT_DATACHANNEL_NAME="datachannel";class WebRTCEvent{}WebRTCEvent.ICE_NEGOTIATION="ice_negotiation",WebRTCEvent.ICE_CANDIDATE="ice_candidate",WebRTCEvent.ICE_SIGNALING="ice_signaling",WebRTCEvent.ICE_GATHERING="ice_gathering",WebRTCEvent.ICE_CONNECTION="ice_connection",WebRTCEvent.DATACHANNEL_OPEN="datachannel_open",WebRTCEvent.DATACHANNEL_DATA="datachannel_data",WebRTCEvent.DATACHANNEL_ERROR="datachannel_error",WebRTCEvent.DATACHANNEL_CLOSE="datachannel_close";class PeerEvent extends WebRTCEvent{}(exports.PeerEvent=PeerEvent).CONNECTION_CLOSED="connection_closed";class ICEConnectionState{}ICEConnectionState.NEW="new",ICEConnectionState.CHECKING="checking",ICEConnectionState.CONNECTED="connected",ICEConnectionState.COMPLETED="completed",ICEConnectionState.DISCONNECTED="disconnected",ICEConnectionState.FAILED="failed",ICEConnectionState.CLOSED="closed";class PeerState{constructor(){this._name=PeerStateName.INITIAL}get isInitial(){return this._name===PeerStateName.INITIAL}get isConnected(){return this._name===PeerStateName.CONNECTED}get isDestroyed(){return this._name===PeerStateName.DESTROYED}toInitial(){this._name=PeerStateName.INITIAL}toConnected(){this._name=PeerStateName.CONNECTED}toDestroyed(){this._name=PeerStateName.DESTROYED}}class PeerStateName{}PeerStateName.INITIAL="initial",PeerStateName.CONNECTED="connected",PeerStateName.DESTROYED="destroyed";