"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.PeerDaemonTaskName=exports.PeerDaemonEvent=exports.AbstractPeerDaemon=void 0;const time_1=require("@mlytics/core-ts/core/tool/time"),error_1=require("@mlytics/core-ts/core/util/error"),future_1=require("@mlytics/core-ts/core/util/future"),logger_1=require("@mlytics/core-ts/core/util/logger"),code_1=require("../../../../../core/const/base/code"),client_1=require("../../../../../core/const/service/client"),blob_1=require("../../../../../core/utility/blob"),message_1=require("../../../../../protocol/client/utility/message/message"),daemon_1=require("../../../base/daemon/daemon"),constant_1=require("../../../base/daemon/process/model/constant"),broker_1=require("../../../tracker/broker/state/broker"),broker_2=require("../../broker/broker");class AbstractPeerDaemon extends daemon_1.AbstractDaemon{constructor(){super(...arguments),this._commands=new future_1.Channel,this._submissions=new future_1.ChannelHub}get broker(){return this._broker}async command(e){return await this._commands.deliver(e),this._submissions.extract(e.id,!0)}async _buildWaitToStartTask(){await this._taskManager.createCommonTask({name:PeerDaemonTaskName.WAIT_TO_START,callee:async()=>{await this._execWaitToStartTaskCallee()}})}async _execWaitToStartTaskCallee(){await broker_1.trackerBrokerPool.available(client_1.BrokerID.TRACKER)}async _buildListenIceNegotiationEventTask(){await this._taskManager.createCyclicTask({name:PeerDaemonTaskName.LISTEN_ICE_NEGOTIATION_EVENT,callee:async()=>{await this._execListenIceNegotiationEventTaskCallee()},sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenIceNegotiationEventTaskCallee(){await this._broker.eventHub.extract(broker_2.PeerEvent.ICE_NEGOTIATION);var e=this._broker.info.id;await logger_1.Logger.track("Peer ice negotiation event.",{brokerID:e})}async _buildListenIceCandidateEventTask(){await this._taskManager.createCyclicTask({name:PeerDaemonTaskName.LISTEN_ICE_CANDIDATE_EVENT,callee:async()=>{await this._execListenIceCandidateEventTaskCallee()},pretasks:[this._taskManager.cueTask(PeerDaemonTaskName.CONNECT_PEER)],sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenIceCandidateEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_2.PeerEvent.ICE_CANDIDATE),a=this._broker.info.peerID,t=this._broker.info.swarmID,r=this._broker.info.id;await logger_1.Logger.track("Peer ice candidate event.",{brokerID:r,ice:e}),await this._agent.operate({name:constant_1.BasePeerPipeName.LAUNCH_DELIVER_ICE_CANDIDATE,data:{brokerID:this._broker.info.id,content:{peerID:a,swarmID:t,ice:e}}})}async _buildListenIceSignalingEventTask(){await this._taskManager.createCyclicTask({name:PeerDaemonTaskName.LISTEN_ICE_SIGNALING_EVENT,callee:async()=>{await this._execListenIceSignalingEventTaskCallee()},sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenIceSignalingEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_2.PeerEvent.ICE_SIGNALING),a=this._broker.info.id;await logger_1.Logger.track("Peer ice signaling event.",{brokerID:a,state:e})}async _buildListenIceGatheringEventTask(){await this._taskManager.createCyclicTask({name:PeerDaemonTaskName.LISTEN_ICE_GATHERING_EVENT,callee:async()=>{await this._execListenIceGatheringEventTaskCallee()},sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenIceGatheringEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_2.PeerEvent.ICE_GATHERING),a=this._broker.info.id;await logger_1.Logger.track("Peer ice gathering event.",{brokerID:a,state:e})}async _buildListenIceConnectionEventTask(){await this._taskManager.createCyclicTask({name:PeerDaemonTaskName.LISTEN_ICE_CONNECTION_EVENT,callee:async()=>{await this._execListenIceConnectionEventTaskCallee()},sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenIceConnectionEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_2.PeerEvent.ICE_CONNECTION),a=this._broker.info.id;await logger_1.Logger.track("Peer ice connection event.",{brokerID:a,state:e})}async _buildListenDataChannelOpenEventTask(){await this._taskManager.createCommonTask({name:PeerDaemonTaskName.LISTEN_DATACHANNEL_OPEN_EVENT,callee:async()=>{await this._execListenDataChannelOpenEventTaskCallee()},pretasks:[this._taskManager.cueTask(PeerDaemonTaskName.CONNECT_PEER)],runningTimeout:10})}async _execListenDataChannelOpenEventTaskCallee(){await this._broker.eventHub.extract(broker_2.PeerEvent.DATACHANNEL_OPEN),await this._broker.condition.pass();var e=this._broker.info.id;await logger_1.Logger.track("Peer data channel open event.",{brokerID:e}),await this._recordEnabled(),await this.emit(PeerDaemonEvent.CONNECTED)}async _buildListenDataChannelDataEventTask(){await this._taskManager.createCyclicTask({name:PeerDaemonTaskName.LISTEN_DATACHANNEL_DATA_EVENT,callee:async()=>{await this._execListenDataChannelDataEventTaskCallee()},pretasks:[this._taskManager.cueTask(PeerDaemonTaskName.LISTEN_DATACHANNEL_OPEN_EVENT)],sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenDataChannelDataEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_2.PeerEvent.DATACHANNEL_DATA),e=new message_1.ProtocolMessage(await blob_1.BlobTool.toBuffer(e)),a=e.payload,t=this._broker.info.id,r=null==(r=a.header)?void 0:r.correlation_id;await logger_1.Logger.info("Peer payload received.",{brokerID:t,payload:a}),r?await this._broker.messageHub.deliver(r,e):await this._broker.receiveChannel.deliver(e)}async _buildListenDataChannelErrorEventTask(){await this._taskManager.createCyclicTask({name:PeerDaemonTaskName.LISTEN_DATACHANNEL_ERROR_EVENT,callee:async()=>{await this._execListenDataChannelErrorEventTaskCallee()},sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenDataChannelErrorEventTaskCallee(){await this._broker.eventHub.extract(broker_2.PeerEvent.DATACHANNEL_ERROR);var e=this._broker.info.id;await logger_1.Logger.warn("Peer data channel error event.",{brokerID:e})}async _buildListenDataChannelCloseEventTask(){await this._taskManager.createCommonTask({name:PeerDaemonTaskName.LISTEN_DATACHANNEL_CLOSE_EVENT,callee:async()=>{await this._execListenDataChannelCloseEventTaskCallee()}})}async _execListenDataChannelCloseEventTaskCallee(){await this._broker.eventHub.extract(broker_2.PeerEvent.DATACHANNEL_CLOSE);var e=this._broker.info.id;await logger_1.Logger.track("Peer data channel close event.",{brokerID:e})}async _buildListenConnectionClosedEventTask(){await this._taskManager.createCommonTask({name:PeerDaemonTaskName.LISTEN_CONNECTION_CLOSED_EVENT,callee:async()=>{await this._execListenConnectionClosedEventTaskCallee()}})}async _execListenConnectionClosedEventTaskCallee(){await this._broker.eventHub.extract(broker_2.PeerEvent.CONNECTION_CLOSED);var e=this._broker.info.id;throw await logger_1.Logger.track("Peer connection closed event.",{brokerID:e}),PeerDaemonError.BROKER_CLOSED}async _buildDeliverMessageTask(){await this._taskManager.createCyclicTask({name:PeerDaemonTaskName.DELIVER_MESSAGE,callee:async()=>{await this._execDeliverMessageTaskCallee()},pretasks:[this._taskManager.cueTask(PeerDaemonTaskName.LISTEN_DATACHANNEL_OPEN_EVENT)],sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execDeliverMessageTaskCallee(){for(var e=await this._broker.deliverChannel.extract();this._broker.isActivated;){if(this._broker.isConnected&&this._broker.isSendable)return void await this._broker.sendMessage(e);await time_1.TimeTool.sleepRandomly(.01)}}async _buildReceiveMessageTask(){await this._taskManager.createCyclicTask({name:PeerDaemonTaskName.RECEIVE_MESSAGE,callee:async()=>{await this._execReceiveMessageTaskCallee()},pretasks:[this._taskManager.cueTask(PeerDaemonTaskName.LISTEN_DATACHANNEL_OPEN_EVENT)],sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execReceiveMessageTaskCallee(){var e=await this._broker.messageHub.lostCenter.extract();await this._broker.receiveChannel.deliver(e)}async _buildProcessMessageTask(){await this._taskManager.createCyclicTask({name:PeerDaemonTaskName.PROCESS_MESSAGE,callee:async()=>{await this._execProcessMessageTaskCallee()},pretasks:[this._taskManager.cueTask(PeerDaemonTaskName.LISTEN_DATACHANNEL_OPEN_EVENT)],sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execProcessMessageTaskCallee(){var e=await this._broker.receiveChannel.extract(),a=e.payload,t=this._agent.findPipeName(a.action),r={id:null==(r=a.header)?void 0:r.correlation_id,brokerID:this._broker.info.id};if(t)try{await this._agent.operate({name:t,data:{...r,content:e}})}catch(e){await this._agent.operate({name:constant_1.BasePeerPipeName.LAUNCH_NOTIFY_EXCEPTION,data:{...r,content:{error:e}}})}else{t=new error_1.ValidationError(code_1.MessageCode.WSS002,void 0,{action:a.action});await this._agent.operate({name:constant_1.BasePeerPipeName.LAUNCH_NOTIFY_EXCEPTION,data:{...r,content:{error:t}}})}}async _buildProcessCommandTask(){await this._taskManager.createCyclicTask({name:PeerDaemonTaskName.PROCESS_COMMAND,callee:async()=>{await this._execProcessCommandTaskCallee()},pretasks:[this._taskManager.cueTask(PeerDaemonTaskName.LISTEN_DATACHANNEL_OPEN_EVENT)],sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execProcessCommandTaskCallee(){var a=await this._commands.extract(),e=a.name,t=this._broker.info.id;if(await logger_1.Logger.track("Peer command received.",{brokerID:t,command:a}),e)try{var r=await this._agent.operate({name:e,data:{id:a.id,brokerID:t,content:a.content}});await this._submissions.deliver(a.id,r)}catch(e){await this._submissions.caution(a.id,e)}else{e=new error_1.InternalError(code_1.MessageCode.ESS003,void 0,{command:a});await this._submissions.caution(a.id,e)}}async _buildExitProcessTask(){await this._taskManager.createCommonTask({name:PeerDaemonTaskName.EXIT_PROCESS,onClose:async()=>{await this._execExitProcessTaskOnClose()},pretasks:[...this._taskManager.cueAllTasks()],callbackTimeout:15})}async _execExitProcessTaskOnClose(){await this._broker.condition.deny(PeerDaemonError.DAEMON_EXITED),await this._recordDisabled(),await this.emit(PeerDaemonEvent.DISCONNECTED)}}exports.AbstractPeerDaemon=AbstractPeerDaemon;class PeerDaemonEvent{}(exports.PeerDaemonEvent=PeerDaemonEvent).CONNECTED="connected",PeerDaemonEvent.DISCONNECTED="disconnected";class PeerDaemonTaskName{}(exports.PeerDaemonTaskName=PeerDaemonTaskName).WAIT_TO_START="peer daemon: wait to start",PeerDaemonTaskName.CONNECT_PEER="peer daemon: connect peer",PeerDaemonTaskName.LISTEN_ICE_NEGOTIATION_EVENT="peer daemon: listen ice negotiation event",PeerDaemonTaskName.LISTEN_ICE_CANDIDATE_EVENT="peer daemon: listen ice candidate event",PeerDaemonTaskName.LISTEN_ICE_SIGNALING_EVENT="peer daemon: listen ice signaling event",PeerDaemonTaskName.LISTEN_ICE_GATHERING_EVENT="peer daemon: listen ice gathering event",PeerDaemonTaskName.LISTEN_ICE_CONNECTION_EVENT="peer daemon: listen ice connection event",PeerDaemonTaskName.LISTEN_DATACHANNEL_OPEN_EVENT="peer daemon: listen datachannel open event",PeerDaemonTaskName.LISTEN_DATACHANNEL_DATA_EVENT="peer daemon: listen datachannel data event",PeerDaemonTaskName.LISTEN_DATACHANNEL_ERROR_EVENT="peer daemon: listen datachannel error event",PeerDaemonTaskName.LISTEN_DATACHANNEL_CLOSE_EVENT="peer daemon: listen datachannel close event",PeerDaemonTaskName.LISTEN_CONNECTION_CLOSED_EVENT="peer daemon: listen connection closed event",PeerDaemonTaskName.DELIVER_MESSAGE="peer daemon: deliver message",PeerDaemonTaskName.RECEIVE_MESSAGE="peer daemon: receive message",PeerDaemonTaskName.PROCESS_MESSAGE="peer daemon: process message",PeerDaemonTaskName.PROCESS_COMMAND="peer daemon: process command",PeerDaemonTaskName.EXIT_PROCESS="peer daemon: exit process";class PeerDaemonError{}PeerDaemonError.BROKER_CLOSED=new error_1.InternalError(code_1.MessageCode.ESS000),PeerDaemonError.DAEMON_EXITED=new error_1.InternalError(code_1.MessageCode.ESS001);