"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.NodeDaemon=void 0;const client_1=require("../../../../../core/const/service/client"),p2sp_1=require("../../../../../core/const/service/p2sp"),collector_1=require("../../../../../core/infra/metrics/collector"),broker_1=require("../../broker/broker"),broker_2=require("../../broker/state/broker"),daemon_1=require("../base/daemon"),agent_1=require("../base/process/agent/agent"),constant_1=require("../base/process/model/constant"),daemon_2=require("../state/daemon");class NodeDaemon extends daemon_1.AbstractPeerDaemon{constructor(){super(),this._initialize()}_initialize(){this._agent=new agent_1.NodeAgent,this._broker=new broker_1.PeerBroker,this._broker.info.peerType=p2sp_1.PeerType.NODE}async _activate(){await this._broker.activate(),await this._taskManager.activate(),await this._storePool(),await this._buildTasks()}async _deactivate(){await this._broker.deactivate(),await this._taskManager.deactivate(),await this._commands.close(),await this._submissions.close(),await this._clearPool()}async _storePool(){await broker_2.peerBrokerPool.register(client_1.BrokerID.NODE,this._broker),await daemon_2.peerDaemonPool.register(client_1.DaemonID.NODE,this)}async _clearPool(){await broker_2.peerBrokerPool.deregister(client_1.BrokerID.NODE),await daemon_2.peerDaemonPool.deregister(client_1.DaemonID.NODE);var e=this._broker.info.id;e&&await broker_2.peerBrokerPool.deregister(e)}async _buildTasks(){await this._buildWaitToStartTask(),await this._buildConnectPeerTask(),await this._buildListenIceNegotiationEventTask(),await this._buildListenIceCandidateEventTask(),await this._buildListenIceSignalingEventTask(),await this._buildListenIceGatheringEventTask(),await this._buildListenIceConnectionEventTask(),await this._buildListenDataChannelOpenEventTask(),await this._buildListenDataChannelDataEventTask(),await this._buildListenDataChannelErrorEventTask(),await this._buildListenDataChannelCloseEventTask(),await this._buildListenConnectionClosedEventTask(),await this._buildDeliverMessageTask(),await this._buildReceiveMessageTask(),await this._buildProcessMessageTask(),await this._buildProcessCommandTask(),await this._buildReportHealthTask(),await this._buildExitProcessTask()}async _buildConnectPeerTask(){await this._taskManager.createCommonTask({name:daemon_1.PeerDaemonTaskName.CONNECT_PEER,callee:async()=>{await this._execConnectPeerTaskCallee()},onFinish:async()=>{await this._execConnectPeerTaskOnFinish()},pretasks:[this._taskManager.cueTask(daemon_1.PeerDaemonTaskName.WAIT_TO_START)],runningTimeout:10})}async _execConnectPeerTaskCallee(){await this._agent.operate({name:constant_1.NodePipeName.LAUNCH_CONNECT_NODE})}async _execConnectPeerTaskOnFinish(){await broker_2.peerBrokerPool.register(this._broker.info.id,this._broker)}async _buildReportHealthTask(){await this._taskManager.createCyclicTask({name:NodeDaemonTaskName.REPORT_HEALTH,callee:async()=>{await this._execReportHealthTaskCallee()},pretasks:[this._taskManager.cueTask(daemon_1.PeerDaemonTaskName.LISTEN_DATACHANNEL_OPEN_EVENT)],sleepFirst:!0,sleepSeconds:60,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execReportHealthTaskCallee(){await this._agent.operate({name:constant_1.NodePipeName.LAUNCH_REPORT_HEALTH})}async _recordEnabled(){await collector_1.MetricsCollectorHolder.emit(collector_1.MetricsCollectorEvent.NODE_STATE_RECORD,{peerID:this._broker.info.peerID,isAvailable:!0})}async _recordDisabled(){await collector_1.MetricsCollectorHolder.emit(collector_1.MetricsCollectorEvent.NODE_STATE_RECORD,{peerID:null,isAvailable:!1})}}exports.NodeDaemon=NodeDaemon;class NodeDaemonTaskName{}NodeDaemonTaskName.REPORT_HEALTH="node daemon: report health";