"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.UserDaemon=void 0;const collector_1=require("../../../../../core/infra/metrics/collector"),broker_1=require("../../broker/broker"),broker_2=require("../../broker/state/broker"),daemon_1=require("../base/daemon"),agent_1=require("../base/process/agent/agent"),constant_1=require("../base/process/model/constant"),daemon_2=require("../state/daemon");class UserDaemon extends daemon_1.AbstractPeerDaemon{constructor(e){super(),this._options=e,this._initialize()}_initialize(){this._agent=new agent_1.UserAgent,this._broker=new broker_1.PeerBroker,this._broker.info.peerID=this._options.peerID,this._broker.info.swarmID=this._options.swarmID}async _activate(){await this._broker.activate(),await this._taskManager.activate(),await this._storePool(),await this._buildTasks()}async _deactivate(){await this._broker.deactivate(),await this._taskManager.deactivate(),await this._commands.close(),await this._submissions.close(),await this._clearPool()}async _storePool(){await broker_2.peerBrokerPool.register(this._broker.info.id,this._broker),await daemon_2.peerDaemonPool.register(this._broker.info.id,this)}async _clearPool(){await broker_2.peerBrokerPool.deregister(this._broker.info.id),await daemon_2.peerDaemonPool.deregister(this._broker.info.id)}async _buildTasks(){await this._buildWaitToStartTask(),await this._buildConnectPeerTask(),await this._buildListenIceNegotiationEventTask(),await this._buildListenIceCandidateEventTask(),await this._buildListenIceSignalingEventTask(),await this._buildListenIceGatheringEventTask(),await this._buildListenIceConnectionEventTask(),await this._buildListenDataChannelOpenEventTask(),await this._buildListenDataChannelDataEventTask(),await this._buildListenDataChannelErrorEventTask(),await this._buildListenDataChannelCloseEventTask(),await this._buildListenConnectionClosedEventTask(),await this._buildDeliverMessageTask(),await this._buildReceiveMessageTask(),await this._buildProcessMessageTask(),await this._buildProcessCommandTask(),await this._buildExitProcessTask()}async _buildConnectPeerTask(){await this._taskManager.createCommonTask({name:daemon_1.PeerDaemonTaskName.CONNECT_PEER,callee:async()=>{await this._execConnectPeerTaskCallee()},pretasks:[this._taskManager.cueTask(daemon_1.PeerDaemonTaskName.WAIT_TO_START)],runningTimeout:10})}async _execConnectPeerTaskCallee(){var e=this._broker.info.id,a=this._options;a.offer?await this._agent.operate({name:constant_1.UserPipeName.HANDLE_CONNECT_USER,data:{id:a.flowID,brokerID:e,content:{peerID:a.peerID,swarmID:a.swarmID,offer:a.offer}}}):await this._agent.operate({name:constant_1.UserPipeName.LAUNCH_CONNECT_USER,data:{id:a.flowID,brokerID:e,content:{peerID:a.peerID,swarmID:a.swarmID}}})}async _recordEnabled(){await collector_1.MetricsCollectorHolder.emit(collector_1.MetricsCollectorEvent.USER_STATE_RECORD,{peerID:this._broker.info.peerID,swarmID:this._broker.info.swarmID,isAvailable:!0})}async _recordDisabled(){await collector_1.MetricsCollectorHolder.emit(collector_1.MetricsCollectorEvent.USER_STATE_RECORD,{peerID:this._broker.info.peerID,swarmID:this._broker.info.swarmID,isAvailable:!1})}}exports.UserDaemon=UserDaemon;