"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.SwarmDaemonTaskName=exports.SwarmDaemonEvent=exports.AbstractSwarmDaemon=void 0;const random_1=require("@mlytics/core-ts/core/tool/random"),error_1=require("@mlytics/core-ts/core/util/error"),future_1=require("@mlytics/core-ts/core/util/future"),logger_1=require("@mlytics/core-ts/core/util/logger"),queue_1=require("@mlytics/core-ts/core/util/queue"),code_1=require("../../../../../core/const/base/code"),client_1=require("../../../../../core/const/service/client"),daemon_1=require("../../../base/daemon/daemon"),broker_1=require("../../../peer/broker/broker"),broker_2=require("../../../tracker/broker/state/broker"),swarm_1=require("../../base/swarm"),constant_1=require("./process/model/constant");class AbstractSwarmDaemon extends daemon_1.AbstractDaemon{constructor(a){super(),this._options=a,this._commands=new future_1.Channel,this._submissions=new future_1.ChannelHub}get info(){return this._info}async command(a){return await this._commands.deliver(a),this._submissions.extract(a.id,!0)}async _buildWaitToStartTask(){await this._taskManager.createCommonTask({name:SwarmDaemonTaskName.WAIT_TO_START,callee:async()=>{await this._execWaitToStartTaskCallee()}})}async _execWaitToStartTaskCallee(){await broker_2.trackerBrokerPool.available(client_1.BrokerID.TRACKER)}async _buildJoinSwarmTask(){await this._taskManager.createCommonTask({name:SwarmDaemonTaskName.JOIN_SWARM,callee:async()=>{await this._execJoinSwarmTaskCallee()},onFinish:async()=>{await this._execJoinSwarmTaskOnFinish()},pretasks:[this._taskManager.cueTask(SwarmDaemonTaskName.WAIT_TO_START)]})}async _execJoinSwarmTaskCallee(){await this._agent.operate({name:constant_1.SwarmProcessPipeName.LAUNCH_JOIN_SWARM,data:{content:{swarmID:this._info.swarmID,swarmScore:swarm_1.SwarmScorer.give(this._info)}}})}async _execJoinSwarmTaskOnFinish(){await this._recordEnabled(),await this.emit(SwarmDaemonEvent.CONNECTED)}async _buildReportSwarmStatsTask(){await this._taskManager.createCyclicTask({name:SwarmDaemonTaskName.REPORT_SWARM_STATS,callee:async()=>{await this._execReportSwarmStatsCallee()},pretasks:[this._taskManager.cueTask(SwarmDaemonTaskName.JOIN_SWARM)],sleepFirst:!0,sleepSeconds:30,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execReportSwarmStatsCallee(){await this._agent.operate({name:constant_1.SwarmProcessPipeName.LAUNCH_REPORT_SWARM_STATS,data:{content:{swarmID:this._info.swarmID,swarmScore:swarm_1.SwarmScorer.give(this._info)}}})}async _buildObtainSwarmUsersTask(){await this._taskManager.createCyclicTask({name:SwarmDaemonTaskName.OBTAIN_SWARM_USERS,callee:async()=>{await this._execObtainSwarmUsersCallee()},pretasks:[this._taskManager.cueTask(SwarmDaemonTaskName.JOIN_SWARM)],sleepSeconds:30,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execObtainSwarmUsersCallee(){this._shouldObtainSwarmUsers&&await this._agent.operate({name:constant_1.SwarmProcessPipeName.LAUNCH_OBTAIN_SWARM_USERS,data:{content:{swarmID:this._info.swarmID}}}).then(async a=>{a=a.swarmUsers.map(a=>({peerID:a.peerID,swarmScore:a.swarmScore}));this._info.swarmUsers=queue_1.Queue.from(random_1.RandomTool.shuffle(a))})}get _shouldObtainSwarmUsers(){return!this._info.userManager.hasReachedMaxConnections}async _buildConnectSwarmUsersTask(){await this._taskManager.createCyclicTask({name:SwarmDaemonTaskName.CONNECT_SWARM_USERS,callee:async()=>{await this._execConnectSwarmUsersCallee()},pretasks:[this._taskManager.cueTask(SwarmDaemonTaskName.JOIN_SWARM)],loopPretasks:[this._taskManager.cueCyclicTask(SwarmDaemonTaskName.OBTAIN_SWARM_USERS)],sleepSeconds:20,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execConnectSwarmUsersCallee(){for(;this._shouldConnectSwarmUser;){var a=this._nextCandidateSwarmUser;a&&await this._agent.operate({name:constant_1.SwarmProcessPipeName.LAUNCH_CONNECT_SWARM_USER,data:{content:{info:this._info,peerID:a.peerID,swarmID:this._info.swarmID}}})}}get _shouldConnectSwarmUser(){return!this._info.userManager.hasReachedMaxConnections&&0<this._info.swarmUsers.size}get _nextCandidateSwarmUser(){var a=this._info.userManager,e=this._info.swarmUsers.pull(),s=broker_1.PeerBrokerID.make(e.peerID,this._info.swarmID);return a.isInUnavailableBrokerIDs(s)||a.isRegistered(s)?null:e}async _buildReportResourceStatsTask(){await this._taskManager.createCyclicTask({name:SwarmDaemonTaskName.REPORT_RESOURCE_STATS,callee:async()=>{await this._execReportResourceStatsCallee()},pretasks:[this._taskManager.cueTask(SwarmDaemonTaskName.JOIN_SWARM)],sleepSeconds:60,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execReportResourceStatsCallee(){this._shouldReportResourceStats&&await this._agent.operate({name:constant_1.SwarmProcessPipeName.LAUNCH_REPORT_RESOURCE_STATS,data:{content:{info:this._info}}})}get _shouldReportResourceStats(){return 0<this._info.userManager.size}async _buildProcessCommandTask(){await this._taskManager.createCyclicTask({name:SwarmDaemonTaskName.PROCESS_COMMAND,callee:async()=>{await this._execProcessCommandTaskCallee()},pretasks:[this._taskManager.cueTask(SwarmDaemonTaskName.JOIN_SWARM)],sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execProcessCommandTaskCallee(){var e=await this._commands.extract(),a=this._info.swarmID,s=e.name;if(await logger_1.Logger.track("Swarm command received.",{swarmID:a,command:e}),s)try{var r=await this._agent.operate({name:s,data:{id:e.id,content:e.content}});await this._submissions.deliver(e.id,r)}catch(a){await this._submissions.caution(e.id,a)}else{a=new error_1.InternalError(code_1.MessageCode.ESS011,void 0,{command:e});await this._submissions.caution(e.id,a)}}async _buildExitProcessTask(){await this._taskManager.createCommonTask({name:SwarmDaemonTaskName.EXIT_PROCESS,onClose:async()=>{await this._execExitProcessTaskOnClose()},pretasks:[...this._taskManager.cueAllTasks()],callbackTimeout:15})}async _execExitProcessTaskOnClose(){await this._agent.operate({name:constant_1.SwarmProcessPipeName.LAUNCH_LEAVE_SWARM,data:{content:{swarmID:this._info.swarmID}}}).finally(async()=>{await this._recordDisabled(),await this.emit(SwarmDaemonEvent.DISCONNECTED)})}}exports.AbstractSwarmDaemon=AbstractSwarmDaemon;class SwarmDaemonEvent{}(exports.SwarmDaemonEvent=SwarmDaemonEvent).CONNECTED="connected",SwarmDaemonEvent.DISCONNECTED="disconnected";class SwarmDaemonTaskName{}(exports.SwarmDaemonTaskName=SwarmDaemonTaskName).WAIT_TO_START="swarm daemon: wait to start",SwarmDaemonTaskName.JOIN_SWARM="swarm daemon: join swarm",SwarmDaemonTaskName.REPORT_SWARM_STATS="swarm daemon: report swarm stats",SwarmDaemonTaskName.OBTAIN_SWARM_USERS="swarm daemon: obtain swarm users",SwarmDaemonTaskName.CONNECT_SWARM_USERS="swarm daemon: connect swarm users",SwarmDaemonTaskName.REPORT_RESOURCE_STATS="swarm daemon: report resource stats",SwarmDaemonTaskName.PROCESS_COMMAND="swarm daemon: process command",SwarmDaemonTaskName.EXIT_PROCESS="swarm daemon: exit process";