"use strict";var __createBinding=this&&this.__createBinding||(Object.create?function(e,t,n,i){void 0===i&&(i=n);var r=Object.getOwnPropertyDescriptor(t,n);r&&("get"in r?t.__esModule:!r.writable&&!r.configurable)||(r={enumerable:!0,get:function(){return t[n]}}),Object.defineProperty(e,i,r)}:function(e,t,n,i){e[i=void 0===i?n:i]=t[n]}),__setModuleDefault=this&&this.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),__importStar=this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var n in e)"default"!==n&&Object.prototype.hasOwnProperty.call(e,n)&&__createBinding(t,e,n);return __setModuleDefault(t,e),t},__importDefault=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.TrackerEvent=exports.TrackerBrokerInfo=exports.TrackerBroker=void 0;const emittery_1=__importDefault(require("emittery")),future_1=require("@mlytics/core-ts/core/util/future"),buffer_1=require("@mlytics/core-ts/native/buffer"),websc_1=require("@mlytics/core-ts/native/websc"),apis=__importStar(require("../../../../core/api")),settings_1=require("../../../../core/config/settings"),broker_1=require("../../base/broker/broker"),centrifuge_1=require("./base/centrifuge/centrifuge"),constant_1=require("./base/centrifuge/model/constant");class TrackerBroker{constructor(e){this._uri=e,this._condition=new future_1.Condition,this._eventHub=new future_1.ChannelHub,this._messageHub=new future_1.ChannelHub,this._deliverChannel=new future_1.Channel,this._receiveChannel=new future_1.Channel,this._info=new TrackerBrokerInfo}get info(){return this._info}get condition(){return this._condition}get eventHub(){return this._eventHub}get messageHub(){return this._messageHub}get deliverChannel(){return this._deliverChannel}get receiveChannel(){return this._receiveChannel}get serverChannelID(){return this._client.serverChannelID}get isActivated(){return!this._client.state.isDestroyed}get isConnected(){return this._client.state.isConnected}get isAvailable(){return this._client.state.isConnected&&this._condition.isDone}async activate(){this._client=new TrackerClient(this._uri),await this._client.open(),await this._bindEvents(),await this._openEventHub()}async deactivate(){await this._client.close(),await this._client.clearListeners(),await this._eventHub.close(),await this._messageHub.close(),await this._deliverChannel.close(),await this._receiveChannel.close()}async sendMessage(e){await this._client.send(e)}async commitMessage(e){await this._deliverChannel.deliver(e)}async _bindEvents(){this._client.on(TrackerEvent.STATE,async e=>{await this._eventHub.deliver(TrackerEvent.STATE,e)}),this._client.on(TrackerEvent.CONNECTING,async e=>{await this._eventHub.deliver(TrackerEvent.CONNECTING,e)}),this._client.on(TrackerEvent.CONNECTED,async e=>{await this._eventHub.deliver(TrackerEvent.CONNECTED,e)}),this._client.on(TrackerEvent.DISCONNECTED,async e=>{await this._eventHub.deliver(TrackerEvent.DISCONNECTED,e)}),this._client.on(TrackerEvent.TERMINATED,async()=>{await this._eventHub.deliver(TrackerEvent.TERMINATED,void 0)}),this._client.on(TrackerEvent.SUBSCRIBING,async e=>{await this._eventHub.deliver(TrackerEvent.SUBSCRIBING,e)}),this._client.on(TrackerEvent.SUBSCRIBED,async e=>{await this._eventHub.deliver(TrackerEvent.SUBSCRIBED,e)}),this._client.on(TrackerEvent.UNSUBSCRIBED,async e=>{await this._eventHub.deliver(TrackerEvent.UNSUBSCRIBED,e)}),this._client.on(TrackerEvent.JOIN,async e=>{await this._eventHub.deliver(TrackerEvent.JOIN,e)}),this._client.on(TrackerEvent.LEAVE,async e=>{await this._eventHub.deliver(TrackerEvent.LEAVE,e)}),this._client.on(TrackerEvent.SERVER_DATA,async e=>{await this._eventHub.deliver(TrackerEvent.SERVER_DATA,e)}),this._client.on(TrackerEvent.SPREAD_DATA,async e=>{await this._eventHub.deliver(TrackerEvent.SPREAD_DATA,e)}),this._client.on(TrackerEvent.MESSAGE,async e=>{await this._eventHub.deliver(TrackerEvent.MESSAGE,e)}),this._client.on(TrackerEvent.ERROR,async e=>{await this._eventHub.deliver(TrackerEvent.ERROR,e)})}async _openEventHub(){await this._eventHub.connect(TrackerEvent.STATE),await this._eventHub.connect(TrackerEvent.CONNECTING),await this._eventHub.connect(TrackerEvent.CONNECTED),await this._eventHub.connect(TrackerEvent.DISCONNECTED),await this._eventHub.connect(TrackerEvent.TERMINATED),await this._eventHub.connect(TrackerEvent.SUBSCRIBING),await this._eventHub.connect(TrackerEvent.SUBSCRIBED),await this._eventHub.connect(TrackerEvent.UNSUBSCRIBED),await this._eventHub.connect(TrackerEvent.JOIN),await this._eventHub.connect(TrackerEvent.LEAVE),await this._eventHub.connect(TrackerEvent.SERVER_DATA),await this._eventHub.connect(TrackerEvent.SPREAD_DATA),await this._eventHub.connect(TrackerEvent.MESSAGE),await this._eventHub.connect(TrackerEvent.ERROR)}}exports.TrackerBroker=TrackerBroker;class TrackerBrokerInfo extends broker_1.AbstractBrokerInfo{constructor(){super(...arguments),this._peerID=settings_1.kernelSettings.client.peerID}get id(){return this._peerID}}exports.TrackerBrokerInfo=TrackerBrokerInfo;class TrackerClient extends emittery_1.default{constructor(e){super(),this._uri=e,this._state=new TrackerState,this._serverChannelID="#"+settings_1.kernelSettings.client.peerID,this._centrifuge=new centrifuge_1.Centrifuge(e,{websocket:websc_1.WebSocket,token:settings_1.kernelSettings.client.token,getToken:this._renewToken.bind(this),protocol:"protobuf",timeout:1e4,maxReconnectDelay:1e4,maxServerPingDelay:1e3}),this._bindCentrifuge()}get state(){return this._state}get serverChannelID(){return this._serverChannelID}async send(e){await this._centrifuge.publish(this._serverChannelID,buffer_1.Buffer.from(e)).catch(async e=>{throw e.code===constant_1.CentrifugeCode.SELF_TERMINATION&&(await this._state.toDestroyed(),await this.emit(TrackerEvent.TERMINATED)),e})}async open(){await this._centrifuge.connect()}async close(){await this._centrifuge.disconnect()}_bindCentrifuge(){this._centrifuge.on(CentrifugeEvent.STATE,async e=>{await this._onState(e)}),this._centrifuge.on(CentrifugeEvent.CONNECTING,async e=>{await this._onConnecting(e)}),this._centrifuge.on(CentrifugeEvent.CONNECTED,async e=>{await this._onConnected(e)}),this._centrifuge.on(CentrifugeEvent.DISCONNECTED,async e=>{await this._onDisconnected(e)}),this._centrifuge.on(CentrifugeEvent.SUBSCRIBING,async e=>{await this._onSubscribing(e)}),this._centrifuge.on(CentrifugeEvent.SUBSCRIBED,async e=>{await this._onSubscribed(e)}),this._centrifuge.on(CentrifugeEvent.UNSUBSCRIBED,async e=>{await this._onUnsubscribed(e)}),this._centrifuge.on(CentrifugeEvent.JOIN,async e=>{await this._onJoin(e)}),this._centrifuge.on(CentrifugeEvent.LEAVE,async e=>{await this._onLeave(e)}),this._centrifuge.on(CentrifugeEvent.PUBLICATION,async e=>{await this._onPublication(e)}),this._centrifuge.on(CentrifugeEvent.MESSAGE,async e=>{await this._onMessage(e)}),this._centrifuge.on(CentrifugeEvent.ERROR,async e=>{await this._onError(e)})}async _renewToken(){var e=await apis.TokenAPIRenewTokenHandler.process();return settings_1.kernelSettings.client.token=e.token,settings_1.kernelSettings.client.peerID=e.peerID,e.token}async _onState(e){await this.emit(TrackerEvent.STATE,e)}async _onConnecting(e){await this._state.toConnecting(),await this.emit(TrackerEvent.CONNECTING,e)}async _onConnected(e){await this.emit(TrackerEvent.CONNECTED,e)}async _onDisconnected(e){await this._state.toDestroyed(),await this.emit(TrackerEvent.DISCONNECTED,e),await this.emit(TrackerEvent.TERMINATED)}async _onSubscribing(e){await this.emit(TrackerEvent.SUBSCRIBING,e)}async _onSubscribed(e){e.channel===this._serverChannelID&&await this._state.toConnected(),await this.emit(TrackerEvent.SUBSCRIBED,e)}async _onUnsubscribed(e){await this.emit(TrackerEvent.UNSUBSCRIBED,e)}async _onJoin(e){await this.emit(TrackerEvent.JOIN,e)}async _onLeave(e){await this.emit(TrackerEvent.LEAVE,e)}async _onPublication(e){e.channel===this._serverChannelID?await this.emit(TrackerEvent.SERVER_DATA,e):await this.emit(TrackerEvent.SPREAD_DATA,e)}async _onMessage(e){await this.emit(TrackerEvent.MESSAGE,e)}async _onError(e){await this.emit(TrackerEvent.ERROR,e)}}class CentrifugeEvent{}CentrifugeEvent.STATE="state",CentrifugeEvent.CONNECTING="connecting",CentrifugeEvent.CONNECTED="connected",CentrifugeEvent.DISCONNECTED="disconnected",CentrifugeEvent.SUBSCRIBING="subscribing",CentrifugeEvent.SUBSCRIBED="subscribed",CentrifugeEvent.UNSUBSCRIBED="unsubscribed",CentrifugeEvent.JOIN="join",CentrifugeEvent.LEAVE="leave",CentrifugeEvent.PUBLICATION="publication",CentrifugeEvent.MESSAGE="message",CentrifugeEvent.ERROR="error";class TrackerEvent extends CentrifugeEvent{}(exports.TrackerEvent=TrackerEvent).TERMINATED="terminated",TrackerEvent.SERVER_DATA="server_data",TrackerEvent.SPREAD_DATA="spread_data";class TrackerState{constructor(){this._name=TrackerStateName.INITIAL}get isInitial(){return this._name===TrackerStateName.INITIAL}get isConnecting(){return this._name===TrackerStateName.CONNECTING}get isConnected(){return this._name===TrackerStateName.CONNECTED}get isDestroyed(){return this._name===TrackerStateName.DESTROYED}toInitial(){this._name=TrackerStateName.INITIAL}toConnecting(){this._name=TrackerStateName.CONNECTING}toConnected(){this._name=TrackerStateName.CONNECTED}toDestroyed(){this._name=TrackerStateName.DESTROYED}}class TrackerStateName{}TrackerStateName.INITIAL="initial",TrackerStateName.CONNECTING="connecting",TrackerStateName.CONNECTED="connected",TrackerStateName.DESTROYED="destroyed";