"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.TrackerDaemonTaskName=exports.TrackerDaemonEvent=exports.AbstractTrackerDaemon=void 0;const time_1=require("@mlytics/core-ts/core/tool/time"),error_1=require("@mlytics/core-ts/core/util/error"),future_1=require("@mlytics/core-ts/core/util/future"),logger_1=require("@mlytics/core-ts/core/util/logger"),buffer_1=require("@mlytics/core-ts/native/buffer"),settings_1=require("../../../../../core/config/settings"),code_1=require("../../../../../core/const/base/code"),message_1=require("../../../../../protocol/client/utility/message/message"),daemon_1=require("../../../base/daemon/daemon"),broker_1=require("../../broker/broker"),constant_1=require("./process/model/constant");class AbstractTrackerDaemon extends daemon_1.AbstractDaemon{constructor(){super(...arguments),this._feedbacks=new future_1.Channel}get broker(){return this._broker}_makeURI(){var e=settings_1.kernelSettings.server.tracker.fqdns;return`wss://${e[Math.floor(Math.random()*e.length)]}/centrifugo/connection/websocket`}async feedback(){return this._feedbacks.extract()}async _buildWaitToStartTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.WAIT_TO_START,sentinel:async()=>this._execWaitToStartTaskSentinel(),sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1,runningTimeout:10})}async _execWaitToStartTaskSentinel(){var e=await this._broker.eventHub.extract(broker_1.TrackerEvent.SUBSCRIBED);return await logger_1.Logger.track("Tracker subscribed event.",{context:e}),e.channel===this._broker.serverChannelID}async _buildListenStateEventTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.LISTEN_STATE_EVENT,callee:async()=>{await this._execListenStateEventTaskCallee()},sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenStateEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_1.TrackerEvent.STATE);await logger_1.Logger.track("Tracker state event.",{context:e})}async _buildListenConnectingEventTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.LISTEN_CONNECTING_EVENT,callee:async()=>{await this._execListenConnectingEventTaskCallee()},sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenConnectingEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_1.TrackerEvent.CONNECTING);await logger_1.Logger.track("Tracker connecting event.",{context:e})}async _buildListenConnectedEventTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.LISTEN_CONNECTED_EVENT,callee:async()=>{await this._execListenConnectedEventTaskCallee()},sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenConnectedEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_1.TrackerEvent.CONNECTED);await logger_1.Logger.track("Tracker connected event.",{context:e})}async _buildListenDisconnectedEventTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.LISTEN_DISCONNECTED_EVENT,callee:async()=>{await this._execListenDisconnectedEventTaskCallee()},sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenDisconnectedEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_1.TrackerEvent.DISCONNECTED);await logger_1.Logger.track("Tracker disconnected event.",{context:e})}async _buildListenTerminatedEventTask(){await this._taskManager.createCommonTask({name:TrackerDaemonTaskName.LISTEN_TERMINATED_EVENT,callee:async()=>{await this._execListenTerminatedEventTaskCallee()}})}async _execListenTerminatedEventTaskCallee(){throw await this._broker.eventHub.extract(broker_1.TrackerEvent.TERMINATED),TrackerDaemonError.BROKER_CLOSED}async _buildListenSubscribingEventTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.LISTEN_SUBSCRIBING_EVENT,callee:async()=>{await this._execListenSubscribingEventTaskCallee()},sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenSubscribingEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_1.TrackerEvent.SUBSCRIBING);await logger_1.Logger.track("Tracker subscribing event.",{context:e})}async _buildListenSubscribedEventTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.LISTEN_SUBSCRIBED_EVENT,callee:async()=>{await this._execListenSubscribedEventTaskCallee()},pretasks:[this._taskManager.cueTask(TrackerDaemonTaskName.WAIT_TO_START)],sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenSubscribedEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_1.TrackerEvent.SUBSCRIBED);await logger_1.Logger.track("Tracker subscribed event.",{context:e})}async _buildListenUnsubscribedEventTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.LISTEN_UNSUBSCRIBED_EVENT,callee:async()=>{await this._execListenUnsubscribedEventTaskCallee()},sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenUnsubscribedEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_1.TrackerEvent.UNSUBSCRIBED);await logger_1.Logger.track("Tracker unsubscribed event.",{context:e})}async _buildListenJoinEventTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.LISTEN_JOIN_EVENT,callee:async()=>{await this._execListenJoinEventTaskCallee()},sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenJoinEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_1.TrackerEvent.JOIN);await logger_1.Logger.track("Tracker join event.",{context:e})}async _buildListenLeaveEventTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.LISTEN_LEAVE_EVENT,callee:async()=>{await this._execListenLeaveEventTaskCallee()},sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenLeaveEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_1.TrackerEvent.LEAVE);await logger_1.Logger.track("Tracker leave event.",{context:e})}async _buildListenServerDataEventTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.LISTEN_SERVER_DATA_EVENT,callee:async()=>{await this._execListenServerDataEventTaskCallee()},pretasks:[this._taskManager.cueTask(TrackerDaemonTaskName.WAIT_TO_START)],sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenServerDataEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_1.TrackerEvent.SERVER_DATA),e=new message_1.ProtocolMessage(buffer_1.Buffer.from(e.data)),a=e.payload,r=this._broker.info.id,t=null==(t=a.header)?void 0:t.correlation_id;await logger_1.Logger.info("Tracker payload received.",{brokerID:r,payload:a}),t?await this._broker.messageHub.deliver(t,e):await this._broker.receiveChannel.deliver(e)}async _buildListenSpreadDataEventTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.LISTEN_SPREAD_DATA_EVENT,callee:async()=>{await this._execListenSpreadDataEventTaskCallee()},pretasks:[this._taskManager.cueTask(TrackerDaemonTaskName.WAIT_TO_START)],sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenSpreadDataEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_1.TrackerEvent.SPREAD_DATA);await logger_1.Logger.track("Tracker spread data event.",{context:e})}async _buildListenMessageEventTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.LISTEN_MESSAGE_EVENT,callee:async()=>{await this._execListenMessageEventTaskCallee()},pretasks:[this._taskManager.cueTask(TrackerDaemonTaskName.WAIT_TO_START)],sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenMessageEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_1.TrackerEvent.MESSAGE);await logger_1.Logger.track("Tracker message event.",{context:e})}async _buildListenErrorEventTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.LISTEN_ERROR_EVENT,callee:async()=>{await this._execListenErrorEventTaskCallee()},sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execListenErrorEventTaskCallee(){var e=await this._broker.eventHub.extract(broker_1.TrackerEvent.ERROR);await logger_1.Logger.warn("Tracker error event.",{context:e})}async _buildDeliverMessageTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.DELIVER_MESSAGE,callee:async()=>{await this._execDeliverMessageTaskCallee()},pretasks:[this._taskManager.cueTask(TrackerDaemonTaskName.WAIT_TO_START)],sleepSeconds:.02,sleepJitter:.5,maxErrorRetry:-1,maxTotalRetry:-1})}async _execDeliverMessageTaskCallee(){for(var e=await this._broker.deliverChannel.extract();this._broker.isActivated;){if(this._broker.isConnected)return void await this._broker.sendMessage(e);await time_1.TimeTool.sleepRandomly(.01)}}async _buildReceiveMessageTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.RECEIVE_MESSAGE,callee:async()=>{await this._execReceiveMessageTaskCallee()},pretasks:[this._taskManager.cueTask(TrackerDaemonTaskName.WAIT_TO_START)],sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execReceiveMessageTaskCallee(){var e=await this._broker.messageHub.lostCenter.extract();await this._broker.receiveChannel.deliver(e)}async _buildProcessMessageTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.PROCESS_MESSAGE,callee:async()=>{await this._execProcessMessageTaskCallee()},pretasks:[this._taskManager.cueTask(TrackerDaemonTaskName.WAIT_TO_START)],sleepSeconds:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execProcessMessageTaskCallee(){var e=await this._broker.receiveChannel.extract(),a=e.payload,r=this._agent.findPipeName(a.action);r?await this._agent.operate({name:r,data:{id:null==(r=a.header)?void 0:r.correlation_id,content:e}}):await this._feedbacks.deliver({content:e})}async _buildReportHealthTask(){await this._taskManager.createCyclicTask({name:TrackerDaemonTaskName.REPORT_HEALTH,callee:async()=>{await this._execReportHealthTaskCallee()},pretasks:[this._taskManager.cueTask(TrackerDaemonTaskName.ENABLE_PEER)],sleepFirst:!0,sleepSeconds:60,sleepJitter:0,maxErrorRetry:-1,maxTotalRetry:-1})}async _execReportHealthTaskCallee(){await this._agent.operate({name:constant_1.TrackerPipeName.LAUNCH_REPORT_HEALTH})}async _buildExitProcessTask(){await this._taskManager.createCommonTask({name:TrackerDaemonTaskName.EXIT_PROCESS,onClose:async()=>{await this._execExitProcessTaskOnClose()},pretasks:[...this._taskManager.cueAllTasks()],callbackTimeout:15})}async _execExitProcessTaskOnClose(){await this._broker.condition.deny(TrackerDaemonError.DAEMON_EXITED),await this._recordDisabled(),await this.emit(TrackerDaemonEvent.DISCONNECTED)}}exports.AbstractTrackerDaemon=AbstractTrackerDaemon;class TrackerDaemonEvent{}(exports.TrackerDaemonEvent=TrackerDaemonEvent).FEEDBACK="feedback",TrackerDaemonEvent.CONNECTED="connected",TrackerDaemonEvent.DISCONNECTED="disconnected";class TrackerDaemonTaskName{}(exports.TrackerDaemonTaskName=TrackerDaemonTaskName).WAIT_TO_START="tracker daemon: wait to start",TrackerDaemonTaskName.LISTEN_STATE_EVENT="tracker daemon: listen state event",TrackerDaemonTaskName.LISTEN_CONNECTING_EVENT="tracker daemon: listen connecting event",TrackerDaemonTaskName.LISTEN_CONNECTED_EVENT="tracker daemon: listen connected event",TrackerDaemonTaskName.LISTEN_DISCONNECTED_EVENT="tracker daemon: listen disconnected event",TrackerDaemonTaskName.LISTEN_TERMINATED_EVENT="tracker daemon: listen terminated event",TrackerDaemonTaskName.LISTEN_SUBSCRIBING_EVENT="tracker daemon: listen subscribing event",TrackerDaemonTaskName.LISTEN_SUBSCRIBED_EVENT="tracker daemon: listen subscribed event",TrackerDaemonTaskName.LISTEN_UNSUBSCRIBED_EVENT="tracker daemon: listen unsubscribed event",TrackerDaemonTaskName.LISTEN_JOIN_EVENT="tracker daemon: listen join event",TrackerDaemonTaskName.LISTEN_LEAVE_EVENT="tracker daemon: listen leave event",TrackerDaemonTaskName.LISTEN_SERVER_DATA_EVENT="tracker daemon: listen server data event",TrackerDaemonTaskName.LISTEN_SPREAD_DATA_EVENT="tracker daemon: listen spread data event",TrackerDaemonTaskName.LISTEN_MESSAGE_EVENT="tracker daemon: listen message event",TrackerDaemonTaskName.LISTEN_ERROR_EVENT="tracker daemon: listen error event",TrackerDaemonTaskName.DELIVER_MESSAGE="tracker daemon: deliver message",TrackerDaemonTaskName.RECEIVE_MESSAGE="tracker daemon: receive message",TrackerDaemonTaskName.PROCESS_MESSAGE="tracker daemon: process message",TrackerDaemonTaskName.ENABLE_PEER="tracker daemon: enable peer",TrackerDaemonTaskName.REPORT_HEALTH="tracker daemon: report health",TrackerDaemonTaskName.EXIT_PROCESS="tracker daemon: exit process";class TrackerDaemonError{}TrackerDaemonError.BROKER_CLOSED=new error_1.InternalError(code_1.MessageCode.ESS020),TrackerDaemonError.DAEMON_EXITED=new error_1.InternalError(code_1.MessageCode.ESS021);