"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.TrackerDaemon=void 0;const client_1=require("../../../../core/const/service/client"),collector_1=require("../../../../core/infra/metrics/collector"),broker_1=require("../broker/broker"),broker_2=require("../broker/state/broker"),daemon_1=require("./base/daemon"),agent_1=require("./base/process/agent/agent"),constant_1=require("./base/process/model/constant");class TrackerDaemon extends daemon_1.AbstractTrackerDaemon{constructor(){super(),this._initialize()}_initialize(){this._agent=new agent_1.TrackerAgent,this._broker=new broker_1.TrackerBroker(this._makeURI())}async _activate(){await this._broker.activate(),await this._taskManager.activate(),await this._storePool(),await this._buildTasks()}async _deactivate(){await this._broker.deactivate(),await this._taskManager.deactivate(),await this._feedbacks.close(),await this._clearPool()}async _storePool(){await broker_2.trackerBrokerPool.register(client_1.BrokerID.TRACKER,this._broker)}async _clearPool(){await broker_2.trackerBrokerPool.deregister(client_1.BrokerID.TRACKER)}async _buildTasks(){await this._buildWaitToStartTask(),await this._buildListenStateEventTask(),await this._buildListenConnectingEventTask(),await this._buildListenConnectedEventTask(),await this._buildListenDisconnectedEventTask(),await this._buildListenTerminatedEventTask(),await this._buildListenSubscribingEventTask(),await this._buildListenSubscribedEventTask(),await this._buildListenUnsubscribedEventTask(),await this._buildListenJoinEventTask(),await this._buildListenLeaveEventTask(),await this._buildListenServerDataEventTask(),await this._buildListenSpreadDataEventTask(),await this._buildListenMessageEventTask(),await this._buildListenErrorEventTask(),await this._buildDeliverMessageTask(),await this._buildReceiveMessageTask(),await this._buildProcessMessageTask(),await this._buildEnablePeerTask(),await this._buildReportHealthTask(),await this._buildExitProcessTask()}async _buildEnablePeerTask(){await this._taskManager.createCommonTask({name:daemon_1.TrackerDaemonTaskName.ENABLE_PEER,callee:async()=>{await this._execEnablePeerTaskCallee()},onFinish:async()=>{await this._execEnablePeerTaskOnFinish()},pretasks:[this._taskManager.cueTask(daemon_1.TrackerDaemonTaskName.WAIT_TO_START)],runningTimeout:5})}async _execEnablePeerTaskCallee(){await this._agent.operate({name:constant_1.TrackerPipeName.LAUNCH_ENABLE_USER})}async _execEnablePeerTaskOnFinish(){await this._broker.condition.pass(),await this._recordEnabled(),await this.emit(daemon_1.TrackerDaemonEvent.CONNECTED)}async _recordEnabled(){await collector_1.MetricsCollectorHolder.emit(collector_1.MetricsCollectorEvent.TRACKER_STATE_RECORD,{peerID:this._broker.info.peerID,isAvailable:!0})}async _recordDisabled(){await collector_1.MetricsCollectorHolder.emit(collector_1.MetricsCollectorEvent.TRACKER_STATE_RECORD,{peerID:null,isAvailable:!1})}}exports.TrackerDaemon=TrackerDaemon;