"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.DownloaderProxyName=exports.DownloaderAgent=void 0;const random_1=require("@mlytics/core-ts/core/tool/random"),backoff_1=require("@mlytics/core-ts/core/util/backoff"),error_1=require("@mlytics/core-ts/core/util/error"),logger_1=require("@mlytics/core-ts/core/util/logger"),queue_1=require("@mlytics/core-ts/core/util/queue"),watch_1=require("@mlytics/core-ts/core/util/watch"),flow_1=require("@mlytics/core-ts/utility/flow"),settings_1=require("../../../core/config/settings"),code_1=require("../../../core/const/base/code"),client_1=require("../../../core/const/service/client"),resource_1=require("../../../core/const/service/resource"),system_1=require("../../../core/const/service/system"),proxy_1=require("../../../core/service/filer/seeker/proxy"),math_1=require("../../../core/utility/math"),constant_1=require("../../client/peer/daemon/base/process/model/constant"),daemon_1=require("../../client/peer/daemon/state/daemon"),daemon_2=require("../../client/swarm/daemon/state/daemon"),constant_2=require("../model/constant");class DownloaderProxyName extends proxy_1.BaseDownloaderProxyName{}(exports.DownloaderProxyName=DownloaderProxyName).MCDN="mcdn",DownloaderProxyName.NODE="node",DownloaderProxyName.USER="user";class NodeDownloaderProxy extends proxy_1.AbstractDownloaderProxy{constructor(e){super(e),this._resource=e,this._noProgressCounter=new watch_1.Counter,this._backoff=new backoff_1.DelayBackoff({delayerClass:backoff_1.LinearDelayer,delayerOptions:{baseInterval:.1,multiplier:.3,maxInterval:1}})}async _setup(){await this._resetStates(),await this._fetchDaemon()}async _resetStates(){this._startSize=this._resource.size}async _fetchDaemon(){if(this._daemon=daemon_1.peerDaemonPool.retrieve(client_1.DaemonID.NODE),!this._daemon.broker.isAvailable)throw new error_1.InternalError(code_1.MessageCode.ESC020)}async _fetching(){await this._backoff.apply(async()=>{await this._startCommand(),await this._checkProgress()})}async _startCommand(){await this._daemon.command({id:flow_1.FlowID.make(),name:constant_1.NodePipeName.LAUNCH_OBTAIN_RESOURCE,content:this._resource}).catch(async e=>{var r=this._resource;await logger_1.Logger.debug("Node downloader proxy fetch failed.",{resource:r},{error:e})})}async _checkProgress(){if(this._isNoProgress?this._noProgressCounter.up():this._noProgressCounter.reset(),this._isToleranceReached)throw new error_1.InternalError(code_1.MessageCode.ESC021);this._canAccelerateFetchSpeed&&await this._backoff.reset()}get _increment(){return this._resource.size-this._startSize}get _isNoProgress(){return 0===this._increment}get _isToleranceReached(){return this._noProgressCounter.hasCountedUpTo(NodeDownloaderProxy.NO_PROGRESS_TOLERANCE)}get _canAccelerateFetchSpeed(){return this._increment>=resource_1.WebRTCConstant.DATACHANNEL_CHUNK_SIZE}async _abort(){}}NodeDownloaderProxy.NO_PROGRESS_TOLERANCE=5;class UserDownloaderProxy extends proxy_1.AbstractDownloaderProxy{constructor(e){super(e),this._resource=e,this._randomNumber=Math.random(),this._noQueueCounter=new watch_1.Counter,this._buildPossibility()}_buildPossibility(){var e=this._resource.priority,e=math_1.MathFunction.upwardExponentialCurve(e,.92103);this._possibility=e*settings_1.kernelSettings.download.maxP2PPossibility}async _setup(){await this._resetStates(),await this._checkStates(),await this._ensureDaemon()}async _resetStates(){this._startSize=this._resource.size}async _checkStates(){if(!this._resource.isShareable)throw new error_1.InternalError(code_1.MessageCode.ESC030);if(this._isUrgentResource)throw new error_1.InternalError(code_1.MessageCode.ESC031);if(this._isNotChosenThisTime)throw new error_1.InternalError(code_1.MessageCode.ESC032)}get _isUrgentResource(){return this._resource.priority<resource_1.ResourceConstant.URGENT_THRESHOLD_PRIORITY}get _isNotChosenThisTime(){return this._randomNumber>this._possibility}async _ensureDaemon(){this._daemon||(await this._ensureQueue(),await this._fetchDaemon())}async _ensureQueue(){this._shouldMakeQueue&&(await this._checkTolerance(),await this._buildDaemonQueue(),await this._checkDaemonQueue())}get _shouldMakeQueue(){return!this._daemons||this._isQueueEmpty}get _isQueueEmpty(){return 0===this._daemons.size}async _checkTolerance(){if(this._isToleranceReached)throw new error_1.InternalError(code_1.MessageCode.ESC034)}get _isToleranceReached(){return this._noQueueCounter.hasCountedUpTo(constant_2.FilerConstant.MAX_USER_DOWNLOADER_RETRY)}async _buildDaemonQueue(){var e=this._resource.swarmID,e=daemon_2.swarmDaemonPool.retrieve(e),r=new Array;for(const t of e.info.userManager.keys){var o=daemon_1.peerDaemonPool.retrieve(t);o&&this._isAvailableDaemon(o)&&await r.push(o)}this._daemons=queue_1.Queue.from(random_1.RandomTool.shuffle(r)),await this._noQueueCounter.up()}_isAvailableDaemon(e){e=e.broker.info.resourceStats.get(this._resource.id);return null!=e&&0<e}async _checkDaemonQueue(){if(this._isQueueEmpty)throw new error_1.InternalError(code_1.MessageCode.ESC033)}async _fetchDaemon(){this._daemon=this._daemons.pull()}async _fetching(){await this._startCommand(),await this._checkProgress()}async _startCommand(){await this._daemon.command({id:flow_1.FlowID.make(),name:constant_1.UserPipeName.LAUNCH_OBTAIN_RESOURCE,content:this._resource}).catch(async e=>{var r=this._resource;await logger_1.Logger.debug("User downloader proxy fetch failed.",{resource:r},{error:e})})}async _checkProgress(){this._isLowProgress?this._daemon=null:this._noQueueCounter.reset()}get _increment(){return this._resource.size-this._startSize}get _isLowProgress(){return this._increment<resource_1.WebRTCConstant.DATACHANNEL_CHUNK_SIZE}async _abort(){}}class DownloaderAgent extends proxy_1.AbstractDownloaderAgent{get _proxyNames(){var e=settings_1.kernelSettings.system.mode;return DownloaderAgent.PROXY_NAMES.get(e)}get _proxyClasses(){return DownloaderAgent.PROXY_CLASSES}}(exports.DownloaderAgent=DownloaderAgent).PROXY_NAMES=new Map([[system_1.SystemModeName.MCDN_ONLY,[DownloaderProxyName.MCDN]],[system_1.SystemModeName.P2P_MCDN,[DownloaderProxyName.USER,DownloaderProxyName.MCDN]],[system_1.SystemModeName.P2P_P2S,[DownloaderProxyName.USER,DownloaderProxyName.NODE]],[system_1.SystemModeName.P2S_ONLY,[DownloaderProxyName.NODE]]]),DownloaderAgent.PROXY_CLASSES=new Map([[DownloaderProxyName.MCDN,proxy_1.MCDNDownloaderProxy],[DownloaderProxyName.NODE,NodeDownloaderProxy],[DownloaderProxyName.USER,UserDownloaderProxy]]);