"use strict";var __importDefault=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.KernelValidator=exports.KernelConfigurator=void 0;const lodash_1=__importDefault(require("lodash")),zod_1=require("zod"),byte_1=require("@mlytics/core-ts/core/tool/byte"),time_1=require("@mlytics/core-ts/core/tool/time"),error_1=require("@mlytics/core-ts/core/util/error"),logger_1=require("@mlytics/core-ts/core/util/logger"),settings_1=require("../core/config/settings"),code_1=require("../core/const/base/code");class KernelConfigurator{constructor(e){this._options=e}config(){this._mergeOptions(),this._updateLogger(),this._updateClient(),this._updateMonitor()}_mergeOptions(){lodash_1.default.merge(settings_1.kernelSettings,this._options)}_updateLogger(){this._updateLoggerLevel()}_updateLoggerLevel(){var e=settings_1.kernelSettings.logger.level;logger_1.Logger.displayLevel=logger_1.LogLevelName[e.toUpperCase()]}_updateClient(){this._updateClientOrigin(),this._updateClientSessionID()}_updateClientOrigin(){void 0===settings_1.kernelSettings.client.origin&&(settings_1.kernelSettings.client.origin=""!==self.location.host?self.location.origin:null)}_updateClientSessionID(){void 0===settings_1.kernelSettings.client.sessionID&&(settings_1.kernelSettings.client.sessionID=SessionID.make())}_updateMonitor(){var e;null!=(null==(e=null==(e=this._options)?void 0:e.monitor)?void 0:e.sampleRate)&&(settings_1.kernelSettings.monitor.isEnabled=Math.random()<settings_1.kernelSettings.monitor.sampleRate)}static config(e){new KernelConfigurator(e).config()}}exports.KernelConfigurator=KernelConfigurator;class SessionID{static make(){return`session-${time_1.TimeTool.makeNowFstring(this.TIME_PART_FORMAT)}-`+byte_1.ByteTool.makeRandomBase36String(this.RANDOM_PART_LENGTH).toLowerCase()}}SessionID.TIME_PART_FORMAT="YYYYMMDDHHmmss",SessionID.RANDOM_PART_LENGTH=20;class KernelValidator{constructor(e){this._options=e,this._schema=zod_1.z.object({logger:zod_1.z.object({level:zod_1.z.enum(Object.keys(logger_1.LogLevelName))}).strict(),server:zod_1.z.object({host:zod_1.z.object({fqdn:zod_1.z.string().regex(/^(?:[0-9a-z](?:[0-9a-z-]{0,61}[0-9a-z])?\.)+[0-9a-z][0-9a-z-]{0,61}[0-9a-z]$/)}).strict()}).strict(),system:zod_1.z.object({isP2PAllowed:zod_1.z.boolean()}).strict(),stream:zod_1.z.object({maxBufferSize:zod_1.z.number().int().min(0),minBufferTime:zod_1.z.number().min(0),maxBufferTime:zod_1.z.number().min(0)}).strict(),swproxy:zod_1.z.object({scriptPath:zod_1.z.string().regex(/^(?:\/|\.\/|(?:\.\.\/)+)?(?:\.?[\w-]+\/)*\.?(?:[\w-]+\.)*[\w-]+$/),scriptScope:zod_1.z.string().regex(/^(?=\S+)(?:\/|\.\/|(?:\.\.\/)+)?(?:\.?[\w-]+\/)*(?:\.?[\w-]+\/?)?$/)}).strict(),monitor:zod_1.z.object({gtagTargetID:zod_1.z.string().regex(/^G-[0-9A-Z]{10}$/),sampleRate:zod_1.z.number().min(0).max(1)}).strict(),download:zod_1.z.object({maxCacheItems:zod_1.z.number().int().min(0),maxP2PPossibility:zod_1.z.number().min(0).max(1),httpResponseTimeout:zod_1.z.number().min(0)}).strict()}).strict().deepPartial().optional()}verify(){try{this._verify()}catch(e){throw logger_1.Logger.error("Kernel options verify failed.",void 0,{error:e}),e}}_verify(){try{this._schema.parse(this._options)}catch(e){throw new error_1.ValidationError(code_1.MessageCode.WSB010,e)}}static verify(e){new KernelValidator(e).verify()}}exports.KernelValidator=KernelValidator;